<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2021 GWE Systems Ltd, 2006-2008 JEvents Project Group
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */

defined( '_JEXEC' ) or die( 'Restricted Access' );

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;

jimport('joomla.application.component.controller');


class AdminRemindersController extends BaseController {

	/**
	 * Controller for Sessions
	 * @param array		configuration
	 * @since V2.0
	 */
	function __construct($config = array())
	{
		parent::__construct($config);
		$this->registerDefaultTask("record");
		$this->registerTask( 'record',  'recordReminder' );

		// Must load admin language files
		$lang = Factory::getLanguage();
		$lang->load("com_jevents", JPATH_ADMINISTRATOR);

		$this->dataModel = new JEventsDataModel();
		$this->queryModel = new JEventsDBModel($this->dataModel);

	}

}
