<?php

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

/**
 * @copyright	Copyright (C) 2011-2021 GWE Systems Ltd. All rights reserved.
 */
// Set flag that this is a parent file
define('_JEXEC', 1);

$x = realpath(dirname(__FILE__) . "/../../../../../");
if (!file_exists($x . "/plugins") && isset($_SERVER["SCRIPT_FILENAME"]))
{
	$x = dirname(dirname(dirname(dirname(dirname(dirname($_SERVER["SCRIPT_FILENAME"]))))));
}

define('JPATH_BASE', $x);

require_once (JPATH_BASE . '/includes/defines.php');
require_once (JPATH_BASE . '/includes/framework.php');

ini_set("display_errors", 1);

$mainframe = Factory::getApplication('site');
$mainframe->initialise();

$db = Factory::getDBO();
HTMLHelper::_('behavior.core', true);
$user = Factory::getUser();

$uri = JURI::getInstance();
$root = str_replace("/administrator/components/com_rsvppro/customfields/HbtgSeatSelector/", "", $uri->base());

$activeCol = 1;
$formfield = Factory::getApplication()->input->getCmd("field");
function displaySeat($activeCol)
{
	static $seats, $concessions, $special, $myseats;
	$id = "";
	$mainframe = Factory::getApplication();
	if (!isset($myseats))
	{

		// special  seat
		$seats = array();
		$concessions = array();
		// pre-reserved seats
		$special = array();

		$myseats = array();

		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest("com_rsvppro" . '.limitstart', 'limitstart', 0, 'int');

		$rp_id = Factory::getApplication()->input->getInt("rpid", 0);
		$at_id = Factory::getApplication()->input->getInt("at_id", 0);
		$atdee = Factory::getApplication()->input->getInt("atdee", 0);
		$formfield = str_replace("xmlfile_", "", Factory::getApplication()->input->getCmd("field"));

		$db = Factory::getDbo();
		$db->setQuery("select a.* from #__jev_attendance as a where a.id=" . intval($at_id));
		$rsvpdata = $db->loadObject();

		require_once(JPATH_SITE . "/components/com_jevents/jevents.defines.php");
		$datamodel = new JEventsDataModel();
		$repeat = $datamodel->queryModel->listEventsById($rp_id);

		if (!$repeat)
		{
			return;
		}

		// seats paid or unpaid for.
		$sql = "SELECT u.name, u.username, a.* FROM #__jev_attendees as a LEFT JOIN #__users as u on u.id=a.user_id WHERE (a.attendstate=1 OR a.attendstate=4) AND a.at_id=" . $rsvpdata->id;
		if (!$rsvpdata->allrepeats)
		{
			$sql .= " and a.rp_id=" . $row->rp_id();
		}
		$sql .= " ORDER BY a.created asc";

		$db->setQuery($sql);
		$attendees = $db->loadObjectList();

		static $rsvpParameters;
		if ($rsvpdata->template != "")
		{
			$xmlfile = JevTemplateHelper::getTemplate($rsvpdata);
			if (is_int($xmlfile) || file_exists($xmlfile))
			{
				if (!isset($rsvpParameters))
				{
					$rsvpParameters = new JevRsvpParameter("", $xmlfile, $rsvpdata, $repeat);
				}
			}
		}
		$fieldsets = $rsvpParameters->getFieldsets();
		$seatfield = $rsvpParameters->getField($formfield, "xmlfile");
		if (!$seatfield)
		{
			return;
		}

		$seatmapping = $seatfield->getSeatMapping();

		foreach ($attendees as $attendee)
		{
			$fielddata = json_decode($attendee->params);
			if (!isset($fielddata->$formfield))
			{
				continue;
			}

			foreach ($fielddata->$formfield as $field)
			{
				if (array_key_exists($field, $seatmapping))
				{
					if ($attendee->id == $atdee)
					{
						$myseats[] = $seatmapping[$field];
					}
					else
					{
						$seats[] = $seatmapping[$field];
					}
				}
			}
		}
	}

	$id .= $activeCol;
	$class = "available";
	$action = 'onclick="javascript:reserveSeat(this, false);return false;"';

	if (in_array($id, $seats) || in_array($id, $concessions) || in_array($id, $special) || in_array($id, $myseats))
	{
		$class = "reserved";
		if (!in_array($id, $myseats))
		{
			$action = "href='#null' onclick='return false;'";
			$class .= " nolink";
		}
		else
		{
			$class .= " myseat";
		}
	}
	?><li class="seat <?php echo $class; ?>" id="seat<?php echo $id; ?>"><a <?php echo $action; ?>  title="<?php echo $id; ?>" id="<?php echo $id; ?>a" ><?php echo $id; ?></a></li><?php
}
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
    <head>
        <title>Seat Planner</title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <!-- gwe //-->
        <script type="text/javascript" src="<?php echo $root; ?>/media/jui/js/jquery.js"></script>
        <style>
            /*** THEATRE SEAT PLANNER ****/
            .closebutton{background-color: #136DA2 !important;
                         border: medium none !important;
                         color: white !important;
                         font-family: arial !important;
                         float:right;
                         font-size: 14px !important;
                         font-weight: bold !important;
                         margin-bottom: 10px;
                         text-decoration:none;
                         padding: 5px 4px !important;
                         margin-top:12px;
            }
            .seatplanner a{
                color:#133478;
                cursor:pointer;
            }
	    .seatplanner ul {
		padding:0px;
		margin:0px 0px 2px 0px;
            }
            .seatplanner .seat a{
                text-align:center;
                color:white!important;
                text-decoration:none;
                font-size:9px;
                height:18px;
                padding:8px 0 0;
                display:block;
            }
	    .seatplanner  li {
		display:inline-block;
	    }
            .seatplanner  li.nolink a {
                cursor:default!important;
            }
            .seatplanner .seat{
                width:25px;
                height:26px;
                list-style:none;
                margin:0 1px 0 1px;
                padding:0px;
                text-align:center;
                color:white!important;
                font-size:9px;
            }
	    .seatplanner #legend li.seat {
		color:black!important;
	    }
            .seatplanner .available{
                background: url("/images/theatre/seat_available.jpg") no-repeat 0 0;
            }
            .seatplanner .available a:hover, 
            .seatplanner .available a:hover{
                color:#133478!important;
                cursor:pointer;
            }
            .seatplanner .available:hover, .seatplanner .available a:hover{
                background: url("/images/theatre/seat_reserve.jpg") no-repeat 0 0;
            }
            .seatplanner .reserve{
                background: url("/images/theatre/seat_reserve.jpg") no-repeat 0 0;
            }
            .seatplanner .reserve a, .seatplanner .reserve:hover a, .seatplanner .reserve a:hover{
                color:#133478!important;
                cursor:pointer;
            }
            .seatplanner .reserve_concession{
                background: url("/images/theatre/seat_reserve_concession.jpg") no-repeat 0 0;
            }
            .seatplanner .reserve_concession a, .seatplanner .reserve_concession:hover a,  .seatplanner .reserve_concession a:hover{
                color:white;
                cursor:pointer;
            }
            .seatplanner .reserved{
                background: url("/images/theatre/seat_reserved.jpg") no-repeat 0 0;
            }
            .seatplanner .reserved.myseat{
                background: url("/images/theatre/seat_reserve.jpg") no-repeat 0 0;
            }
            .seatplanner .reserved.myseat a{
                color:#133478 !important
            }
            .seatplanner .reserved:hover a, .seatplanner .reserved a:hover{
                color:white;
                cursor:pointer;
            }
            .seatplanner .disabled{
                background: url("/images/theatre/disabled_booking.jpg") no-repeat 0 0;
            }

	    .seatplanner div.row7, .seatplanner div.row8, .seatplanner div.row9, .seatplanner div.row10  {
		margin-left:177px;
	    }

	    .seatplanner div.row6 {
		margin-top:25px;
	    }

	    .seatplanner div.row5 ,.seatplanner div.row6  {
		margin-left:81px;
	    }

	    .seatplanner .block1, .seatplanner .block2, .seatplanner .block3 {
		display:inline-block;
	    }
	    .seatplanner .block2, .seatplanner .block3 {
		margin-left:238px;
	    }
	    .seatplanner div.row1 .block2, .seatplanner div.row1 .block3 {
		margin-left:0px;
	    }
	    .seatplanner  li#seat354, .seatplanner  li#seat370 , .seatplanner  li#seat386 ,
	    .seatplanner  li#seat250, .seatplanner  li#seat266 , .seatplanner  li#seat282
	    {
		margin-left:55px;
	    }


            /** END OF SEAT PLANNER */

        </style>
        <script type="text/javascript" >

                var selectedFields = {
                    fields: new Array(),
                    seatcount: 0,
                    seatnumber: new Array(),
                    formfield: false,
                    setupSeatNumbers: function (formfield) {
                        // reset the arrays !
                        selectedFields.seatnumber = new Array();
                        if (!this.formfield) {
                            this.formfield = formfield;
                        }

                        var registrations = jQuery('select.rsvp_' + this.formfield + ':not(".paramtmpl")', parent.document);
                        selectedFields.seattypes = jQuery('select.jevrhbtgseattype:not(".paramtmpl")', parent.document);

                        if (selectedFields.seattypes.length != registrations.length) {
                            alert("mismatch in seattypes.length and registrations.length = please report this problem " + selectedFields.seattypes.length + " vs " + registrations.length);
                            return;
                        }

                        for (var r = 0; r < registrations.length; r++) {
                            var registration = registrations[r];
                            if (registration.hasClass("paramtmpl")) {
                                continue;
                            }
                            // if selected no or maybe then clear the reservations
                            if ((jQuery('#jevattend_no', parent.document) && jQuery('#jevattend_no', parent.document).attr("checked"))
                                    || (jQuery('#jevattend_maybe', parent.document) && jQuery('#jevattend_maybe', parent.document).attr("checked"))) {
                                //this.clearReserved();
                            }

                            var seattype = selectedFields.seattypes[r];
                            seatcount = registration.id.replace(this.formfield + "_", "");
                            fieldname = this.formfield;
                            selectedFields.seatnumber.push({'fieldname': fieldname, 'seatcount': seatcount,'seatnumberspan':('#selectedseat'+seatcount),
                                'value': jQuery(registration).val(), 'text': jQuery(registration).find('option:selected').text(), 'reg': jQuery(registration),
                                'option': jQuery(registration).find('option:selected'), 'seattype': selectedFields.seattypes[r]});

                        }
                        ;

                    },
                    click: function (seatelem, initial) {
                        var matched = false;
                        // from the DOM we click on the link not the <li>
                        var seatId = (jQuery(seatelem).prop('nodeName').toUpperCase() == "A") ? jQuery(seatelem).parent().attr('id') : jQuery(seatelem).attr('id');

                        jQuery.each(selectedFields.fields, function (i, item) {
                            if (item.seatId != seatId)
                                return;
                            selectedFields.clickitem(item, seatId, initial);
                            matched = true;
                        });
                        if (!matched) {
                            var item = {'seatId': seatId, 'clicks': 0};
                            selectedFields.fields.push(item);
                            //selectedFields.seatnumber.push(item);
                            selectedFields.clickitem(item, seatId, initial);
                        }
                        ;
                    },
                    clearReserved: function (seatId, item) {
                        var $seat = jQuery('#' + seatId)
                        if (!$seat.length) {
                            alert(seatId + " can't be made unavailable");
                            return;
                        }
                        $seat.removeClass('myseat');
                        $seat.addClass('available');
                        $seat.removeClass('reserve_concession');
                        $seat.removeClass('reserved');
                        selectedFields.seatcount--;
                    },
                    setReserved: function (seatId, item) {
                        var $seat = jQuery('#' + seatId)
                        if (!$seat.length) {
                            alert(seatId + " can't be made available");
                            return;
                        }
                        $seat.addClass('myseat');
                        $seat.removeClass('available');
                        $seat.removeClass('reserve_concession');
                        $seat.addClass('reserved');
                        $seat.removeClass('disabled');
                        selectedFields.seatcount++;
                    },
                    setConcession: function (seatId, item) {
                        var $seat = jQuery('#' + seatId)
                        if (!$seat.length) {
                            alert(seatId + " can't be made into a concession");
                            return;
                        }
                        $seat.addClass('myseat');
                        $seat.removeClass('available');
                        $seat.addClass('reserve_concession');
                        $seat.removeClass('reserved');
                        $seat.removeClass('disabled');
                    },
                    clickitem: function (item, seatId, initial) {
                        item.clicks++;
                        var $seat = jQuery('#' + seatId)
                        if (item.clicks == 1) {
                            selectedFields.setReserved(seatId, item);
                            //	selectedFields.seatnumber[selectedFields.seatcount].each(function(el){el.val( seatId)});
                            //selectedFields.concessionseatnumber[selectedFields.seatcount].each(function(el){el.val( '')});
                        } else if (item.clicks == 2) {
                            selectedFields.setConcession(seatId, item);
                        } else {
                            selectedFields.clearReserved(seatId, item);
                            item.clicks = 0;
                        }
                        if (selectedFields.seatnumber.length < selectedFields.seatcount && selectedFields.seatnumber.length > 0) {
                            // do not use parent window method - we don't want to scroll into view !
                            //window.parent.addGuest(0);
                            this.addGuest(0);
                        } else if (selectedFields.seatnumber.length > selectedFields.seatcount && selectedFields.seatnumber.length > 1) {
                            // in initial setup we don't clear the tabs and their values'
                            if (!initial) {
                                var registrations = jQuery('select.rsvp_' + this.formfield, parent.document);
                                for (var r = 0; r < registrations.length; r++) {
                                    var registration = registrations[r];
                                    if (registration.hasClass("paramtmpl")) {
                                        continue;
                                    }
                                    for (var sn = 0; sn < selectedFields.seatnumber.length; sn++) {
                                        if (selectedFields.seatnumber[sn].val() == registration.val()) {
                                            if (selectedFields.seatnumber[sn].seatcount > 0) {
                                                window.parent.regTabs.activate(window.parent.regTabs.titles[seatcount]);
                                                this.removeGuest(0);
                                                item.removed = true;
                                            }
                                        }
                                    }
                                }
                                //this.removeGuest(0);
                            }
                        }
                        selectedFields.setupSeatNumbers();
                        if (initial) {
                            // in initial setup we don't clear the tabs and their values'
                            return;
                        }
                        // now propagate the values
                        var ticketcount = 0;

                        jQuery.each(selectedFields.fields, function (i, item) {
                            if (item.clicks == 0 || item.clicks > 2) {
                                if (item.removed) {
                                    return;
                                }
                                jQuery(selectedFields.seatnumber[ticketcount].reg).val(0);
                                jQuery(selectedFields.seattypes[ticketcount]).val(0);				
				jQuery(selectedFields.seatnumber[ticketcount].seatnumberspan, parent.document).html('');
                                ticketcount++;
                            } else if (item.clicks == 1) {
                                jQuery(selectedFields.seatnumber[ticketcount].reg).val(0);
                                // find the select option with text to match seatId
                                var toMatch = item.seatId.replace("seat","");
                                jQuery(selectedFields.seatnumber[ticketcount].reg).val(toMatch);
				jQuery(selectedFields.seatnumber[ticketcount].seatnumberspan, parent.document).html(toMatch);
                                jQuery(selectedFields.seattypes[ticketcount]).val(1);
                                ticketcount++;
                            } else if (item.clicks == 2) {
                                jQuery(selectedFields.seatnumber[ticketcount].reg).val(0);
                                // find the select option with text to match seatId
                                var toMatch = item.seatId.replace("seat","");
                                jQuery(selectedFields.seatnumber[ticketcount].reg).val(toMatch);
				jQuery(selectedFields.seatnumber[ticketcount].seatnumberspan, parent.document).html(toMatch);
                                jQuery(selectedFields.seattypes[ticketcount]).val(2);
                                ticketcount++;
                            } else {
                            }
                        });

                        window.parent.JevrFees.calculate(window.parent.document.updateattendance);
                    },
                    addGuest: function (limit) {
                        // update the guest count
                        // Do not change this to remove +1 without changing call to addStates
                        jQuery('#guestcount', parent.document).val(parseInt(jQuery('#guestcount', parent.document).val()) + 1);
                        jQuery('#lastguest', parent.document).val(parseInt(jQuery('#lastguest', parent.document).val()) + 1);
                        var title = jQuery("#jevnexttabtitle", parent.document).val();
                        title = title.replace('xxx', jQuery('#lastguest', parent.document).val());
                        // Skip the scroll!
                        window.parent.regTabs.addTab(title, title, jQuery('#lastguest', parent.document).val(), true);

                        // Watch this count is 1 less than the label on the tab!
                        // call before the fees since the bisibility affect the calculation
                        window.parent.JevrConditionFieldState.addStates(jQuery('#lastguest', parent.document).val() - 1);
                        // recalculate the fees!
                        window.parent.JevrFees.calculate(window.parent.document.updateattendance);

                        if (limit > 0 && jQuery('#guestcount', parent.document).val() >= limit) {
                            if (jQuery('#addguest', parent.document))
                                jQuery('#addguest', parent.document).style.display = "none";
                        }
                    },
                    removeGuest: function (limit) {
                        // update the guest count
                        jQuery('#guestcount'.parent.document).val(parseInt(jQuery('#guestcount', parent.document).val()) - 1);
                        window.parent.regTabs.removeActiveTab();
                        // recalculate the fees!
                        window.parent.JevrFees.calculate(window.parent.document.updateattendance);
                        if (limit > 0 && jQuery('#guestcount', parent.document).val() < limit) {
                            if (jQuery('#addguest', parent.document))
                                jQuery('#addguest', parent.document).style.display = "block";
                        }
                    }
                };
                function reserveSeat(seatelem, initial) {
                    selectedFields.click(seatelem, initial);
                }
                jQuery(window).on("load", function () {
                    selectedFields.setupSeatNumbers('<?php echo $formfield; ?>');

                    for (var s = 0; s < selectedFields.seatnumber.length; s++) {
                        var seatitem = selectedFields.seatnumber[s];
                        if (seatitem.value != "" && seatitem.value != "0" && seatitem.value != undefined) {
                            reserveSeat(jQuery('#seat' + seatitem.text), true);
                            // concession type field
                            if (jQuery(seatitem.seattype).prop("selectedIndex") == 2) {
                                reserveSeat(jQuery('#seat' + seatitem.text), true);
                            }
                        }
                    }
                });
        </script>
    </head>
    <body>
        <div class="seatplanner" style="margin-left: 17px; width: 710px; position: fixed; height: 50px; overflow: auto;">
            <ul id="legend" style="list-style: none outside none; padding: 0pt; margin-left: 10px;">
                <li class="seat available" style="margin: 0px; float: left; width: 160px; color: black; font-size: 14px; padding-top: 6px;">Seat Available</li>
                <li style="margin: 0px; float: left; width: 170px; color: black; font-size: 14px; padding-top: 6px;" class="seat reserved">Seat Reserved</li>
                <li style="margin: 0px; float: left; width: 145px; color: black; font-size: 14px; padding-top: 6px;" class="seat reserve">My Seat</li>
                <li style="margin: 0px; float: left; width: 210px; color: black; font-size: 14px; padding-top: 6px;" class="seat reserve_concession">My Concession Seat</li>
            </ul>
        </div>
	<div class="placeholder" style="height:50px;"></div>
        <div class="seatplanner" style="margin-left: 17px; width: 2390px; height: 332px; position: relative;">
	    <div class="upper">
		<div  class="row10">
		    <ul class="row10">
			<?php
			for ($s = 489; $s >= 415; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row9">
		    <ul class="row9">
			<?php
			for ($s = 564; $s >= 490; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row8">
		    <ul class="row8">
			<?php
			for ($s = 639; $s >= 565; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row7">
		    <ul class="row7">
			<?php
			for ($s = 714; $s >= 640; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row6">
		    <ul class="block1 row6">

			<?php
			for ($s = 324; $s >= 310; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block2 row6">

			<?php
			for ($s = 34; $s >= 1; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block3 row6">

			<?php
			for ($s = 205; $s <= 219; $s++)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row5">
		    <ul class="block1 row5">

			<?php
			for ($s = 339; $s >= 325; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block2 row5">

			<?php
			for ($s = 68; $s >= 35; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block3 row5">

			<?php
			for ($s = 220; $s <= 234; $s++)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row4">
		    <ul class="block1 row4">

			<?php
			for ($s = 355; $s >= 340; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block2 row4">

			<?php
			for ($s = 102; $s >= 69; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block3 row4">

			<?php
			for ($s = 235; $s <= 250; $s++)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row3">
		    <ul class="block1 row3">

			<?php
			for ($s = 371; $s >= 356; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block2 row3">

			<?php
			for ($s = 136; $s >= 103; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block3 row3">

			<?php
			for ($s = 251; $s <= 266; $s++)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row2">
		    <ul class="block1 row2">

			<?php
			for ($s = 387; $s >= 372; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block2 row2">

			<?php
			for ($s = 170; $s >= 137; $s--)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		    <ul class="block3 row2">

			<?php
			for ($s = 267; $s <= 282; $s++)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
		<div  class="row1">
		    <ul class=" row1">
			<?php
			for ($s = 414; $s >= 388; $s--)
			{
				echo displaySeat($s);
			}
			for ($s = 204; $s >= 171; $s--)
			{
				echo displaySeat($s);
			}
			for ($s = 283; $s <= 309; $s++)
			{
				echo displaySeat($s);
			}
			?>
		    </ul>
		</div>
	    </div>
        </div>
        <!-- Adam's bit -->
        <div class="seatplanner" style="margin-left: 17px; width: 710px; position: fixed; height: 50px; overflow: auto;">
            <a href="javascript:window.parent.jQuery('#seatSelectModal').modal('toggle');" class="closebutton" title="close">Continue to booking...</a>
        </div>

    </body>
</html>
