<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2015 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

include_once(JPATH_ADMINISTRATOR ."/components/com_rsvppro/customfields/JevrFieldDogList.php");
$language = JFactory::getLanguage();
$language->load('com_rsvppro', JPATH_ADMINISTRATOR);


class JFormFieldJevrdoglist extends JevrFieldDogList
{

	/**
	 * Element name
	 *
	 * @access	protectedf
	 * @var		string
	 */
	var $_name = 'jevrdoglist';
	const name = 'jevrdoglist';
	
	static function isEnabled()
	{
		return is_dir(JPATH_SITE . '/components/com_jsn') && is_dir(JPATH_ADMINISTRATOR . '/components/com_jsn');

	}
	
	public static function loadScript($field=false)
	{
		$comparams = JComponentHelper::getParams("com_rsvppro");		
				
		JHtml::script('administrator/components/' . RSVP_COM_COMPONENT . '/customfields/js/jevrdoglist.js');

		if ($field)
		{
			$id = 'field' . $field->field_id;
		}
		else
		{
			$id = '###';
		}
		ob_start();
		?>
		<div class='rsvpfieldinput'>

			<div class="gsl-form-label"><?php echo JText::_("RSVP_FIELD_TYPE"); ?></div>
			<div class="gsl-form-controls gsl-form-small" style="font-weight:bold;"><?php echo JText::_("RSVP_TEMPLATE_TYPE_jevrdoglist"); ?><?php RsvpHelper::fieldId($id); ?></div>
			<div class="rsvpclear"></div>

			<?php
			RsvpHelper::hidden($id, $field, self::name);
			RsvpHelper::label($id, $field, self::name);
			RsvpHelper::tooltip($id, $field);
			?>

			
			<div class="rsvpclear"></div>

			<?php
			RsvpHelper::required($id, $field);
			RsvpHelper::requiredMessage($id, $field);
			RsvpHelper::conditional($id, $field);
			RsvpHelper::peruser($id, $field);
			RsvpHelper::formonly($id, $field);
			RsvpHelper::showinform($id, $field);
			RsvpHelper::showindetail($id, $field);
			RsvpHelper::showinlist($id, $field);
			RsvpHelper::showinticket($id, $field);
			RsvpHelper::allowoverride($id, $field);
			RsvpHelper::accessOptions($id, $field);
			RsvpHelper::applicableCategories("facc[$id]", "facs[$id]", $id, $field ? $field->applicablecategories : "all");
			?>

			<div class="rsvpclear"></div>

		</div>
		<div class='rsvpfieldpreview' id='<?php echo $id; ?>preview'>
			<div class="previewlabel"><?php echo JText::_("RSVP_PREVIEW"); ?></div>
			<div class="gsl-form-label rsvppl" id='pl<?php echo $id; ?>' ><?php echo $field ? $field->label : JText::_("RSVP_FIELD_LABEL"); ?></div>

		</div>
		<div class="rsvpclear"></div>
		<?php
		$html = ob_get_clean();

		return RsvpHelper::setField($id, $field, $html, self::name);

	}

	function getInput()
	{
		
		if (!$this->isEnabled()){
			return;
		}
		
		require_once(JPATH_SITE.'/components/com_jsn/helpers/helper.php');
		
		$name = $this->name;
		$fieldname = $this->fieldname;
		$id = $this->id;
		$value = $this->value;
		
		$attribs = ( $this->attribute('class') ? 'class="' . $this->attribute('class'). ' xxx"' : 'class="inputbox xxx"' );
		$comparams = JComponentHelper::getParams("com_rsvppro");

		$html = "";
		$htmloption = "";
		$options = array();
		$newoption = array();
		
		//$user=JsnHelper::getUser(); 
		
		if (JRequest::getCmd("task")=="attendees.edit" && isset($this->attendee) && $this->attendee->user_id>0 && $this->attendee->user_id != $user->getField("id")) {
			$jsnUser = $this->attendee->user_id;
			$user=JsnHelper::getUser($jsnUser);		
		}
		elseif (JRequest::getCmd("task")=="attendees.edit" && isset($this->attendee) && $this->attendee->id>0 && $this->attendee->user_id==0) {
			$user->id = 0;
		}
		
		$showinform = $this->attribute("showinform");

		$fieldname = $this->attribute("fieldname");
		$userid="";
		
		if (!$this->isEnabled()){
			$showinform = false;
		}

		if ($showinform){
			if (is_null($value) || $value == "" || $value == "0" || $value == 0)
			{
				$user=JsnHelper::getUser(); 
				if (isset($this->attendee) && isset($this->attendee->user_id) && $this->attendee->user_id > 0)
				{
					$userid = $this->attendee->user_id;
				}
				else if ($user->id == 0)
					return "";
				else {
					if (JRequest::getCmd("task")=="attendees.edit" && isset($this->attendee) && $this->attendee->user_id == 0) {
						return "";
					}
					else {
						$userid = $user->id;
					}
				}
			}
			else
			{
				$splitValue = explode("_", $value);
				$userid = $splitValue[0];
			}
			$user=JsnHelper::getUser($userid);

			$db = JFactory::getDbo();
			$db->setQuery(
				'SELECT a.id, a.alias FROM #__jsn_fields AS a WHERE ((a.alias = "your_dog") OR (a.alias = "2nd_dog") OR (a.alias = "3rd_dog") OR (a.alias = "4th_dog")) ORDER BY a.lft');
			
			$parents = $db->loadObjectList();
			
			$fldtitle = array();
			$currentdog = array();
			$doginfo = array();
			$display = 'none';
			$addhtml = "";
			$text = "";
			$val = "";
			$html .= '<script type="text/javascript">
						function dogInfo(id) {

							var e = document.getElementById(id);

							var dog = e.options[e.selectedIndex].value;

							b = document.getElementsByClassName("doginfo");
							
							for (j=0;j<b.length;j++){
								b[j].style.display = "none";
							}
							document.getElementById(dog).style.display = "block";	
						}
						
					 </script>';
							
							
			$v = 1;
			
			$options[] = $htmloption;
			foreach ($parents as $parent)
			{
			
				if ($parent->alias == 'your_dog'){
					$dognm = 'dog_s_name';
					$add = 'add_dog';
				}
				else {
					$x = substr($parent->alias, 0, 1);
					$dognm = 'dog_s_name'.$x;
					$add = 'add_dog'.$x;
				}
				
				$pub = '1';
				
				$db->setQuery(
					'SELECT '.$dognm.' FROM #__jsn_users WHERE id = "'.$user->id.'"');
				$result = $db->loadResult();
				
				if ($result != "") {	
				
					$db->setQuery(
						'SELECT COUNT(a.alias) FROM #__jsn_fields AS a WHERE a.parent_id = "'.$parent->id.'"');
					$cnt = $db->loadResult();
					
					$db->setQuery(
						'SELECT a.alias, a.title FROM #__jsn_fields AS a WHERE a.parent_id = "'.$parent->id.'" AND a.alias != "'.$add.'" ORDER BY a.lft ASC');	
					$fields = $db->loadObjectList();
					$selectfld = "";
					
					foreach ($fields as $field)
					{
				
						if ($cnt >= 3)
						{
							$fieldnm = 'b.'.$field->alias.', ';
		
						}
						elseif($cnt == 2) 
						{
							$fieldnm = 'b.'.$field->alias.' ';
						}
						else
						{
							$fieldnm = '';
						}
						$selectfld .= $fieldnm;
						$fldtitle[$field->alias] = $field->title;
						$cnt--;
					}
					
					
					$query = 'SELECT '.$selectfld.' FROM #__jsn_users AS b WHERE b.id = "'.$user->id.'" AND ((b.'.$dognm.' != "") OR (b.'.$dognm.' IS NOT NULL))';
			
					$db->setQuery($query);
					$eachdog = $db->loadObject();
			
					$currentdog = (array) $eachdog;
			
					$chkobj = count($currentdog);
			
					if ($chkobj != 0) {
						$val = $user->id.'_'.$parent->id;
						$text = $eachdog->$dognm;
						
						$newoption[$text] = $val;
					
						$htmloption = JHtml::_('select.option', $val, $text);
						$options[] = $htmloption;
						$currentdog = (array) $eachdog;
						//$doginfoid = $parent->alias;
						
						$addhtml = '<div id="'.$val.'" class="doginfo" style="display:'.$display.'">';
						while ($key = key($currentdog))
						{ 
							$addhtml .= '<div class="dogfield '.$key.'">';
							$addhtml .= '<span><label>'.$fldtitle[$key].'</label></span> ';
							$addhtml .= '<span>'.$user->getField($key).'</span>';
							$addhtml .= '</div>'; 
							next($currentdog);
						};
						$addhtml .= '</div>';
					
						$doginfo[] = $addhtml;
					}
				}
				$v++;
			}
			
			if ($this->attribute("peruser") == 1 || $this->attribute("peruser") == 2){
				
				$this->fixValue($value, $this);
	
				$elementname =  $name . '[]';
				$i = 0;
				
				foreach ($value as $val)
				{
					
					if ($i == 0)
					{
						
						if ($this->attribute("peruser") == 2)
						{
							$thisclass = str_replace(" xxx", " disabledfirstparam rsvpparam rsvpparam0 rsvp_$fieldname rsvp_xmlfile_$fieldname", $attribs);
						}
						else
						{
							$thisclass = str_replace(" xxx", " rsvpparam rsvpparam0 rsvp_$fieldname rsvp_xmlfile_$fieldname", $attribs);
						}
					}
					else
					{
						$thisclass = str_replace(" xxx", " rsvpparam rsvpparam$i  rsvp_$fieldname rsvp_xmlfile_$fieldname", $attribs);
					}
					
					$thisclass .= " id = 'rsvp_" . $fieldname . "_span_$i' ";
					
					$thisclass .= " onchange = dogInfo('".$id. "_$i') ";
					
					if ((is_null($val)||($val == "")) && (count($newoption) == 1)) {
					$val = $newoption[$text];
					}
					
					$html .= JHtml::_('jevrDogList.genericlist', $options, $elementname, $thisclass, 'value', 'text', $val, $id. "_" . $i);
					
					
					if (($val == "") || (count($options) == 0)) {
						$val = "";
					}
					
					/*foreach ($doginfo as $info)
					{	
						$html .= $info;
					}*/
					$i++;
				}

				$val = "";
				$val = "#%^£xx£^%#";
				$thisclass = str_replace(" xxx", " paramtmpl rsvp_$fieldname rsvp_xmlfile_$fieldname", $attribs);
				$thisclass .= " id = 'rsvp_" . $fieldname . "_span_xxxyyyzzz' ";
				
				$thisclass .= " onchange = dogInfo('".$id. "_xxxyyyzzz') ";
				
				$html .= JHtml::_('jevrList.genericlist', $options, "paramtmpl_" . $elementname, $thisclass, 'value', 'text', $val, $id . "_xxx");
				
				foreach ($doginfo as $info)
				{	
					$html .= $info;
				}
			}
				
			else{
					
				$thisclass = str_replace(" xxx", " rsvpparam rsvpparam0 rsvp_$fieldname rsvp_xmlfile_$fieldname", $attribs);
				// per user is 0 so don't put a guest number on the element!
				$thisclass .= " id = 'rsvp_" . $fieldname . "_span_' ";
				$thisclass .= " onchange = dogInfo('".$id."') ";
				if ((is_null($value)||($value == "")) && (count($newoption) == 1)) {
					$value = $newoption[$text];
				}
				
				$html .= JHtml::_('jevrDogList.genericlist', $options, '' . $name, $thisclass, 'value', 'text', $value, $id);
				
				
				if (($value == "") || (count($options) == 0)) {
					$value = "";
				}
				
				foreach ($doginfo as $info)
				{	
					$html .= $info;
				}
			}
			return $html;
		}
		
	}


	/*
	  function toXML($field)
	  {
	  $result = array();
	  $result[] = "<field ";
	  foreach (get_object_vars($field) as $k => $v)
	  {
	  if ($k == "options" || $k == "html" || $k == "defaultvalue" || $k == "name")
	  continue;
	  if ($k == "field_id")
	  {
	  $k = "name";
	  $v = "field" . $v;
	  $result[] = $k . '="' . addslashes($v) . '" ';
	  }
	  else if ($k == "params")
	  {
	  if (is_string($field->params))
	  {
	  $field->params = @json_decode($field->params);
	  }
	  if (is_object($field->params))
	  {
	  foreach (get_object_vars($field->params) as $label=>$value)
	  {
	  $result[] = $label . '="' . addslashes($value) . '" ';
	  }
	  }
	  }
	  else {
	  $result[] = $k . '="' . addslashes($v) . '" ';
	  }
	  }
	  $result[] = " />";
	  $xml = implode(" ", $result);
	  return $xml;

	  }
	 */
	 
	 public function convertValue($value)
	{
				
		if (!$this->isEnabled()){
			return "";
		}

		require_once(JPATH_SITE.'/components/com_jsn/helpers/helper.php');
		
		$fieldname = $this->attribute("fieldname");
		$attendeeUserId = 0;
		if (isset($this->attendee) && isset($this->attendee->user_id) && $this->attendee->user_id > 0)
		{
			$attendeeUserId = $this->attendee->user_id;
		}

		$html = "";
		if (is_null($value) || $value == "" || $value == "0")
		{
			$jsnUser=JsnHelper::getUser();
			if (isset($this->attendee) && isset($this->attendee->user_id) && $this->attendee->user_id > 0)
			{
				$attendeeUserId = $user = $this->attendee->user_id;
			}
			else if ($jsnUser->id == 0)
				return "";
			else {
				if (JRequest::getCmd("task")=="attendees.edit" && isset($this->attendee) && $this->attendee->user_id == 0) {
					return "";
				}
				else {
					$user = $jsnUser->id;
				}
			}
		}
		
			
			$splitValue = explode("_", $value);
			
			$user = $splitValue[0];
			$jsnUser = JsnHelper::getUser($user);
			$dog = $splitValue[1];
	
			$db = JFactory::getDbo();
			$db->setQuery(
			'SELECT a.alias FROM #__jsn_fields AS a WHERE a.id = '.$dog);
			$dogalias = $db->loadResult();
	
			if ($dogalias == 'your_dog'){
				$dognm = 'dog_s_name';
				$add = 'add_dog';
			}
			else {
				$x = substr($dogalias, 0, 1);
				$dognm = 'dog_s_name'.$x;
				$add = 'add_dog'.$x;
			}
		
			$pub = '1';
		
			$db->setQuery(
				'SELECT COUNT(a.alias) FROM #__jsn_fields AS a WHERE a.parent_id = "'.$dog.'"');
			$cnt = $db->loadResult();
				
			$db->setQuery(
				'SELECT a.alias, a.title FROM #__jsn_fields AS a WHERE a.parent_id = "'.$dog.'" AND a.alias != "'.$add.'" ORDER BY a.lft ASC');	
			$fields = $db->loadObjectList();
			$selectfld = "";
				
			foreach ($fields as $field)
			{
			
				if ($cnt >= 3)
				{
					$fieldnm = 'b.'.$field->alias.', ';

				}
				elseif($cnt == 2) 
				{
					$fieldnm = 'b.'.$field->alias.' ';
				}
				else
				{
					$fieldnm = '';
				}
				$selectfld .= $fieldnm;
				$fldtitle[$field->alias] = $field->title;
				$cnt--;
			}
			
			$query = 'SELECT '.$selectfld.' FROM #__jsn_users AS b WHERE b.id = "'.$user.'" AND ((b.'.$dognm.' != "") OR (b.'.$dognm.' IS NOT NULL))';
	
			$db->setQuery($query);
			$eachdog = $db->loadObject();
			
			$currentdog = (array) $eachdog;
			
			$chkobj = count($currentdog);
			
			if ($chkobj != 0) {
				
				while (list($key, $val) = each($currentdog))
				{ 
					if ($key != 'vaccinations'){
						if ($chkobj >= 2)
						{
							$html .= '<span><strong>'.$fldtitle[$key].'</strong> =</span> ';
							$html .= '<span>'.$jsnUser->getField($key).',</span> ';
						}
						else
						{
							$html .= '<span><strong>'.$fldtitle[$key].'</strong> =</span> ';
							$html .= '<span>'.$jsnUser->getField($key).'</span>';
						
						}
					}
					else
					{
						$html .= "";
					}
					$chkobj--;
				}
			}
		
		if (JRequest::getCmd("task")=="attendees.export"){
			// there is a HTML error in some CB fields so missmatched tags and cannot use strip_tags
			//$value =  strip_tags($html);
			$search = array('@<*?[^<>]*?>@si');
			$value = preg_replace($search, '', $html); 			
			return $value;
		}
		
		if (!isset($this->attendee->guestcount)){
			$this->attendee->guestcount=1;
		}

		 /*if ($this->attribute("peruser")==1 && $this->attendee->guestcount>0){
			return array_fill(0, $this->attendee->guestcount, $html);
		}
		else if ($this->attribute("peruser")==2 && $this->attendee->guestcount>0){
			$return = array_fill(0, $this->attendee->guestcount, $html);
			//$return[0]="";
			return $return;
		} */
		return $html;

	}
	function currentAttendeeCount($node, $value)
	{
		if (is_array($value) && count($value) > 1)
		{
			return count($value) - 1;
		}
		return 1;

	}

}

class JHTMLJevrDogList
{

	/**
	 * Generates an HTML select list
	 *
	 * @field	array	An array of objects
	 * @field	string	The value of the HTML name attribute
	 * @field	string	Additional HTML attributes for the <select> tag
	 * @field	string	The name of the object variable for the option value
	 * @field	string	The name of the object variable for the option text
	 * @field	mixed	The key that is selected (accepts an array or a string)
	 * @returns	string	HTML for the select list
	 */
	static function genericlist($arr, $name, $attribs = null, $key = 'value', $text = 'text', $selected = NULL, $idtag = false, $translate = false)
	{
		/*
		  // see checklist code if I am to allow multi-selects
		  // field selection is by index not by value - take care here!
		  if ($selected && (strpos($selected, "[")===0 || strpos($selected, "{")===0)){
		  $selectedvalues = json_decode($selected);
		  $selected = array();
		  foreach ($selectedvalues as $selectedvalue){
		  if (array_key_exists($selectedvalue, $arr)){
		  $selected[] = $arr[$selectedvalue]->$key;
		  }
		  }
		  }
		  else if (!is_null($selected)) {
		  if (array_key_exists($selected, $arr)){
		  $selected = $arr[$selected]->$key;
		  }
		  }
		 */

		if (is_array($arr))
		{
			reset($arr);
		}

		if (is_array($attribs))
		{
			$attribs = JArrayHelper::toString($attribs);
		}

		$html = '<span ' . $attribs . ">\n";

		$id = $name;

		if ($idtag)
		{
			$id = $idtag;
		}

		$id = str_replace('[', '', $id);
		$id = str_replace(']', '', $id);

		$idpos = strpos($attribs, "id=");
		if ($idpos>0){
			$attribs = substr($attribs, 0, $idpos);
		}
		$html .= '<select name="' . $name . '" id="' . $id . '" ' . $attribs . '>'."\n";
		$html .= JHTMLJevrDogList::Options($arr, $key, $text, $selected, $translate);
		$html .= '</select>'."\n";
		$html .= '</span>'."\n";
		
		return $html;

	}
	
	/**
	 * Generates just the option tags for an HTML select list
	 *
	 * @field	array	An array of objects
	 * @field	string	The name of the object variable for the option value
	 * @field	string	The name of the object variable for the option text
	 * @field	mixed	The key that is selected (accepts an array or a string)
	 * @returns	string	HTML for the select list
	 */
	static function options($arr, $key = 'value', $text = 'text', $selected = null, $translate = false)
	{
		$html = '';

		foreach ($arr as $i => $option)
		{
			$element = & $arr[$i]; // since current doesn't return a reference, need to do this

			$isArray = is_array($element);
			$extra = '';
			if ($isArray)
			{
				$k = $element[$key];
				$t = $element[$text];
				$id = ( isset($element['id']) ? $element['id'] : null );
				if (isset($element['disable']) && $element['disable'])
				{
					$extra .= ' disabled="disabled"';
				}
			}
			else
			{
				$k = $element->$key;
				$t = $element->$text;
				$id = ( isset($element->id) ? $element->id : null );
				if (isset($element->disable) && $element->disable)
				{
					$extra .= ' disabled="disabled"';
				}
			}

			// This is real dirty, open to suggestions,
			// barring doing a propper object to handle it
			if ($k === '<OPTGROUP>')
			{
				$html .= '<optgroup label="' . $t . '">'."\n";
			}
			else if ($k === '</OPTGROUP>')
			{
				$html .= '</optgroup>'."\n";
			}
			else
			{
				//if no string after hypen - take hypen out
				$splitText = explode(' - ', $t, 2);
				$t = $splitText[0];
				if (isset($splitText[1]))
				{
					$t .= ' - ' . $splitText[1];
				}

				//$extra = '';
				//$extra .= $id ? ' id="' . $arr[$i]->id . '"' : '';
				if (is_array($selected))
				{
					foreach ($selected as $val)
					{
						$k2 = is_object($val) ? $val->$key : $val;
						if ($k == $k2)
						{
							$extra .= ' selected="selected"';
							break;
						}
					}
				}
				else
				{
					$extra .= ( (string) $k == (string) $selected ? ' selected="selected"' : '' );
				}

				//if flag translate text
				if ($translate)
				{
					$t = JText::_($t);
				}

				// ensure ampersands are encoded
				$k = JFilterOutput::ampReplace($k);
				$t = JFilterOutput::ampReplace($t);

				if (isset($option->price) && is_numeric($option->price))
				{
					// this is not respected by many browsers to skip this
					//	$extra .= ' rel="{price:'.$option->price.'}" ';
				}

				$html .= '<option value="' . $k . '" ' . $extra . '>' . $t . '</option>'."\n";
			}
		}

		return $html;

	}
	function currentAttendeeCount($node, $value){
		if (is_array($value) && count($value)>1) {
			return count($value)-1;
		}
		return 1;
	}

}
class_alias("JFormFieldJevrdoglist", "FormFieldJevrdoglist");