<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\User\User;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

include_once(JPATH_ADMINISTRATOR . "/components/com_rsvppro/fields/JevrField.php");

class JFormFieldJevrvmprofilefield extends JevrField
{

	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var $_name = 'Jevrvmprofilefield';

	const name = 'jevrvmprofilefield';

	static function isEnabled()
	{
		$db = Factory::getDbo();
		$db->setQuery("SELECT enabled FROM #__extensions WHERE element = 'com_virtuemart'");
		$is_vm = $db->loadResult();

		$lang = Factory::getLanguage();
		$lang->load("jevrvmprofilefield", __DIR__);

		return $is_vm;
	}

	public static function loadScript($field = false)
	{
		$lang = Factory::getLanguage();
		$lang->load("jevrvmprofilefield", __DIR__);

		HTMLHelper::script('administrator/components/' . RSVP_COM_COMPONENT . '/fields/js/jevrvmprofilefield.js');

		if ($field)
		{
			$id = 'field' . $field->field_id;
		}
		else
		{
			$id = '###';
		}
		ob_start();
		?>
		<div class='rsvpfieldinput'>

		    <div class="gsl-form-label"><?php echo Text::_("RSVP_FIELD_TYPE"); ?></div>
		    <div class="gsl-form-controls gsl-form-small" style="font-weight:bold;"><?php echo Text::_("RSVP_TEMPLATE_TYPE_JEVRVMPROFILEFIELD"); ?><?php RsvpHelper::fieldId($id); ?></div>
		    <input type="hidden" name="dv[<?php echo $id; ?>]"  value="" />
		    <select name="params[<?php echo $id; ?>][fieldname]" id="fieldname<?php echo $id; ?>"  onchange="jevrvmprofilefield.setvalue('<?php echo $id; ?>');">
			<?php
			// get the VM language file
			$lang = Factory::getLanguage();
			$lang->load("com_virtuemart", JPATH_ADMINISTRATOR);
			$lang->load("com_virtuemart", JPATH_ADMINISTRATOR . "/components/com_virtuemart");
			$lang->load("com_virtuemart_shoppers", JPATH_SITE);
			$lang->load("com_virtuemart_shoppers", JPATH_SITE . "/components/com_virtuemart");

			if (!class_exists('VmConfig'))
				require(JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_virtuemart' . DS . 'helpers' . DS . 'config.php');
			VmConfig::loadConfig();

			include_once(JPATH_ADMINISTRATOR . "/components/com_virtuemart/models/userfields.php");
			$vmmodel = new VirtueMartModelUserfields();
			$userfields = $vmmodel->getUserFields("account", array("published"), array('password', 'password2'));

			$vmmodel = VmModel::getModel('Userfields');
			$userfields = $vmmodel->getUserFields("account", "BT");

			$fieldname = "";
			$activeField = "";
			if ($field)
			{
				try
				{
					$params = json_decode($field->params);
					$fieldname = isset($params->fieldname) ? $params->fieldname : "";
				}
				catch (Exception $e)
				{

				}
			}

			// Add the registration fields to the form.
			foreach ($userfields as $vmfield)
			{
				$label = Text::_($vmfield->title);
				$name = $vmfield->name;
				$selected = "";
				if ($field && $fieldname == $name)
				{
					$selected = "selected='selected'";
					$activeField = $label;
				}
				?>
				<option value="<?php echo $name; ?>" <?php echo $selected; ?> ><?php echo $label ?></option>
				<?php
			}
			?>
		    </select>

		    <div class="rsvpclear"></div>

		    <?php
		    RsvpHelper::hidden($id, $field, self::name);
		    RsvpHelper::label($id, $field, self::name);
		    JFormFieldJevrvmprofilefield::namefield($id, $field);
		    $canmodify = isset($params->canmodify) ? intval($params->canmodify) : 0;
		    ?>
		    <div class="gsl-form-label"><?php echo Text::_("RSVP_CAN_MODIFY"); ?></div>
		    <div class="gsl-form-controls radio btn-group">
			<label for="canmodify1<?php echo $id; ?>"><?php echo Text::_("JYES"); ?>
			    <input type="radio" name="params[<?php echo $id; ?>][canmodify]"  id="canmodify1<?php echo $id; ?>" value="1" <?php
			    if ($canmodify == 1)
			    {
				    echo 'checked="checked"';
			    }
			    ?> />
			</label>
			<label for="canmodify0<?php echo $id; ?>"><?php echo Text::_("JNO"); ?>
			    <input type="radio" name="params[<?php echo $id; ?>][canmodify]" id="canmodify0<?php echo $id; ?>" value="0" <?php
			    if ($canmodify == 0)
			    {
				    echo 'checked="checked"';
			    }
			    ?> />
			</label>
		    </div>
		    <div class="rsvpclear"></div>

		    <?php
		    RsvpHelper::required($id, $field);
		    RsvpHelper::requiredMessage($id, $field);
		    RsvpHelper::conditional($id, $field);
		    RsvpHelper::className($id, $field);
		    RsvpHelper::peruser($id, $field);
		    RsvpHelper::formonly($id, $field);
		    RsvpHelper::showinform($id, $field);
		    RsvpHelper::showindetail($id, $field);
		    RsvpHelper::showinlist($id, $field);
		    RsvpHelper::showinticket($id, $field);
			RsvpHelper::includeinexport($id,  $field);
		    RsvpHelper::allowoverride($id, $field);
		    RsvpHelper::accessOptions($id, $field);
		    RsvpHelper::applicableCategories("facc[$id]", "facs[$id]", $id, $field ? $field->applicablecategories : "all");
		    ?>
		    <div class="rsvpclear"></div>
		</div>
		<div class='rsvpfieldpreview'  id='<?php echo $id; ?>preview'>
		    <div class="previewlabel"><?php echo Text::_("RSVP_PREVIEW"); ?></div>
		    <div class="gsl-form-label rsvppl" id='pl<?php echo $id; ?>'><?php echo $field ? $field->label : Text::_("RSVP_FIELD_LABEL"); ?></div>
		    <div id="pdv<?php echo $id; ?>">
			<?php
			echo $activeField;
			?>
		    </div>
		</div>
		<div class="rsvpclear"></div>
		<?php
		$html = ob_get_clean();

		return RsvpHelper::setField($id, $field, $html, self::name);
	}

	function getInput()
	{
		$node = $this->element;
		$name = $this->name;
		$id = $this->id;
		$value = $this->value;
		if (empty($value))
			$value = "";
		$inputfieldname = $this->fieldname;
		$class = ( $this->attribute('class') ? 'class="' . $this->attribute('class') . ' xxx"' : 'class="text_area xxx"' );

		$user = Factory::getUser();

		if (Factory::getApplication()->input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->user_id > 0 && $this->attendee->user_id != $user->get("id"))
		{
			$userid = $this->attendee->user_id;
		}
		else if (Factory::getApplication()->input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->id > 0 && $this->attendee->user_id == 0)
		{
			$userid = 0;
		}
		else
		{
			$userid = $user->id;
		}

		$showinform = $this->attribute("showinform");

		$fieldname = $this->attribute("fieldname");
		$html = "";

		$canmodify = $this->attribute("canmodify") ? intval($this->attribute("canmodify")) : 0;

		// do we need to map anyu profile fields across?
		$this->mapProfileFields($userid);

		// get the VM language file
		$lang = Factory::getLanguage();
		$lang->load("com_virtuemart", JPATH_ADMINISTRATOR);
		$lang->load("com_virtuemart", JPATH_ADMINISTRATOR . "/components/com_virtuemart");

		include_once(JPATH_ADMINISTRATOR . "/components/com_virtuemart/models/user.php");
		$vmmodel = new VirtueMartModelUser();

		$userid = $vmmodel->setId($userid);
		$userDetails = $vmmodel->getUser();
		$_new = ($userDetails->User->get('id') < 1);

		$layoutName = "edit";
		$virtuemart_userinfo_id_BT = $vmmodel->getBTuserinfo_id($userid);
		$userFieldsArray = $vmmodel->getUserInfoInUserFields($layoutName, 'BT', $virtuemart_userinfo_id_BT, false);
		$userFieldsBT = $userFieldsArray[$virtuemart_userinfo_id_BT];

		if ($canmodify)
		{

			if ($user->id > 0)
			{
				if ($value == "" && isset($userFieldsBT["fields"][$fieldname]))
				{
					$value = $userFieldsBT["fields"][$fieldname]["value"];
				}
			}
			$html .= "<input type='text' value='$value' name='$name' id='" . $id . "' size='40' class='profile_$inputfieldname' />";
		}
		else
		{
			if ($user->id == 0)
			{
				$html .= "<input type='hidden' value='0' name='$name' id='" . $id . "' />";
			}
			else
			{
				$val = $user->id;
				if ($userid > 0 && isset($userFieldsBT["fields"][$fieldname]))
				{
					$val = $userFieldsBT["fields"][$fieldname]["value"];
				}

				$html .= '<input type="hidden" value="' . $val . '" name="' . $name . '"  id="' . $id . '"  />';
				$html .= $val;
			}
		}


		return $html;
	}

	function render_NOT_USED(&$xmlElement, $value, $control_name = 'params')
	{
		$showinform = $xmlElement->attributes("showinform");

		$name = $xmlElement->attributes()->name;
		$label = $xmlElement->attributes('label');
		$descr = $xmlElement->attributes('description');
		if (!$showinform)
			$label = "";

		$result[0] = $label . " ";
		$result[1] = $this->fetchElement($name, $value, $xmlElement, $control_name);
		$result[2] = $descr;
		$result[3] = $label;
		$result[4] = $value;
		$result[5] = $name;

		return $result;
	}

	function toXML($field)
	{
		$result = array();
		$result[] = "<field ";
		if (is_string($field->params) && strpos($field->params, "{") === 0)
		{
			$field->params = json_decode($field->params);
		}
		foreach (get_object_vars($field) as $k => $v)
		{
			if ($k == "options" || $k == "html" || $k == "defaultvalue" || $k == "name")
				continue;
			if ($k == "field_id")
			{
				$k = "name";
				$v = "field" . $v;
			}
			if ($k == "params")
			{
				if (is_object($field->params))
				{
					foreach (get_object_vars($field->params) as $label => $value)
					{
						$result[] = $label . '="' . addslashes(htmlspecialchars($value)) . '" ';
					}
				}
				continue;
			}
			$result[] = $k . '="' . addslashes(htmlspecialchars($v)) . '" ';
		}
		$result[] = " />";
		$xml = implode(" ", $result);
		return $xml;
	}

	public function convertValue($value)
	{
		$fieldname = $this->attribute("fieldname");
		$attendeeUserId = 0;
		if (isset($this->attendee) && isset($this->attendee->user_id) && $this->attendee->user_id > 0)
		{
			$attendeeUserId = $this->attendee->user_id;
		}

		$html = "";
		if (is_null($value) || $value == "" || $value == "0" || (is_numeric($value) && intval($value) == 0))
		{
			$user = Factory::getUser();
			if (isset($this->attendee) && isset($this->attendee->user_id) && $this->attendee->user_id > 0)
			{
				$attendeeUserId = $value = $this->attendee->user_id;
			}
			else if ($user->id == 0)
				return "";
			else
			{
				if (Factory::getApplication()->input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->user_id == 0)
				{
					return "";
				}
				else
				{
					$value = $user->id;
				}
			}
		}

		if (is_numeric($value) && $value == $attendeeUserId)
		{
			$user = Factory::getUser($value);
			if (!isset($user->profile) || !$user->profile)
			{
				// Load the profile data from the database.
				$db = Factory::getDbo();
				$db->setQuery(
					'SELECT profile_key, profile_value FROM #__user_profiles' .
					' WHERE user_id = ' . (int) $value . " AND profile_key LIKE 'profile.%'" .
					' ORDER BY ordering'
				);
				try {
					$results = $db->loadRowList();
				}
				catch (RuntimeException $e)
				{
					$error = $e->getMessage();
					$this->_subject->setError($error);
					return false;
				}

				// Merge the profile data.
				$user->profile = array();

				foreach ($results as $v)
				{
					$k = str_replace('profile.', '', $v[0]);
					$user->profile[$k] = json_decode($v[1], true);
					if ($user->profile[$k] === null)
					{
						$user->profile[$k] = $v[1];
					}
				}
			}

			if (isset($user->profile[$fieldname]))
			{
				$html = $user->profile[$fieldname];
			}
		}
		else
		{
			$html = $value;
		}

		if (Factory::getApplication()->input->getCmd("task") == "attendees.export")
		{
			// there is a HTML error in some CB fields so missmatched tags and cannot use strip_tags
			//$value =  strip_tags($html);
			$search = array('@<*?[^<>]*?>@si');
			$value = preg_replace($search, '', $html);
			return $value;
		}

		if (!isset($this->attendee->guestcount))
		{
			$this->attendee->guestcount = 1;
		}

		return $html;
		// No longer needed since we support multi-attendee fields
		/*
		  if ($this->attribute("peruser")==1 && $this->attendee->guestcount>0){
		  return array_fill(0, $this->attendee->guestcount, $html);
		  }
		  else if ($this->attribute("peruser")==2 && $this->attendee->guestcount>0){
		  $return = array_fill(0, $this->attendee->guestcount, $html);
		  //$return[0]="";
		  return $return;
		  }
		  return $html;
		 */
	}

	static function namefield($id, $field, $default = 0)
	{
		$isname = 0;
		if ($field)
		{
			try
			{
				$params = json_decode($field->params);
				$isname = isset($params->isname) ? $params->isname : 0;
			}
			catch (Exception $e)
			{
				$isname = 0;
			}
		}
		?>
		<div class="gsl-form-label"  ><?php echo Text::_("RSVP_IS_ATTENDEE_NAME_FIELD"); ?></div>
		<div class="gsl-form-controls  radio btn-group">
		    <label for="isname1<?php echo $id; ?>" class="btn radio"><?php echo Text::_("RSVP_YES"); ?>
			<input type="radio" name="params[<?php echo $id; ?>][isname]"  id="isname1<?php echo $id; ?>" value="1" <?php
			if ($isname)
			{
				echo 'checked="checked"';
			}
			?> />
		    </label>
		    <label for="isname0<?php echo $id; ?>"  class="btn radio"><?php echo Text::_("RSVP_NO"); ?>
			<input type="radio" name="params[<?php echo $id; ?>][isname]" id="isname0<?php echo $id; ?>" value="0" <?php
			if (!$isname)
			{
				echo 'checked="checked"';
			}
			?> />
		    </label>
		</div>
		<div class="rsvpclear"></div>
		<?php
	}

	public function mapProfileFields($userid)
	{
		static $mappedUsers = array();
		static $params;
		if (!isset($params))
		{
			$params = false;
			$plugin = PluginHelper::getPlugin('rsvppro', 'virtuemart');
			if (isset($plugin->params) && $plugin->params)
			{
				$params = new Registry($plugin->params);
			}
		}
		if (!isset($mappedUsers[$userid]) && $params && $params->get("vmmapfields" , 0) )
		{
			$mappedUsers[$userid] = 1;

			$user = Factory::getUser($userid);

			for ($field = 1; $field <= 20; $field++)
			{
				$value = $params->get("vmfieldmapping" . $field);
				if ($value && isset($value->vm) && $value->vm != "" && ($value->up != "" OR $value->cf != ""))
				{
					$sourcevalue = "";
					if ($value->cf != "")
					{
						JLoader::register('FieldsHelper', JPATH_ADMINISTRATOR . '/components/com_fields/helpers/fields.php');
						$userCustomFields = FieldsHelper::getFields("com_users.user", $user);
						foreach ($userCustomFields as $userCustomField)
						{
							if ($userCustomField->id == $value->cf)
							{
								$sourcevalue = $userCustomField->value;
							}
						}
					}
					else if ($value->up != "")
					{

						if ($userid > 0 && (!isset($user->profile) || !$user->profile))
						{
							// Load the profile data from the database.
							$db = Factory::getDbo();
							$db->setQuery(
								'SELECT profile_key, profile_value FROM #__user_profiles' .
								' WHERE user_id = ' . (int) $userid . " AND profile_key LIKE 'profile.%'" .
								' ORDER BY ordering'
							);

							try {
								$results = $db->loadRowList();
							}
							catch (RuntimeException $e)
							{
								$error = $e->getMessage();
								echo $error;
								continue;
							}

							// Merge the profile data.
							$user->profile = array();

							foreach ($results as $v)
							{
								$k = str_replace('profile.', '', $v[0]);
								$user->profile[$k] = json_decode($v[1], true);
								if ($user->profile[$k] === null)
								{
									$user->profile[$k] = $v[1];
								}
							}
						}

						if ($userid > 0 && isset($user->profile[$value->up]))
						{
							echo $user->profile[$value->up] . "<Br/>";
							$sourcevalue = $user->profile[$value->up];
						}
					}
					if (!empty($sourcevalue))
					{
						// need to make sure there is a record
						$db = Factory::getDbo();
						$db->setQuery("SELECT * FROM #__virtuemart_userinfos where virtuemart_user_id=$userid");
						if (!$db->loadObject()){
							$db->setQuery("INSERT INTO #__virtuemart_userinfos (virtuemart_user_id) VALUES ($userid)");
							@$db->execute();
						}
						$vmUserFieldsModel = VmModel::getModel('Userfields');
						$vmfields = $vmUserFieldsModel->getUserFields();
						foreach ($vmfields as $vmfield)
						{
							if ($vmfield->virtuemart_userfield_id == $value->vm)
							{
								$db = Factory::getDbo();
								$db->setQuery('UPDATE #__virtuemart_userinfos SET '.$vmfield->name.'='.$db->quote($sourcevalue). " where virtuemart_user_id=$userid");
								@$db->execute();
								break;
							}
						}
					}
				}
			}
		}
	}

}
class_alias("JFormFieldJevrvmprofilefield", "FormFieldJevrvmprofilefield");