<?php
/**
 * JEvents Locations Component for Joomla 1.5.x
 *
 * @version     $Id: jevboolean.php 1331 2010-10-19 12:35:49Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */

// Check to ensure this file is included in Joomla!

defined('JPATH_BASE') or die;

use Joomla\CMS\Language\Text;
use Joomla\CMS\Form\Field\EditorField;
use Joomla\CMS\Factory;

if (file_exists(JPATH_SITE."/libraries/joomla/form/fields/editor.php")){
	include_once(JPATH_SITE."/libraries/joomla/form/fields/editor.php");
}

jimport('joomla.html.editor');

class JFormFieldJevhtml extends EditorField
{
	protected function getInput()
	{
		// Trap to stop the config from being editing from the categories page
		// Updated to redirect to the correct edit page, Joomla 3.x Config actually loads this page when configuration components.
		if (Factory::getApplication()->input->getString("option") =="com_config"){
			$redirect_url  =  "index.php?option=com_rsvppro&task=params.edit"; // get rid of any ampersands
			$app  =  Factory::getApplication();
			$app->redirect($redirect_url); //redirect
			exit();
		}

		//$this->value = str_replace('<br />', "\n", Text::_($this->value));
		$this->element['buttons'] = 0;
		if (Text::_($this->value) !=  $this->value){
			$this->value = Text::_($this->value);
		}
		$html =  parent::getInput();

		if (Factory::getApplication()->input->getCmd("task")=="templates.edit"){
			ob_start();
			?>
			<div>
			<h4 ><?php echo Text::_("RSVP_SELECT_FIELD_TO_INSERT");?> : </h4>
			<select onchange="messagesEditorPlugin.insert('<?php echo $this->id;?>fields' )" id="<?php echo $this->id;?>fields" class="messagesEditorPlugin"  >
				<option value="Select ...:">Select ...</option>
				<optgroup label="<?php echo Text::_("RSVP_EVENT_FIELDS",true);?>" >
					<option value="EVENT"><?php echo Text::_("RSVP_EVENT_TITLE");?></option>
					<option value="LINK}{EVENT}{/LINK"><?php echo Text::_("RSVP_EVENT_LINK"); ?></option>
					<option value="RAWLINK"><?php echo Text::_("RSVP_EVENT_LINK_RAW_URL"); ?></option>
					<option value="DATE}%Y %m %d{/DATE"><?php echo Text::_("RSVP_EVENT_DATE");?></option>
					<option value="TIME}%H:%M{/TIME"><?php echo Text::_("RSVP_EVENT_TIME");?></option>
					<option value="LOCATION"><?php echo Text::_("RSVP_EVENT_LOCATION");?></option>
					<option value="CATEGORY"><?php echo Text::_("RSVP_EVENT_CATEGORY");?></option>
					<option value="REGDATE}%Y-%m-%d{/REGDATE"><?php echo Text::_("RSVP_EVENT_REGISTRATION_DATE"); ?></option>
					<option value="REGID}Ticket Number : %s{/REGID"><?php echo Text::_("RSVP_EVENT_REGISTRATION_ID"); ?></option>
					<?php if (strpos($this->fieldname, "paymessage")>0  || strpos($this->fieldname, "pay2message") >0)  {?>
					<option value="TRANSACTIONID}%010s{/TRANSACTIONID"><?php echo Text::_("RSVP_TRANSACTION_NUMBER");?></option>
					<option value="AMOUNTPAID"><?php echo Text::_("RSVP_PAYMENTAMOUNT");?></option>
					<option value="TIMEPAID}%d %B %Y{/TIMEPAID"><?php echo Text::_("RSVP_TIMEPAYMENTMADE");?></option>
					<?php } ?>
					<?php
					// Bad choices of variable names !
					// templatebody is manual payment gateway layout
					//  is paypal payment gateway layout
					if ($this->fieldname=="templatebody" || $this->fieldname=="template" || $this->fieldname=="paypaltemplate" || $this->fieldname=="manualtemplate"  || $this->fieldname=="hikashoptemplate" )  {?>
					<option value="TOTALFEES"><?php echo Text::_("RSVP_TOTALFEES");?></option>
					<option value="FEESPAID"><?php echo Text::_("RSVP_FEESPAID");?></option>
					<option value="BALANCE"><?php echo Text::_("RSVP_BALANCE");?></option>
					<option value="FORM"><?php echo Text::_("RSVP_PAYMENT_FORM");?></option>
					<option value="DEPOSIT"><?php echo Text::_("RSVP_DEPOSIT");?></option>
					<?php } ?>
					<option value="CREATOR"><?php echo Text::_("RSVP_EVENT_CREATOR");?></option>
					<option value="CUSTOM"><?php echo Text::_("RSVP_EVENT_CUSTOMFIELD_SUMMARY");?></option>
					<option value="VCUSTOM"><?php echo Text::_("RSVP_EVENT_CUSTOMFIELD_VERTICAL_SUMMARY");?></option>
					<option value="REPEATSUMMARY"><?php echo Text::_("RSVP_EVENT_REPEATSUMMARY");?></option>
					<option value="WAITINGMESSAGE"><?php echo Text::_("RSVP_WAITINGMESSAGE");?></option>
					<option value="TICKETS"><?php echo Text::_("RSVP_TICKET_LINK");?></option>
					<option value="PDFTICKETS"><?php echo Text::_("RSVP_PDF_TICKETS");?></option>
					<option value="ATTENDEESUMMARY"><?php echo Text::_("RSVP_ATTENDEE_SUMMARY");?></option>
				</optgroup>
				<optgroup label="<?php echo Text::_("RSVP_TEMPLATE_FIELDS",true);?>" class="templatefields">
				</optgroup>
			</select>
			</div>
			<?php
			$html .= ob_get_clean();
		}
		else if (Factory::getApplication()->input->getCmd("option")=="com_plugins"){
			$html = "<div style='clear:left'>".$html."</div>";
		}
		return $html;
	}

}
class_alias("JFormFieldJevhtml", "FormFieldJevhtml");
