<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

include_once(JPATH_ADMINISTRATOR ."/components/com_rsvppro/fields/JevrField.php");

class JFormFieldJevrprofilefield extends JevrField
{

	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var $_name = 'Jevrprofilefield';
	const name = 'jevrprofilefield';

	static function isEnabled()
	{
		return true;
		$plugin = PluginHelper::getPlugin('user', 'profile');
		return $plugin;
	}


	public static function loadScript($field=false)
	{
		HTMLHelper::script('administrator/components/' . RSVP_COM_COMPONENT . '/fields/js/jevrprofilefield.js');

		if ($field)
		{
			$id = 'field' . $field->field_id;
		}
		else
		{
			$id = '###';
		}
		ob_start();
?>
		<div class='rsvpfieldinput'>

			<div class="gsl-form-label"><?php echo Text::_("RSVP_FIELD_TYPE"); ?></div>
	<div class="gsl-form-controls gsl-form-small" style="font-weight:bold;"><?php echo Text::_("RSVP_TEMPLATE_TYPE_JEVRPROFILEFIELD"); ?><?php RsvpHelper::fieldId($id);?></div>
	<input type="hidden" name="dv[<?php echo $id; ?>]"  value="" />
	<select name="params[<?php echo $id; ?>][fieldname]" id="fieldname<?php echo $id; ?>"  onchange="jevrprofilefield.setvalue('<?php echo $id; ?>');">
		<?php
		// get the community builder language file - in the vain hope they have moved to Joomla 1.5 system
		$lang = Factory::getLanguage();
		$lang->load("plg_user_profile", JPATH_ADMINISTRATOR);

		$plugin = PluginHelper::getPlugin('user', 'profile');
		if (isset($plugin->params) && $plugin->params) {
			$params = new Registry($plugin->params);
			$hasPlugin = true;
		}
		else {
			$params = new Registry(null);
			$hasPlugin = false;
		}

		$plugin2 = PluginHelper::getPlugin('user', 'profile2');

		if (isset($plugin2->params) && $plugin2->params) {
			$hasPlugin2 = true;
		}
		else {
			$hasPlugin2 = false;
		}

		$fieldname = "";
		$activeField = "";
		if ($field)
		{
			try {
				$params = json_decode($field->params);
				$fieldname = isset($params->fieldname) ? $params->fieldname : "";
			}
			catch (Exception $e) {

			}
		}

		// Add the registration fields to the form.
		if ($hasPlugin) {
			Form::addFormPath(JPATH_SITE. '/plugins/user/profile/profiles');

			$form = Form::getInstance("profileform", "profile");
			$fieldsets = $form->getFieldsets();

            if (count($fieldsets)) {
                ?>
                <option value="profileuserfields" disabled><?php Text::_('RSVPPRO_PROFILE_FIELDS_FIELD_HEADER'); ?></option>
                <?php
            }

			foreach ($fieldsets as $key=>$fieldset) {
				$fieldsetFields = $form->getFieldset($key);
				foreach ($fieldsetFields as $fsfield){
					$label = $fsfield->getLabel();
					$name = $fsfield->fieldname;
					$selected = "";
					if ($field && $fieldname == $name)
					{
						$selected = "selected='selected'";
						$activeField = $label;
					}
			?>
						<option value="<?php echo $fsfield->fieldname; ?>" <?php echo $selected; ?> ><?php echo $label ?></option>
			<?php
				}
			}
		}

		// Add the registration fields to the form.
		if ($hasPlugin2) {
			Form::addFormPath(JPATH_SITE. '/plugins/user/profile2/profiles');

			$form = Form::getInstance("profileform", "profile");
			$fieldsets = $form->getFieldsets();

            if (count($fieldsets)) {
                ?>
                <option value="profile2userfields" disabled><?php Text::_('RSVPPRO_PROFILE2_FIELDS_FIELD_HEADER'); ?></option>
                <?php
            }

			foreach ($fieldsets as $key=>$fieldset) {
				$fieldsetFields = $form->getFieldset($key);
				foreach ($fieldsetFields as $fsfield){
					$label = $fsfield->getLabel();
					$name = $fsfield->fieldname;
					$selected = "";
					if ($field && $fieldname == $name)
					{
						$selected = "selected='selected'";
						$activeField = $label;
					}
			?>
						<option value="<?php echo $fsfield->fieldname; ?>" <?php echo $selected; ?> ><?php echo $label ?></option>
			<?php
				}
			}
		}

		// Get the core Joomla user fields form.
		Form::addFormPath(JPATH_ADMINISTRATOR. '/components/com_users/models/forms');
		Form::addFieldPath(JPATH_ADMINISTRATOR. '/components/com_users/models/fields');

		// J4
		Form::addFormPath(JPATH_ADMINISTRATOR. '/components/com_users/forms');
		Form::addFieldPath(JPATH_ADMINISTRATOR. '/components/com_users/forms/fields');

		$lang = Factory::getLanguage();
		$lang->load("com_users", JPATH_ADMINISTRATOR);

		$form = Form::getInstance('com_users.user', 'user');
		$fieldsets = $form->getFieldsets();

        if (count($fieldsets)) {
            ?>
            <option value="coreuserfields" disabled><?php echo Text::_('RSVPPRO_CORE_USER_FIELD_HEADER'); ?></option>
            <?php
        }

		foreach ($fieldsets as $key=>$fieldset) {

			$fieldsetFields = $form->getFieldset($key);

			foreach ($fieldsetFields as $fsfield){
				if ($fsfield->element->attributes()->readonly){
					continue;
				}
				$label = $fsfield->getLabel();
				$name = $fsfield->fieldname;
				$selected = "";
				if ($field && $fieldname == $name)
				{
					$selected = "selected='selected'";
					$activeField = $label;
				}
		?>
					<option value="<?php echo $fsfield->fieldname; ?>" <?php echo $selected; ?> ><?php echo $label ?></option>
		<?php
			}
		}

		// Get Joomla User custom fields if exist

        $user = Factory::getUser();
        JLoader::register('FieldsHelper', JPATH_ADMINISTRATOR . '/components/com_fields/helpers/fields.php');
        $customFields = FieldsHelper::getFields('com_users.user', $user, true);

        if (count($customFields)) {
            ?>
            <option value="customfields" disabled><?php echo Text::_('RSVPPRO_CUSTOM_FIELDS_FIELD_HEADER'); ?></option>
            <?php
        }

        foreach ($customFields as $key => $cfield) {
            $label =  $cfield->title;
            $name = $cfield->name;
            $selected = "";
            if ($cfield && $fieldname == $name)
            {
                $selected = "selected='selected'";
                $activeField = $label;
            }
            ?>
            <option value="<?php echo $name; ?>" <?php echo $selected; ?> ><?php echo $label ?></option>
            <?php
        }
	?>
		</select>
		<div class="rsvpclear"></div>

<?php
		RsvpHelper::hidden($id, $field, self::name);
		RsvpHelper::label($id,  $field, self::name);
		FormFieldJevrprofilefield::namefield($id,  $field);
		$canmodify = isset($params->canmodify) ? intval($params->canmodify) : 0;
?>
			<div class="gsl-form-label"><?php echo Text::_("RSVP_CAN_MODIFY"); ?></div>
			<div class="gsl-form-controls radio gsl-button-group">
				<label for="canmodify1<?php echo $id; ?>"><?php echo Text::_("JYES"); ?>
				<input type="radio" name="params[<?php echo $id; ?>][canmodify]"  id="canmodify1<?php echo $id; ?>" value="1" <?php
			if ($canmodify == 1)
			{
				echo 'checked="checked"';
			}
					?> />
				</label>
				<label for="canmodify0<?php echo $id; ?>"><?php echo Text::_("JNO"); ?>
				<input type="radio" name="params[<?php echo $id; ?>][canmodify]" id="canmodify0<?php echo $id; ?>" value="0" <?php
			   if ($canmodify == 0)
			   {
				   echo 'checked="checked"';
			   }
					?> />
				</label>
			</div>
			<div class="rsvpclear"></div>

<?php
		RsvpHelper::required($id, $field);
		RsvpHelper::requiredMessage($id, $field);
		RsvpHelper::conditional($id,  $field);
        RsvpHelper::className($id, $field);
		RsvpHelper::peruser($id, $field);
		RsvpHelper::formonly($id, $field);
		RsvpHelper::showinform($id, $field);
		RsvpHelper::showindetail($id, $field);
		RsvpHelper::showinlist($id, $field);
		RsvpHelper::showinticket($id, $field);
		RsvpHelper::includeinexport($id,  $field);
		RsvpHelper::allowoverride($id, $field);
		RsvpHelper::accessOptions($id, $field);
		RsvpHelper::applicableCategories("facc[$id]", "facs[$id]", $id, $field ? $field->applicablecategories : "all");
?>
	<div class="rsvpclear"></div>
</div>
<div class='rsvpfieldpreview'  id='<?php echo $id; ?>preview'>
			<div class="previewlabel"><?php echo Text::_("RSVP_PREVIEW"); ?></div>
			<div class="gsl-form-label rsvppl" id='pl<?php echo $id; ?>'><?php echo $field ? $field->label : Text::_("RSVP_FIELD_LABEL"); ?></div>
			<div id="pdv<?php echo $id; ?>">
<?php
		echo $activeField;
?>
			</div>
		</div>
		<div class="rsvpclear"></div>
<?php
		$html = ob_get_clean();

		return RsvpHelper::setField($id, $field, $html, self::name);

	}

	function getInput()
	{

	    $app    = Factory::getApplication();
	    $input  = $app->input;
		$name   = $this->name;
		$id     = $this->id;
		$value  = $this->value;

		if (empty($value)) $value ="";
		$inputfieldname = $this->fieldname;

		$class  = ( $this->attribute('class') ? 'class="'.$this->attribute('class').' xxx"' : 'class="text_area xxx"' );
		$user   =  Factory::getUser();

		if ($input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->user_id>0 && $this->attendee->user_id != $user->get("id")) {
			$userid = $this->attendee->user_id;
		}
		else if ($input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->id>0 && $this->attendee->user_id==0) {
			$userid = 0;
		}
		else {
			$userid = $user->id;
		}

		$showinform = $this->attribute("showinform");

		$fieldname = $this->attribute("fieldname");
		$html = "";

		$canmodify = $this->attribute("canmodify") ? intval($this->attribute("canmodify")) : 0 ;

		// do we need to map any profile fields across?
		$this->mapProfileFields($userid);

		if ($showinform)
		{
			if (is_null($value) || $value == "" || $value == "0" || $value == 0)
			{
				if (isset($this->attendee) && isset($this->attendee->user_id) && $this->attendee->user_id > 0)
				{
					$userid = $this->attendee->user_id;
				}
				else if ($user->id == 0)
					$userid = $user->id;//return $value;
				else {
					if ($input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->user_id == 0) {
						$userid = 	$this->attendee->user_id; //return $value;
					}
				}
			}

			$user = Factory::getUser($userid);

			if ($userid> 0 && (!isset($user->profile) || !$user->profile))
			{
				// Load the profile data from the database.
				$db = Factory::getDbo();
				$db->setQuery(
					'SELECT profile_key, profile_value FROM #__user_profiles' .
					' WHERE user_id = '.(int) $userid." AND profile_key LIKE 'profile.%'" .
					' ORDER BY ordering'
				);

				try {
					$results = $db->loadRowList();
				}
				catch (RuntimeException $e)
				{
					$this->_subject->setError($e->getMessage());
					return false;
				}

				// Merge the profile data.
				$user->profile = array();

				foreach ($results as $v)
				{
					$k = str_replace('profile.', '', $v[0]);
					$user->profile[$k] = json_decode($v[1], true);
					if ($user->profile[$k] === null)
					{
						$user->profile[$k] = $v[1];
					}
				}

				// We didn't find anything, lets try custom fields
                if (is_array($results) && empty($user->profile->$fieldname)) {
                    // Map over the Custom Fields data
                    JLoader::register('FieldsHelper', JPATH_ADMINISTRATOR . '/components/com_fields/helpers/fields.php');
                    $customFields = FieldsHelper::getFields('com_users.user', $user, true);

                    foreach ($customFields as $key => $field) {
                        $user->customfields[$field->name] = $field->value;
                    }
                }
			}


			if ($userid > 0 && isset($user->profile[$fieldname]) && !$canmodify) {
                $user->profile[$fieldname] = trim ($user->profile[$fieldname], '"');
				JLoader::register('PlgUserProfile', JPATH_SITE . '/plugins/user/profile/profile.php');
				JLoader::register('PlgUserProfile2', JPATH_SITE . '/plugins/user/profile2/profile2.php');

				if (method_exists('PlgUserProfile', $fieldname))
				{
					$html .= PlgUserProfile::$fieldname($user->profile[$fieldname]);
				}
                else if (class_exists('PlgUserProfile2') && method_exists('PlgUserProfile2', $fieldname))
				{
					$html .= PlgUserProfile2::$fieldname($user->profile[$fieldname]);
				}
				else
                {
					$html .= $user->profile[$fieldname];
				}
			}
			else if ($userid > 0 && isset($user->$fieldname) && !$canmodify) {
				$html .= $user->$fieldname;
			}
            else if ($userid > 0 && !empty($user->customfields[$fieldname]) && !$canmodify) {
                $html .= $user->customfields[$fieldname];
            }
		}

		if ($canmodify) {

			if ($this->attribute("peruser") == 1 || $this->attribute("peruser") == 2) {

				if (!is_array($value)){
					$value = array($value);
				}

				if (count($value)<$this->currentAttendees){
					// flesh out the value if there are not the right number of items
					for ($i=0;$i<=$this->currentAttendees-count($value);$i++){
						$value[] = "";
					}
				}

				$elementname = $name . '[]';
				$html = "";
				$i = 0;

				foreach ($value as $val){
					if ($i==0){
						if ($this->attribute("peruser") == 2){
							$thisclass = str_replace(" xxx"," disabledfirstparam rsvpparam rsvpparam0 rsvp_" . $inputfieldname,$class);
						}
						else {
							// is this the attendee name field?
							if ($val=="" && !$app->isClient('administrator') && $this->attribute("isname")){
								if ($this->attendee && $this->attendee->user_id>0){
									$atdee = JEVHelper::getUser($this->attendee->user_id);
								}
								else {
									$atdee = Factory::getUser();
								}
								$val  = $atdee->name;
							}
							$thisclass = str_replace(" xxx"," rsvpparam rsvpparam0 rsvp_" . $inputfieldname,$class);
						}
					}
					else {
						$thisclass = str_replace(" xxx"," rsvpparam rsvpparam".$i."  rsvp_" . $inputfieldname,$class);
					}

					if ($user->id > 0)
					{
						if ($val=="" && isset($user->profile[$fieldname]) && $user->profile[$fieldname]){
							$val  = $user->profile[$fieldname] ;
						}
						else if ($val=="" && isset($user->$fieldname) && $user->$fieldname){
							$val  = $user->$fieldname ;
						}
						else if($val == '' && isset($user->customfields[$fieldname]) && $user->customfields[$fieldname]) {
							$val = $user->customfields[$fieldname];
						}
					}
					$html .= "<input type='text' value='$val' name='$elementname' id='".$id."_".$i."' ".$thisclass." size='40' />";

					$i++;
				}

				$thisclass = str_replace(" xxx"," paramtmpl rsvp_" . $inputfieldname,$class);
				$html .= '<input type="text" name="paramtmpl_'.$elementname.'" id="'.$id.'_xxx" value="'.$val.'" '.$thisclass.' size="40" />';

				return $html;
			}

			$formfield = false;

			if ($user->id > 0)
			{
				if ($value=="" && isset($user->profile[$fieldname]) && $user->profile[$fieldname]) {
					$value = $user->profile[$fieldname] ;
				}
				else if ($value=="" && isset($user->$fieldname) && $user->$fieldname) {
					$value = $user->$fieldname;
				} else if($value == '' && isset($user->customfields[$fieldname]) && $user->customfields[$fieldname]) {
				    $value = $user->customfields[$fieldname];
                }

				$form = new Form("profile");

				JLoader::register('PlgUserProfile', JPATH_SITE . '/plugins/user/profile/profile.php');
				JLoader::register('PlgUserProfile2', JPATH_SITE . '/plugins/user/profile2/profile2.php');
                if (method_exists('PlgUserProfile', $fieldname))
				{
					// Add the registration fields to the form.
					Form::addFormPath(JPATH_SITE . '/plugins/user/profile/profiles');
					$form->loadFile('profile', false);
					$formfield = $form->getField($fieldname, 'profile');
					$formfield->id = $id;
					$formfield->name = $name;
					$formfield->value = $value;
					$formfield->class = 'profile_'.$inputfieldname;
				}
                else if (class_exists('PlgUserProfile2') && method_exists('PlgUserProfile2', $fieldname))
				{
					// Add the registration fields to the form.
					Form::addFormPath(JPATH_SITE . '/plugins/user/profile2/profiles');
					$form->loadFile('profile', false);
					$formfield = $form->getField($fieldname, 'profile');
					$formfield->id = $id;
					$formfield->name = $name;
					$formfield->value = $value;
					$formfield->class = 'profile_'.$inputfieldname;
				}

			}

			if ($formfield)
			{
				$html .= $formfield->getInput();
			}
			else {
			    $classPrefix    = !empty($user->customfields[$fieldname]) ? 'profile_customfield' : 'profile';
				$html .= "<input type='text' value='$value' name='$name' id='".$id ."' size='40' class='" . $classPrefix . "_$inputfieldname' />";
			}
		}
		else {
			if ($user->id == 0)
			{
				$html .= "<input type='hidden' value='0' name='$name' id='".$id ."' />";
			}
			else
			{
				$val = $user->id ;
				if ($userid> 0 && isset($user->profile[$fieldname]) && !$canmodify) {
					$val = $user->profile[$fieldname];
				}
				else if ($userid> 0 && isset($user->$fieldname) && !$canmodify) {
					$val = $user->$fieldname;
				} else if ($userid> 0 && isset($user->customfields[$fieldname]) && !$canmodify) {
                    $val = $user->customfields[$fieldname];
                }

				$html .= '<input type="hidden" value="' . $val . '" name="'.$name.'"  id="'.$id .'"  />';
			}
		}

		return $html;

	}

	function render_NOT_USED(&$xmlElement, $value, $control_name = 'params')
        {
		$showinform = $xmlElement->attributes("showinform");

		$name = $xmlElement->attributes()->name;
		$label = $xmlElement->attributes('label');
		$descr = $xmlElement->attributes('description');
		if (!$showinform)
			$label = "";

		$result[0] = $label . " ";
		$result[1] = $this->fetchElement($name, $value, $xmlElement, $control_name);
		$result[2] = $descr;
		$result[3] = $label;
		$result[4] = $value;
		$result[5] = $name;

		return $result;

	}

	function toXML($field)
	{
		$result = array();
		$result[] = "<field ";
		if (is_string($field->params) && strpos($field->params, "{") === 0)
		{
			$field->params = json_decode($field->params);
		}
		foreach (get_object_vars($field) as $k => $v)
		{
			if ($k == "options" || $k == "html" || $k == "defaultvalue" || $k == "name")
				continue;
			if ($k == "field_id")
			{
				$k = "name";
				$v = "field" . $v;
			}
			if ($k == "params")
			{
				if (is_object($field->params))
				{
				   foreach (get_object_vars($field->params) as $label=>$value)
				   {
					   $result[] = $label . '="' . addslashes(htmlspecialchars($value)) . '" ';
				   }
				}
				continue;
			}
			$result[] = $k . '="' . addslashes(htmlspecialchars($v)) . '" ';
		}
		$result[] = " />";
		$xml = implode(" ", $result);
		return $xml;

	}

	public function convertValue($value)
	{
	    $app    = Factory::getApplication();
	    $input  = $app->input;

		$fieldname = $this->attribute("fieldname");
		$attendeeUserId = 0;
		if (isset($this->attendee) && isset($this->attendee->user_id) && $this->attendee->user_id > 0)
		{
			$attendeeUserId = $this->attendee->user_id;
		}

		$html = "";
		if (is_null($value) || $value == "" || $value == "0" || (is_numeric($value)  && intval($value) == 0))
		{
			$user = Factory::getUser();
			if (isset($this->attendee) && isset($this->attendee->user_id) && $this->attendee->user_id > 0)
			{
				$attendeeUserId = $value = $this->attendee->user_id;
			}
			else if ($user->id == 0)
				return "";
			else {
				if ($input->getCmd("task")=="attendees.edit" && isset($this->attendee) && $this->attendee->user_id == 0) {
					return "";
				}
				else {
					$value = $user->id;
				}
			}
		}

		if (is_numeric($value) && $value==$attendeeUserId ){
			$user = Factory::getUser($value);
			if (!isset($user->profile) || !$user->profile)
			{
				// Load the profile data from the database.
				$db = Factory::getDbo();
				$db->setQuery(
					'SELECT profile_key, profile_value FROM #__user_profiles' .
					' WHERE user_id = '.(int) $value." AND profile_key LIKE 'profile.%'" .
					' ORDER BY ordering'
				);
				try {
					$results = $db->loadRowList();
				}
				catch (RuntimeException $e)
				{
					$error = $e->getMessage();
					$this->_subject->setError($error);
					return false;
				}

				// Merge the profile data.
				$user->profile = array();

				foreach ($results as $v)
				{
					$k = str_replace('profile.', '', $v[0]);
					$user->profile[$k] = json_decode($v[1], true);
					if ($user->profile[$k] === null)
					{
						$user->profile[$k] = $v[1];
					}
				}
			}

			if (isset($user->profile[$fieldname])) {
                            $user->profile[$fieldname] = trim ($user->profile[$fieldname], '"');
				$html = $user->profile[$fieldname];
				JLoader::register('PlgUserProfile', JPATH_SITE . '/plugins/user/profile/profile.php');
				JLoader::register('PlgUserProfile2', JPATH_SITE . '/plugins/user/profile2/profile2.php');

                                if (method_exists('PlgUserProfile', $fieldname))
				{
					$html = PlgUserProfile::$fieldname($user->profile[$fieldname]);
				}
                                else if (class_exists('PlgUserProfile2') && method_exists('PlgUserProfile2', $fieldname))
				{
					$html = PlgUserProfile2::$fieldname($user->profile[$fieldname]);
				}

			}
		}
		else {
			JLoader::register('PlgUserProfile', JPATH_SITE . '/plugins/user/profile/profile.php');
			JLoader::register('PlgUserProfile2', JPATH_SITE . '/plugins/user/profile2/profile2.php');

			if (method_exists('PlgUserProfile', $fieldname))
			{
				$html = PlgUserProfile::$fieldname($value);
			}
			else if (class_exists('PlgUserProfile2') && method_exists('PlgUserProfile2', $fieldname))
			{
				$html = PlgUserProfile2::$fieldname($value);
			}
			else
			{
				$html = $value;
			}
		}

		if ($input->getCmd("task")=="attendees.export"){
			// there is a HTML error in some CB fields so missmatched tags and cannot use strip_tags
			//$value =  strip_tags($html);
			$search = array('@<*?[^<>]*?>@si');
			$value = preg_replace($search, '', $html);
			return $value;
		}

		if (!isset($this->attendee->guestcount)){
			$this->attendee->guestcount=1;
		}

		return $html;
		// No longer needed since we support multi-attendee fields
		/*
		 if ($this->attribute("peruser")==1 && $this->attendee->guestcount>0){
			return array_fill(0, $this->attendee->guestcount, $html);
		}
		else if ($this->attribute("peruser")==2 && $this->attendee->guestcount>0){
			$return = array_fill(0, $this->attendee->guestcount, $html);
			//$return[0]="";
			return $return;
		}
		return $html;
		*/
	}

	static function namefield($id, $field, $default = 0)
	{
		$isname = 0;

		if ($field)
		{
			try {
				$params = json_decode($field->params);
				$isname = isset($params->isname)?$params->isname:0;
			}
			catch (Exception $e) {
				$isname = 0;
			}
		}
		?>
		<div class="gsl-form-label"  ><?php echo Text::_("RSVP_IS_ATTENDEE_NAME_FIELD"); ?></div>
		<div class="gsl-form-controls  radio gsl-button-group">
			<label for="isname1<?php echo $id; ?>" class="gsl-button radio"><?php echo Text::_("RSVP_YES"); ?>
			<input type="radio" name="params[<?php echo $id; ?>][isname]"  id="isname1<?php echo $id; ?>" value="1" <?php
		if ($isname)
		{
			echo 'checked="checked"';
		}
		?> />
			</label>
			<label for="isname0<?php echo $id; ?>"  class="gsl-button radio"><?php echo Text::_("RSVP_NO"); ?>
			<input type="radio" name="params[<?php echo $id; ?>][isname]" id="isname0<?php echo $id; ?>" value="0" <?php
		   if (!$isname)
		   {
			   echo 'checked="checked"';
		   }
		?> />
			</label>
		</div>
		<div class="rsvpclear"></div>
		<?php

	}

	public function mapProfileFields($userid)
	{

		static $mappedUsers = array();
		static $params;
		if (!isset($params))
		{
			$params = false;
			$plugin = PluginHelper::getPlugin('rsvppro', 'virtuemart');
			if (isset($plugin->params) && $plugin->params)
			{
				$params = new Registry($plugin->params);
			}
		}

		// Virtuemart Fields
		if (!isset($mappedUsers[$userid]) && $params && $params->get("vmmapfields" , 0) )
		{

			JLoader::register('VmConfig', JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/config.php');
			JLoader::register('VmModel', JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/vmmodel.php');
			VmConfig::loadConfig();
			$mappedUsers[$userid] = 1;

			$user = Factory::getUser($userid);

			for ($field = 1; $field <= 20; $field++)
			{
				$value = $params->get("vmfieldmapping" . $field);
				if ($value && isset($value->vm) && $value->vm != "" && ($value->up != "" OR $value->cf != ""))
				{
					$sourcevalue = "";
					if ($value->cf != "")
					{
						JLoader::register('FieldsHelper', JPATH_ADMINISTRATOR . '/components/com_fields/helpers/fields.php');
						$userCustomFields = FieldsHelper::getFields("com_users.user", $user);
						foreach ($userCustomFields as $userCustomField)
						{
							if ($userCustomField->id == $value->cf)
							{
								$sourcevalue = $userCustomField->value;
							}
						}
					}
					else if ($value->up != "")
					{

						if ($userid > 0 && (!isset($user->profile) || !$user->profile))
						{
							// Load the profile data from the database.
							$db = Factory::getDbo();
							$db->setQuery(
								'SELECT profile_key, profile_value FROM #__user_profiles' .
								' WHERE user_id = ' . (int) $userid . " AND profile_key LIKE 'profile.%'" .
								' ORDER BY ordering'
							);

							try {
								$results = $db->loadRowList();
							}
							catch (RuntimeException $e)
							{
								$error = $e->getMessage();
								echo $error;
								continue;
							}

							// Merge the profile data.
							$user->profile = array();

							foreach ($results as $v)
							{
								$k = str_replace('profile.', '', $v[0]);
								$user->profile[$k] = (strpos($v[1],"{")===0 || strpos($v[1],"[")===0) ?  json_decode($v[1], true) : $v[1];
								if ($user->profile[$k] === null)
								{
									$user->profile[$k] = $v[1];
								}
							}
						}

						if ($userid > 0 && isset($user->profile[$value->up]))
						{

							$sourcevalue = $user->profile[$value->up];
						}
					}
					if (!empty($sourcevalue) && $userid > 0)
					{
						// need to make sure there is a record
						$db = Factory::getDbo();
						$db->setQuery("SELECT * FROM #__virtuemart_userinfos where virtuemart_user_id=$userid AND address_type='BT'");
						if (!$db->loadObject()){
							$db->setQuery("INSERT INTO #__virtuemart_userinfos (virtuemart_user_id, address_type) VALUES ($userid, 'BT')");
							@$db->execute();
						}

						$sourcevalue = trim($sourcevalue, '"');
						$vmUserFieldsModel = VmModel::getModel('Userfields');
						$vmfields = $vmUserFieldsModel->getUserFields();
						foreach ($vmfields as $vmfield)
						{
							if ($vmfield->virtuemart_userfield_id == $value->vm)
							{
								$db = Factory::getDbo();
								$db->setQuery('UPDATE #__virtuemart_userinfos SET '.$vmfield->name.'='.$db->quote($sourcevalue). " where virtuemart_user_id=$userid");
								$db->execute();
								break;
							}
						}
						$db = Factory::getDbo();
						$db->setQuery('UPDATE #__virtuemart_userinfos SET address_type="BT" where address_type="" AND virtuemart_user_id='.$userid);
						$db->execute();
					}
				}
			}

		}

		// RVirtuemart Fields
		if (!isset($mappedUsers[$userid]) && $params && $params->get("rvmmapfields" , 0) )
		{
			JLoader::register('VmConfig', JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/config.php');
			JLoader::register('VmModel', JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/vmmodel.php');
			VmConfig::loadConfig();
			$mappedUsers[$userid] = 1;

			$user = Factory::getUser($userid);

			for ($field = 1; $field <= 20; $field++)
			{
				$value = $params->get("rvmfieldmapping" . $field);

				if ($value && isset($value->vm) && $value->vm != "" && ($value->up != "" OR $value->cf != ""))
				{
					$sourcevalue = "";


					$db = Factory::getDbo();

					$vmUserFieldsModel = VmModel::getModel('Userfields');
					$vmfields = $vmUserFieldsModel->getUserFields('');
					foreach ($vmfields as $vmfield)
					{
						if ($vmfield->virtuemart_userfield_id == $value->vm)
						{
							try {
								$db->setQuery('SELECT '.$vmfield->name.' from  #__virtuemart_userinfos'." where virtuemart_user_id=$userid");
								$sourcevalue = (string) $db->loadResult();
								//$sourcevalue = trim($sourcevalue, '"');
							}
							catch (Exception $e)
							{
							}
							break;
						}
					}
					$newObj = new stdClass;

					$newObj->field_id = (int) $value->cf;
					$newObj->item_id  = (int) $userid;
					$newObj->value = $sourcevalue;

					if (!empty($sourcevalue) && $userid > 0)
					{

						if ((int) $value->cf )
						{
							$newObj = new stdClass;

							$newObj->field_id = (int) $value->cf;
							$newObj->item_id  = (int) $userid;
							$newObj->value = $sourcevalue;

							$db->setQuery("SELECT * FROM #__fields_values where item_id=$newObj->item_id AND field_id=$newObj->field_id");
							if ($obj = $db->loadObject())
							{
								$db->setQuery("UPDATE #__fields_values set value=".$db->quote($newObj->value)." where item_id=$newObj->item_id AND field_id=$newObj->field_id");
								$db->execute();
							}
							else {
								$db->insertObject('#__fields_values', $newObj);
							}
						}
						else if ($value->up != "")
						{

							if ($userid > 0)
							{
								// Load the profile data from the database.
								$db = Factory::getDbo();
								$db->setQuery(
									'SELECT profile_key, profile_value FROM #__user_profiles' .
									' WHERE user_id = ' . (int) $userid . " AND profile_key LIKE 'profile.%'" .
									' ORDER BY ordering'
								);

								try {
									$profilefields = $db->loadObjectList('profile_key');
								}
								catch (RuntimeException $e)
								{
									$error = $e->getMessage();
									echo $error;
									continue;
								}

								if (isset($profilefields["profile.".$value->up]))
								{
									$db->setQuery(
										'UPDATE #__user_profiles' .
										' SET profile_value = '.$db->quote($sourcevalue) .
										' WHERE user_id = ' . (int) $userid . " AND profile_key = 'profile.$value->up'"
									);
								}
								else
								{
									$db->setQuery(
										'INSERT INTO #__user_profiles (user_id, profile_value, profile_key) ' .
										' VALUES ( ' . (int) $userid . ', '.$db->quote($sourcevalue) .", 'profile.$value->up')"
									);

								}
								$db->execute();

								if (isset($user->profile))
								{
									$user->profile[$value->up] = $sourcevalue ;
								}
							}

						}
					}
				}
			}

		}

	}

}
class_alias("JFormFieldJevrprofilefield", "FormFieldJevrprofilefield");
