<?php
/**
 * @version    CVS: 1.7.4
 * @package    com_yoursites
 * @author     Geraint Edwards <yoursites@gwesystems.com>
 * @copyright  2016-2020 GWE Systems Ltd
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('JPATH_BASE') or die;

use Joomla\CMS\Access\Access;
use Joomla\CMS\Version;
use Joomla\CMS\Router\Route;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Language\Text;

JLoader::register('JEventsHelper', JPATH_ADMINISTRATOR . "/components/com_jevents/helpers/jevents.php");

class GslRsvpproMenuHelper
{

	static public function getLeftIconSubLinks($leftmenutrigger)
	{

		JLoader::register('JevTemplateHelper', JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/templatehelper.php");

		$iconLinks = array();

		$iconLink                 = new stdClass();
		$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
		$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
		$iconLink->active         = false;
		$iconLink->link           = Route::_("index.php?option=com_rsvppro&task=sessions.overview");
		$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
		$iconLink->icon           = "calendar";
		$iconLink->label          = Text::_('RSVP_SESSIONS');
		$iconLink->tooltip        = $leftmenutrigger !== 2 ? "" : Text::_('RSVP_SESSIONS');
		$iconLink->tooltip_detail = "";
		$iconLinks[]              = $iconLink;

		$iconLink                 = new stdClass();
		$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
		$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
		$iconLink->active         = false;
		$iconLink->link           = Route::_("index.php?option=com_rsvppro&task=pmethods.overview");
		$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
		$iconLink->icon           = "credit-card";
		$iconLink->label          = Text::_('RSVP_PRO_PAYMENT_METHODS');
		$iconLink->tooltip        = $leftmenutrigger !== 2 ? "" : Text::_('RSVP_PRO_PAYMENT_METHODS');
		$iconLink->tooltip_detail = "";
		$iconLinks[]              = $iconLink;

		if (JevTemplateHelper::canCreateOwn())
		{
			$iconLink                 = new stdClass();
			$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
			$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
			$iconLink->active         = false;
			$iconLink->link           = Route::_("index.php?option=com_rsvppro&task=templates.overview");
			$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
			$iconLink->icon           = "thumbnails";
			$iconLink->label          = Text::_('RSVP_TEMPLATES');
			$iconLink->tooltip        = $leftmenutrigger !== 2 ? "" : Text::_('RSVP_TEMPLATES');
			$iconLink->tooltip_detail = "";
			$iconLinks[]              = $iconLink;
		}

		$iconLink                 = new stdClass();
		$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
		$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
		$iconLink->active         = false;

		$uri    = (string) Uri::getInstance();
		$return = urlencode(base64_encode($uri));

		$iconLink->link           = Route::_("index.php?option=com_config&view=component&component=com_rsvppro&return=" . $return);
		$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
		$iconLink->icon           = "settings";
		$iconLink->label          = Text::_('COM_RSVPPRO_CONFIG');
		$iconLink->tooltip        = $leftmenutrigger !== 2 ? "" : Text::_('COM_RSVPPRO_CONFIG_TOOLTIP', true);
		$iconLink->tooltip_detail = "";
		$iconLinks[]              = $iconLink;

		return $iconLinks;
	}

}
