<?php
/**
 * @version $Id$
 * @package Attend Events
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

use Joomla\CMS\Table\Table;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Factory;

class rsvpTransaction extends Table {
	
	public $transaction_id = null;
	public $attendee_id = null;
	public $gateway = null;
	public $amount = null;
	public $transaction_date = null;
	public $logdata = null;
	public $currency = null;
	public $paymentstate = null;
	public $notes = null;

	// Gateway Specific Info Goes in params as JSON data
	public $params = null;

	// Gateway Transaction ID saved to avoid decoding json
	public $gw_transid = null;

	function __construct() {
		$db = Factory::getDBO();
		parent::__construct( '#__jev_rsvp_transactions', 'transaction_id', $db );
		$this->params = json_encode(array());
	} 

	function check() {
		if (!is_null($this->transaction_date)){
			$this->transaction_date = strftime('%Y-%m-%d %H:%M:%S', strtotime($this->transaction_date));
		}
		else {
			$this->transaction_date = strftime('%Y-%m-%d %H:%M:%S');
		}

		return true;
	}

	function delete($pk = null)
	{

		if ( !parent::delete() ) return false;

		// update attendee status too!
		$this->updateAttendee();

		return true;
	}

	function store($updateNulls = false, $updateAttendee = true)
	{
		$this->check();
		if ( !parent::store($updateNulls) ) return false;

		// update attendee status too!
		if ($updateAttendee)
		{
			$this->updateAttendee();
		}
		
		return true;
	}
	

	private function updateAttendee(){
		if (isset($this->attendee_id) && intval($this->attendee_id)>0){
			$db = Factory::getDBO();
            $sql = "SELECT * FROM #__jev_attendees WHERE id=".intval($this->attendee_id);
			$db->setQuery($sql);
			$attendee = $db->loadObject();

			if (isset($attendee) && isset($attendee->params)){
	            $sql = "SELECT * FROM #__jev_attendance WHERE id=".intval($attendee->at_id);
				$db->setQuery($sql);
				$rsvpdata = $db->loadObject();

				// Load class helpers for JSON/Direct Requests.
				JLoader::register('JevTemplateHelper', JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/templatehelper.php");
				JLoader::register('JevRsvpParameter', JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/jevrsvpparameter.php");

				$xmlfile = JevTemplateHelper::getTemplate($rsvpdata);
				if (is_int($xmlfile) || file_exists($xmlfile)) {
					$params = new JevRsvpParameter($attendee->params,$xmlfile, $rsvpdata, null);
					$feesAndBalances = $params->outstandingBalance($attendee);
				}

				// I also need to trigger a plugin to say that a registration has been updated
				PluginHelper::importPlugin("rsvppro");
				$rpid = $attendee->rp_id;
				// Find the rellevant repeat
				$this->dataModel = new JEventsDataModel();
				$this->queryModel = new JEventsDBModel($this->dataModel);
				if ($rpid == 0)
				{
					$vevent = $this->dataModel->queryModel->getEventById($rsvpdata->ev_id, false, "icaldb");
					if (!$vevent) {
						return;
					}
					$repeat = $vevent->getFirstRepeat();
				}
				else
				{
					list($year, $month, $day) = JEVHelper::getYMD();
					$repeatdata = $this->dataModel->getEventData(intval($rpid), "icaldb", $year, $month, $day);
					if ($repeatdata && isset($repeatdata["row"]))
						$repeat = $repeatdata["row"];
				}

				Factory::getApplication()->triggerEvent( 'onRegistrationStatusChange' , array(&$attendee, $repeat, $rsvpdata));

			}

		}
	}
}

