<?php
/**
 * JEvents Component for Joomla
 *
 * @version     $Id: overview.php 1676 2010-01-20 02:50:34Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
defined('_JEXEC') or die('Restricted Access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;



$db = Factory::getDBO();
$user = Factory::getUser();
$compparams = ComponentHelper::getParams('com_rsvppro');
$params = false;
$feesAndBalances = false;
$showtransactions = false;

if (count($this->rows) > 0)
{
	$attendee = $this->rows[0];

    $sql = "SELECT * FROM #__jev_attendance WHERE id=" . $attendee->at_id;
	$db->setQuery($sql);
	$rsvpdata = $db->loadObject();
}
else
{
	$rsvpdata = false;
}

$pluginpath = 'plugins/jevents/jevrsvppro/rsvppro/';

$pathIMG = JURI::root() . 'administrator/images/';

if (!isset($this->templateInfo))
{
	$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);

	if (is_int($xmlfile) && $xmlfile > 0)
	{
		$db = Factory::getDbo();
		$db->setQuery("Select * from #__jev_rsvp_templates where id=" . intval($xmlfile));
		$this->templateInfo = $db->loadObject();
		if ($this->templateInfo)
		{
			$this->templateParams = $this->templateInfo->params;
			$this->templateParams = json_decode($this->templateParams);
		}
		else
		{
			$this->templateParams = false;
		}
	}
	else
	{
		$this->templateParams = false;
	}
}
	?>
<div id="jevents" class="attendeeslist">

    <form action="index.php" method="post" name="adminForm"  id="adminForm"  >
	<table cellpadding="4" cellspacing="0" border="0" >
	    <tr>
		<td><?php echo Text::_('JEV_SEARCH'); ?>&nbsp
            <input type="text" name="search" value="<?php echo $this->search; ?>" class="inputbox"
                   onchange="document.adminForm.task.value = 'attendees.list';document.adminForm.submit();" /></td>
		<td><?php echo $this->confirmed; ?></td>
		<td><?php echo $this->attendstate; ?></td>
		<td><?php echo $this->waiting; ?></td>
	    </tr>
	</table>

	<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist  table table-striped" id="attendeelist">
	    <thead>
		<tr>
		    <th width="20" nowrap="nowrap">
			<?php echo HTMLHelper::_('grid.checkall'); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'RSVP_ATTENDEE_NUMBER', 'atdees.id', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'JEV_ATTENDEE', 'attendee', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <th class="title" >
			<?php echo Text::_("RSVP_DELETE"); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'RSVP_CONFIRMED_STATUS', 'atdees.confirmed', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'JEV_ATTENDANCE_STATUS', 'atdees.attendstate', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'JEV_WAITING', 'atdees.waiting', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'JEV_REGISTRATION_TIME', 'atdees.created', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'JEV_MODIFICATION_TIME', 'atdees.modified', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'RSVP_ATTENDED', 'atdees.didattend', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <th class="title" >
			<?php echo HTMLHelper::_('grid.sort', 'RSVP_ATTENDANCENOTES', 'atdees.notes', $this->orderdir, $this->order, "attendees.list"); ?>
		    </th>
		    <?php
		    if ($this->templateParams && $this->templateInfo->withticket)
		    {
			    ?>
			    <th class="title jevticket">
				<?php echo Text::_("JEV_PRINT_TICKET"); ?>
			    </th>
			    <?php
		    }

		    $html = "";
		    $colcount = 11;
		    if (count($this->rows) > 0)
		    {

			    $attendee = $this->rows[0];

			    $template = $rsvpdata->template;

			    // Store details in registry - will need them for waiting lists!
			    $registry = JevRegistry::getinstance("jevents");
			    $registry->set("rsvpdata", $rsvpdata);
			    $registry->set("event", $attendee->eventrepeat);

			    // New parameterised fields
			    $params = false;
			    if ($template != "")
			    {
				    $xmlfile = JevTemplateHelper::getTemplate($rsvpdata);
				    if (is_int($xmlfile))
				    {
					    $eventrow = clone $this->repeat;
					    $masterparams = new JevRsvpParameter("", $xmlfile, $rsvpdata, $eventrow);
				    }

				    if (is_int($xmlfile) || file_exists($xmlfile))
				    {
					    // no need to check attendee or locked templates for the headers !!!
					    // transfer attendee specific information into the event row
					    $eventrow = clone $this->repeat;
					    if (isset($this->xmlparams[$xmlfile]))
					    {
						    $params = clone ($this->xmlparams[$xmlfile]);
					    }
					    else
					    {
						    $params = new JevRsvpParameter("", $xmlfile, $rsvpdata, $eventrow);
						    $this->xmlparams[$xmlfile] = $params;
					    }

					    $html = "";
					    $html .= '<th class="title transactionscolumn"   >' . Text::_("RSVP_TRANSACTIONS") . '</th>';
					    $colcount++;

					    $params = $params->renderToBasicArray();
					    foreach ($params as $param)
					    {
						    if ($param["capacity"] > 0 && isset($param["capacitycount"]))
						    {
							    $html .= '<th>' . Text::_($param['label']) . ' (' . $param["capacitycount"] . '/' . $param["capacity"] . ')</th>';
							    $colcount++;
						    }
						    else
						    {
							    if ($param['label'] != "" && $param["showinlist"])
							    {
								    $html .= '<th>' . stripslashes(Text::_($param['label'])) . '</th>';
								    $colcount++;
							    }
						    }
					    }
					    //}
				    }
			    }
		    }
		    echo $html;
		    ?>
		</tr>
	    </thead>
	    <tbody>

		<?php
		$k = 0;
		$nullDate = $db->getNullDate();

		for ($i = 0, $n = count($this->rows); $i < $n; $i++)
		{
			$attendee = &$this->rows[$i];

			$rowspan = $attendee->guestcount > 0 ? " rowspan='" . $attendee->guestcount . "' " : "";

			// New parameterised fields
			$params = false;
			if ($rsvpdata->template != "")
			{
				$xmlfile = JevTemplateHelper::getTemplate($rsvpdata);

				if ((is_int($xmlfile) || file_exists($xmlfile)) && ($attendee->lockedtemplate == 0 || $attendee->lockedtemplate == $xmlfile))
				{
					// transfer attendee specific information into the event row
					$eventrow = clone $this->repeat;
					if (isset($this->xmlparams[$xmlfile]))
					{
						$params = clone ($this->xmlparams[$xmlfile]);
					}
					else
					{
						$params = new JevRsvpParameter("", $xmlfile, $rsvpdata, $eventrow);
						$this->xmlparams[$xmlfile] = $params;
					}
					foreach (get_object_vars($attendee) as $key => $val)
					{
						$eventrow->$key = $val;
					}
					if (isset($attendee->params))
					{
						// building from scratch each time is slow! so use a cloned object!
						//$params = new JevRsvpParameter($attendee->params, $xmlfile, $rsvpdata, $eventrow);
						$params->loadData($attendee->params, $rsvpdata, $eventrow);
						$feesAndBalances = $params->outstandingBalance($attendee);
					}
					else
					{
						//$params = new JevRsvpParameter("", $xmlfile, $rsvpdata, $eventrow);
						$feesAndBalances = false;
					}
					$params = $params->renderToBasicArray('xmlfile', $attendee);
				}
				else if ($attendee->lockedtemplate > 0)
				{
					$xmlfile = $attendee->lockedtemplate;

					// transfer attendee specific information into the event row
					$eventrow = clone $this->repeat;
					if (isset($this->xmlparams[$xmlfile]))
					{
						$params = clone ($this->xmlparams[$xmlfile]);
					}
					else
					{
						$params = new JevRsvpParameter("", $xmlfile, $rsvpdata, $eventrow);
						$this->xmlparams[$xmlfile] = $params;
					}
					foreach (get_object_vars($attendee) as $key => $val)
					{
						$eventrow->$key = $val;
					}
					if (isset($attendee->params))
					{
						// building from scratch each time is slow! so use a cloned object!
						//$params = new JevRsvpParameter($attendee->params, $xmlfile, $rsvpdata, $eventrow);
						$params->loadData($attendee->params, $rsvpdata, $eventrow);
						$feesAndBalances = $params->outstandingBalance($attendee);
					}
					else
					{
						//$params = new JevRsvpParameter("", $xmlfile, $rsvpdata, $eventrow);
						$feesAndBalances = false;
					}
					$params = $params->renderToBasicArray('xmlfile', $attendee);
				}
				else
				{
					$params = false;
				}
			}

			if (!$attendee->confirmed)
			{
				$cimg = 'Cross.png';
			}
			else
			{
				$cimg = 'Tick.png';
			}
			$calt = "";
			if (!$attendee->waiting)
			{
				$wimg = 'Cross.png';
			}
			else
			{
				$wimg = 'Tick.png';
			}
			$walt = "";

			$trashimg = "Trash.png";
			$talt = "";

			$wimg = '<img src="' . JURI::root() . $pluginpath . '/assets/' . $wimg . '" border="0" alt="' . $walt . '" style="height:16px;border:none;" /></a>';
			$cimg = '<img src="' . JURI::root() . $pluginpath . '/assets/' . $cimg . '" border="0" alt="' . $walt . '" style="height:16px;border:none;" /></a>';
			$trashimg = '<img src="' . JURI::root() . $pluginpath . '/assets/' . $trashimg . '" border="0" alt="' . $talt . '" style="height:16px;border:none;" /></a>';
			$mainframe = Factory::getApplication();
			?>
		<tr class="row<?php echo $k; ?>">
			    <td width="20"  <?php echo $rowspan; ?>>
				<?php echo HTMLHelper::_('grid.id', $i, $attendee->atdee_id); ?>
			    </td>
			    <td   <?php echo $rowspan; ?>>
				<?php echo $attendee->atdee_id; ?>
			    </td>
			    <td   <?php echo $rowspan; ?>>
				<a href="#edit" onclick=" Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.edit');return false;" title="<?php echo Text::_('JEV_CLICK_TO_EDIT'); ?>"><?php echo $attendee->attendee; ?></a>
			    </td>
			    <td   <?php echo $rowspan; ?>>
				<a href="#delete" onclick="if (confirm('<?php echo addslashes(Text::sprintf("RSVP_DELETE_ATTENDEE_NAMED", $attendee->attendee)); ?>'))
								{Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.delete');return false;}
		                                            else
		                                                return false;" title="<?php echo Text::_('JEV_CLICK_TO_DELETE_ATTENDEE'); ?>">
				       <?php echo $trashimg; ?>
				</a>
			    </td>
			    <td   <?php echo $rowspan; ?>>
				<?php
				if (!$attendee->confirmed)
				{
					?>
				<a href="javascript: void(0);" onclick="Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.confirm');return false;" title="<?php echo Text::_('JEV_CLICK_TO_CONFIRM', true); ?>"><?php echo $cimg; ?></a>
						<?php
					}
					else
					{
					?>
							<?php echo $cimg; ?>
						<?php } ?>
				    </td>
				    <td  <?php echo $rowspan; ?>>
					<?php
					$images = array("Cross.png", "Tick.png", "Question.png", "Pending.png", "MoneyBag.png", "RedMoneyBag.png");
					$imageLinks = $images;
					array_walk($imageLinks,function (&$value, $key, $pluginpath) {
						$value = '<img src="' . JURI::root() . $pluginpath . 'assets/' . $value . '" style="height:16px;" alt="' . $value . '" />';
					}, $pluginpath);

					$tooltip = ' data-yspoptitle = "' . Text::_('RSVP_CLICK_TO_CHANGE_STATE', true). '"'
						. "  data-yspopcontent = '" . vsprintf(str_replace("'", "&apos;", Text::_("RSVP_ATTENDEE_STATUS_ICONS")), $imageLinks)  . "'";

					$img = $images[$attendee->attendstate];
					if ($attendee->attendstate == 1 && $feesAndBalances)
				{
					if ($feesAndBalances["feebalance"] < -0.01)
					{
						$img = $images[5];
					}
				}
				// pending state allowing for approval
				if ($attendee->attendstate == 3)
				{
					?>
				<img src="<?php echo JURI::root() . $pluginpath . '/assets/Pending.png'; ?>"  alt="<?php echo Text::_("JEV_PENDING"); ?>" />
						<a href="#changestate" onclick="if (confirm('<?php echo Text::_("JEV_APPROVE_ATTENDANCE_CHECK_CAPACITY") . "?"; ?>'))
				                                                               {Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.approve');return false;}
				                                                            else
				                                                                return false;" title="<?php echo Text::_('JEV_APPROVE_ATTENDANCE'); ?>">
						    (<img src="<?php echo JURI::root() . $pluginpath . '/assets/Tick.png'; ?>"  alt="<?php echo Text::_("JEV_APPROVE_ATTENDANCE"); ?>" />)
						</a>
						<?php
					}
					else
					{
					?>
							<a href="#edit" onclick="Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.changestate');return false;" class="hasYsPopover" <?php echo $tooltip;?> >
							    <?php
							    echo '<img src="' . JURI::root() . $pluginpath . '/assets/' . $img . '"  style="height:16px;" alt="' . $img . '" />';
							    ?>
							</a>
							<?php
						}
						?>
				    </td>
				    <td   <?php echo $rowspan; ?>>
					<?php
					if ($attendee->waiting)
					{
						?>
						<a href="#notwaiting" onclick="if (confirm('<?php echo addslashes(Text::sprintf("RSVP_PROMOTE_FROM_WAITING_LIST", $attendee->attendee)); ?>'))
				                                                {Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.notwaiting');return false;}
				                                            else
				                                                return false;" title="<?php echo Text::_('RSVP_PROMOTE_FROM_WAITING_LIST', true); ?>">
						       <?php echo $wimg; ?>
						</a>
						<?php
					}
					else
					{
					?>
				<a href="#waiting" onclick="if (confirm('<?php echo addslashes(Text::sprintf("RSVP_DEMOTE_TO_WAITING_LIST", $attendee->attendee)); ?>'))
				                                                {Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.waiting');return false;}
				                                            else
				                                                return false;" title="<?php echo Text::_('RSVP_DEMOTE_TO_WAITING_LIST', true); ?>">
						       <?php echo $wimg; ?>
						</a>
					<?php } ?>
				    </td>
				    <td   <?php echo $rowspan; ?>>
					<?php
					$format = $this->params->get("timestampformat", "%Y-%m-%d %H:%M");
					echo strftime($format, strtotime($attendee->created));
					?>
				    </td>
				    <td   <?php echo $rowspan; ?>>
					<?php
					$format = $this->params->get("timestampformat", "%Y-%m-%d %H:%M");
					if ($attendee->modified != "0000-00-00 00:00:00")
					{
					echo strftime($format, strtotime($attendee->modified));
				}
				?>
				    </td>
				    <td   <?php echo $rowspan; ?>>
					<?php
					$img = $attendee->didattend ? 'Tick.png' : 'Cross.png';
					$task = $attendee->didattend ? 'notattend' : 'attend';
					$alt = !$attendee->didattend ? Text::_('RSVP_MARK_ATTENDANCE') : Text::_('RSVP_MARK_NONATTENDANCE');
				$action = !$attendee->didattend ? Text::_('RSVP_MARK_ATTENDANCE') : Text::_('RSVP_MARK_NONATTENDANCE');

				$mainframe = Factory::getApplication();
				$img = '<img src="' . JURI::root() . $pluginpath . '/assets/' . $img . '"  style="height:16px;" alt="' . $alt . '" />';

				$didattend = '
							<a href="javascript:void(0);" onclick="Joomla.listItemTask(\'cb' . $i . '\',\'attendees.' . $task . '\');return false;" title="' . $action . '">	' . $img . '</a>';
				// should we show how many guests are attending?
				if ($attendee->guestcount > 1 && $attendee->guestattend != "")
				{
					$guests = explode(",", $attendee->guestattend);
					$didattend .= "<br/> (" . count($guests) . "/" . $attendee->guestcount . ")";
		$didattend .= " <br/>" . $attendee->guestattend;
					}
					echo $didattend;
					?>
				    </td>
				    <?php
				    if (!isset($attendee->atdee_id))
				    {
					    $attendee->notes = "";
			    }
			    ?>
				    <td  <?php echo $rowspan; ?>>
					<textarea rows="2" cols="10" name="notes[<?php echo $attendee->atdee_id; ?>]" id="attendeenotes_<?php echo $attendee->atdee_id; ?>" onkeyup="jQuery('#attendeenotes_<?php echo $attendee->atdee_id; ?>').parent().find('div').css('display', 'block');" ><?php echo trim($attendee->notes); ?></textarea>
					<div >
					    <a class="gsl-button gsl-button-small" href="javascript:void(0);" onclick="Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.updatenotes');return false;" >
						<span class="icon-save"></span>
						<?php echo Text::_("RSVP_UPDATE_NOTES"); ?>
					    </a>
					</div>
				    </td>
				    <?php
				    if ($this->templateParams && $this->templateInfo->withticket)
				    {
					    if ($attendee->attendstate == 0)
				    {
					    ?>
						    <td   <?php echo $rowspan; ?> class="jevtickets" />
						    <?php
					    }
					    else
					    {
						    // Load the modal behavior script.
								JLoader::register('JevModal', JPATH_LIBRARIES . "/jevents/jevmodal/jevmodal.php");
								JevModal::modal("a.jevmodal");
							    $data = new stdClass();
							    $data->size   = 'modal-lg';
							    $data->title  = Text::_("JEV_PRINT_TICKET");

						    ?>
								    <td  <?php echo $rowspan; ?> class="jevtickets">
										<div class="jevtickets" style="white-space: nowrap;">
										    <a href="<?php echo Route::_("index.php?option=com_rsvppro&tmpl=component&task=attendees.ticket&attendee=" . $attendee->id); ?>"  title="<?php echo Text::_("JEV_PRINT_TICKET"); ?>"
										       class="jevmodal" data-jevmodal='<?php echo json_encode($data);?>'
										       data-jevmodal=
										    >
											    <span class="gsl-icon" data-gsl-icon="print"></span>
										    </a>
										    <a href="<?php echo Route::_("index.php?option=com_rsvppro&tmpl=component&task=attendees.pdfticket&skipgsl=1&attendee=" . $attendee->id); ?>"
										       title="<?php echo Text::_("RSVP_PDF_TICKETS"); ?>"
										       target="_blank"
										    >
											    <span class="gsl-icon" data-gsl-icon="file-pdf"></span>
										    </a>
											<a href="<?php echo Route::_("index.php?option=com_rsvppro&tmpl=component&task=attendees.htmlticket&skipgsl=1&attendee=" . $attendee->id); ?>"
											   title="<?php echo Text::_("RSVP_HTML_TICKETS"); ?>"
											   target="_blank"
											>
												<span class="gsl-icon" data-gsl-icon="file-text"></span>
											</a>
									    </div>
								    </td>
								    <?php
							    }
						    }
						    if ($feesAndBalances && $feesAndBalances["hasfees"])
			    {
				    $showtransactions = true;
				    ?>
							    <td  style="text-align: center" <?php echo $rowspan; ?> class="transactionscolumn">
								<a href="#edit" onclick="Joomla.listItemTask('cb<?php echo $i; ?>', 'attendees.transactions');return false;" title="<?php echo Text::_('RSVP_TRANSACTIONS'); ?>">
								    <?php
								    echo count($feesAndBalances["transactions"]);
								    $img = "MoneyBag.png";
								    echo ' <img src="' . JURI::root() . $pluginpath . '/assets/' . $img . '"  style="height:16px;" alt="' . $img . '" />';
					    ?>
							</a>
						    </td>
						    <?php
					    }
					    else
					    {
				    ?>
						    <td   <?php echo $rowspan; ?> class="transactionscolumn"> - </td>
						    <?php
					    }

					    $html = "";

					    if ($params)
			    {
				    foreach ($params as $param)
				    {
					    if ($param['label'] != "" && $param["showinlist"])
					    {
						    if (is_array($param['value']) && $attendee->guestcount > 0)
						    {
							    $val = $param['value'][0];
							    if ($val == "")
							    {
								    // need hard space for Joomla 3.3 backend stylinh
								    $val = "&nbsp";
							    }
							    if ($attendee->attendstate != 0)
							    {
								    $html .= '<td >' . stripslashes($val) . '</td>';
							    }
							    else
							    {
								    $html .= '<td class="notattending"><em>' . stripslashes($val) . '</em></td>';
							    }
						    }
						    else
						    {
							    if ($param['value'] == "")
							    {
								    // need hard space for Joomla 3.3 backend stylinh
								    $param['value'] = "&nbsp";
							    }
							    if ($attendee->attendstate != 0)
							    {
								    $html .= '<td ' . $rowspan . '>' . stripslashes($param['value']) . '</td>';
							    }
							    else
							    {
								    $html .= '<td class="notattending"><em>' . stripslashes($param['value']) . '</em></td>';
							    }
						    }
					    }
				    }
			    }

			    echo $html;
			    ?>
				</tr>
				<?php
				// Now the other param rows
				if ($attendee->guestcount > 0 && $params)
				{
				for ($a = 1; $a < $attendee->guestcount; $a++)
				{
					?>
			<tr class="row<?php echo $k; ?>">
						    <?php
						    foreach ($params as $param)
						    {
							    if ($param['label'] != "" && $param["showinlist"])
						    {
							    if (is_array($param['value']))
							    {
								    $val = $param['accessible'] && isset($param['value'][$a]) ? $param['value'][$a] : "";
								    if ($param['peruser'] <= 0)
								    {
									    // need hard space for Joomla 3.3 backend stylinh
									    $val = "&nbsp;";
								    }

								    echo '<td >' . stripslashes($val) . '</td>';
							    }
						    }
					    }
					    ?>
								</tr>
								<?php
							}
						}

						$k = 1 - $k;
		}

		if (!$showtransactions)
		{
			Factory::getDocument()->addStyleDeclaration(".transactionscolumn {display:none;}");
		}
		?>
	    </tbody>
	    <tfoot>
		<tr>
		    <td align="center" colspan="<?php echo $colcount; ?>"><?php
			echo $this->pageNav->getListFooter();
			if (version_compare(JVERSION, "3.0", 'ge'))
			{
				echo $this->pageNav->getLimitBox();
			}
			?>
		    </td>
		</tr>
	    </tfoot>
	</table>
	<input type="hidden" name="option" value="<?php echo RSVP_COM_COMPONENT; ?>" />
	<input type="hidden" name="task" value="attendees.list" />
	<input type="hidden" name="boxchecked" id="boxchecked" value="0" />
	<input type="hidden" name="atd_id[]" value="<?php echo $this->atd_id . "|" . $this->rp_id; ?>" />
	<input type="hidden" name="repeating" value="<?php echo $this->repeating; ?>" />
	<input type="hidden" name="filter_order" value="<?php echo $this->order; ?>" />
	<input type="hidden" name="filter_order_Dir" value="<?php echo $this->orderdir; ?>" />
	<input type="hidden" name="Itemid" value="<?php echo Factory::getApplication()->input->getInt("Itemid", 0); ?>" />

	<?php
	$securitycheck = md5($compparams->get("emailkey", "email key") . " attendee list " . $user->id);
	?>
	<input type="hidden" name="sc" value="<?php echo $securitycheck ?>" />

	<?php echo HTMLHelper::_('form.token'); ?>
    </form>
</div>

