<?php
/**
 * JEvents Component for Joomla! 3.x
 *
 * @version     $Id: cpanel.php 3119 2011-12-20 14:34:33Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;

$lang = Factory::getLanguage();
$lang->load("com_jevents", JPATH_ADMINISTRATOR);

$params  = ComponentHelper::getParams(JEV_COM_COMPONENT);

?>

<div id="jevents" >
    <!-- CONTENT -->
    <div class="gsl-container gsl-container-expand">
        <div class="gsl-grid gsl-grid-divider gsl-grid-medium gsl-child-width-1-2 gsl-child-width-1-3@m gsl-child-width-1-4@l"
             gsl-grid>
            <div>
                <span class="gsl-text-small">
                        <span gsl-icon="icon:calendar" class="gsl-margin-small-right gsl-text-primary"></span>
                        <?php echo Text::_("COM_RSVPPRO_TOTAL_SINGLE_SESSIONS");?>
                </span>
                <h2 class="gsl-heading-primary gsl-margin-remove gsl-text-primary gsl-h2">
                    <a href="<?php echo Route::_("index.php?option=com_rsvppro&task=sessions.overview&hidepast=1&repeating=1")?>">
						<?php echo Text::sprintf("COM_RSVPPRO_FUTURE_SESSIONS", $this->futureSessions);?>
                    </a>
                </h2>
                <a href="<?php echo Route::_("index.php?option=com_rsvppro&task=sessions.overview&hidepast=0&repeating=1")?>"
                   class="gsl-text-small gsl-text-success gsl-display-block">
                    <span class="gsl-text-success" gsl-icon="icon: history"></span>
					<?php echo Text::sprintf("COM_RSVPPRO_PAST_SESSIONS", $this->pastSessions);?>
                </a>
            </div>
            <div>
                <span class="gsl-text-small">
                        <span gsl-icon="icon:calendar" class="gsl-margin-small-right gsl-text-primary"></span>
                        <?php echo Text::_("COM_RSVPPRO_TOTAL_REPEATING_SESSIONS");?>
                </span>
                <h2 class="gsl-heading-primary gsl-margin-remove gsl-text-primary gsl-h2">
                    <a href="<?php echo Route::_("index.php?option=com_rsvppro&task=sessions.overview&hidepast=1&repeating=0")?>">
				        <?php echo Text::sprintf("COM_RSVPPRO_FUTURE_SESSIONS", $this->futureRepeatingSessions);?>
                    </a>
                </h2>
                <a href="<?php echo Route::_("index.php?option=com_rsvppro&task=sessions.overview&hidepast=0&repeating=0")?>"
                   class="gsl-text-small gsl-text-success gsl-display-block">
                    <span class="gsl-text-success" gsl-icon="icon: history"></span>
			        <?php echo Text::sprintf("COM_RSVPPRO_PAST_SESSIONS", $this->pastRepeatingSessions);?>
                </a>
            </div>
            <div>
                <span class="gsl-text-small">
                        <span gsl-icon="icon:plus-circle" class="gsl-margin-small-right gsl-text-primary"></span>
                        <?php echo Text::_("COM_JEVENTS_NEW_EVENTS");?>
                </span>
                <h2 class="gsl-heading-primary gsl-margin-remove gsl-text-primary gsl-h2">
                    <a href="<?php echo Route::_("index.php?option=com_jevents&task=icalevent.list")?>">
						<?php echo Text::sprintf("COM_JEVENTS_NEW_EVENTS_THIS_Week", $this->newSessions);?>
                    </a>
                </h2>
                <a href="<?php echo Route::_("index.php?option=com_jevents&task=icalevent.list")?>"
                   class="gsl-text-small gsl-text-success gsl-display-block">
                    <span class="gsl-text-success" gsl-icon="icon: plus-circle"></span>
					<?php echo Text::sprintf("COM_JEVENTS_NEW_EVENTS_THIS_MONTH", $this->newThisMonth);?>
                </a>
            </div>
            <div>
                <span class="gsl-text-small">
                   <span gsl-icon="icon:users" class="gsl-margin-small-right gsl-text-primary"></span>
                   <?php echo Text::_("COM_JEVENTS_UPCOMING_REGISTRATIONS");?>
                </span>
				<?php if ($this->upcomingAttendees >= 0) { ?>
                    <h2 class="gsl-heading-primary gsl-margin-remove  gsl-text-primary gsl-h2">
                        <a href="<?php echo Route::_("index.php?option=com_rsvppro&task=sessions.list")?>">
							<?php echo Text::sprintf("COM_JEVENTS_UPCOMING_REGISTRATIONS_THIS_WEEK", $this->upcomingAttendees);?>
                        </a>
                    </h2>
                    <a href="<?php echo Route::_("index.php?option=com_rsvppro&task=sessions.overview")?>"
                       class="gsl-text-small gsl-text-success gsl-display-block">
                        <span class="gsl-text-success" gsl-icon="icon: users"></span>
						<?php echo Text::sprintf("COM_JEVENTS_UPCOMING_REGISTRATIONS_THIS_MONTH", $this->upcomingAttendeesThisMonth);?>
                    </a>
				<?php }
				else {
					?>
                    <h2 class="gsl-heading-primary gsl-margin-remove  gsl-text-primary hasYsPopover"
                        data-yspoptitle="<?php echo Text::_('COM_JEVENTS_REQUIRES_RSVPPRO'); ?>"
                        data-yspopcontent="<?php echo Text::_("COM_JEVENTS_REQUIRES_RSVPPRO_DETAIL"); ?>"
                        ?>
	                    <?php echo Text::_("COM_JEVENTS_NOT_INSTALLED");?>
                    </h2>
					<?php
				}
				?>
            </div>
        </div>
        <hr>
        <div class="gsl-grid gsl-grid-medium" gsl-grid>

            <!-- panel -->
            <div class="gsl-width-1-1@s gsl-width-1-1@l">
                <div class="gsl-card gsl-card-default gsl-card-small gsl-card-hover">
                    <div class="gsl-card-header">
                        <div class="gsl-grid gsl-grid-small">
                            <div class="gsl-width-auto"><h4><?php echo Text::_("COM_JEVENTS_UPCOMING_REGISTRATIONS_BY_EVENT");?></h4></div>
                        </div>
                    </div>
                    <div class="gsl-card-body">
                        <div class="chart-container">
                            <canvas id="chart3"></canvas>
                        </div>
                    </div>
                </div>
            </div>
            <!-- /panel -->
        </div>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/chart.js@2.8.0/dist/Chart.min.js"></script>
    <script type="text/javascript">

	    // Chart 3
	    // ========================================================================
	    <?php if (PluginHelper::isEnabled("jevents", "jevrsvppro")) { ?>
	    new Chart(document.getElementById('chart3'), {
		    type: 'bar',
		    data: {
			    labels: ['<?php echo  implode("', '", $this->attendeeCountsByEvent['title']); ?>'],
			    datasets: [
				    {
					    backgroundColor: "#39f",
					    data: [<?php echo  implode(", ", $this->attendeeCountsByEvent['count']); ?>],
                        'jeventlinks': ['<?php echo  implode("', '", $this->attendeeCountsByEvent['link']); ?>'],
				    },
			    ],
			    startrepeat: ['<?php echo  implode("', '", $this->attendeeCountsByEvent['start']); ?>'],
		    },
		    options: {
			    maintainAspectRatio: false,
			    responsiveAnimationDuration: 500,
			    legend: {
				    display: false
			    },
			    animation: {
				    duration: 2000
			    },
			    title: {
				    display: false,
			    },
			    scales: {
				    yAxes: [{
					    display: true,
					    ticks: {
						    suggestedMin: 0,    // minimum will be 0, unless there is a lower value.
						    precision: 0
					    }
				    }]
			    },
			    tooltips: {
				    enabled: true,
				    mode: 'single',
				    callbacks: {
					    label: function(tooltipItems, data) {
						    return tooltipItems.yLabel + ' @ ' + data.startrepeat[tooltipItems.index] ;
					    }
				    }
			    },
			    onClick: function(evt, item) {
                    var activePoints = this.getElementsAtEvent(evt);
                    if ( typeof item[0]._index != 'undefined')
                    {
                        window.open(this.data.datasets[0].jeventlinks[item[0]._index]);
                    }
			    },
		    }
	    });
	    <?php } ?>

    </script>

    <form action="<?php echo Route::_('index.php?option=com_rsvppro'); ?>" method="post" name="adminForm" id="adminForm">
        <input type="hidden" name="task" value=""/>
        <input type="hidden" name="redirecturl" value=""/>
        <input type="hidden" name="boxchecked" value="0"/>
        <input type="hidden" name="form_submitted" value="1"/>
        <input type="hidden" name="baseurl" id="baseurl" value="<?php echo JURI::root(); ?>"/>
        <input type="hidden" name="listlayout" id="listlayout"  value=""/>
        <input type="hidden" id="ystscomponent" value="dashboard"/>
		<?php echo HTMLHelper::_('form.token', array('id' => "tokenid")); ?>
    </form>
    <!-- /CONTENT -->
</div>
