<?php
/**
 * @version    3.7.4
 * @package    COM_RSVPPRO
 * @author     Tony Partridge <tony@jevents.net>
 * @copyright  2018 - 2021 GWE Systems Ltd
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access
defined('_JEXEC') or die;

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

HTMLHelper::addIncludePath(JPATH_COMPONENT . '/helpers/');
HTMLHelper::_('bootstrap.tooltip');
HTMLHelper::_('behavior.multiselect');
//HTMLHelper::_('formbehavior.chosen', 'select');

// Import CSS
$document = Factory::getDocument();

$user      = Factory::getUser();
$userId    = $user->get('id');
$listOrder = $this->state->get('list.ordering');
$listDirn  = $this->state->get('list.direction');

$sortFields = $this->getSortFields();

$params    = ComponentHelper::getParams('com_rsvppro');
$jevparams = ComponentHelper::getParams('com_jevents');
?>
<div id="jevents">
    <form action="<?php echo Route::_('index.php?option=com_rsvppro&view=emailinvitees'); ?>" method="post"
      name="adminForm" id="adminForm">

			<?php echo LayoutHelper::render('joomla.searchtools.default', array('view' => $this)); ?>

			<div class="clearfix"></div>
			<table class="table table-striped" id="emailinviteeList">
				<thead>
				<tr>
					<?php if (isset($this->items[0]->ordering)): ?>
						<th width="1%" class="nowrap center hidden-phone">
							<?php echo HTMLHelper::_('searchtools.sort', '', 'a.`ordering`', $listDirn, $listOrder, null, 'asc', 'JGRID_HEADING_ORDERING', 'icon-menu-2'); ?>
						</th>
					<?php endif; ?>
					<th width="1%" class="hidden-phone">
						<input type="checkbox" name="checkall-toggle" value=""
						       title="<?php echo Text::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)"/>
					</th>
					<?php if (isset($this->items[0]->state)): ?>

					<?php endif; ?>

					<th class='left'>
						<?php echo HTMLHelper::_('searchtools.sort', 'COM_RSVPPRO_EMAILINVITEES_ID', 'a.`id`', $listDirn, $listOrder); ?>
					</th>
					<th class='left'>
						<?php echo HTMLHelper::_('searchtools.sort', 'COM_RSVPPRO_EMAILINVITEES_NAME', 'a.`name`', $listDirn, $listOrder); ?>
					</th>
					<th class='left'>
						<?php echo HTMLHelper::_('searchtools.sort', 'COM_RSVPPRO_EMAILINVITEES_USER_ID', 'a.`user_id`', $listDirn, $listOrder); ?>
					</th>
					<th class='left'>
						<?php echo HTMLHelper::_('searchtools.sort', 'COM_RSVPPRO_EMAILINVITEES_EMAIL_ADDRESS', 'a.`email_address`', $listDirn, $listOrder); ?>
					</th>
					<th class='left'>
						<?php echo HTMLHelper::_('searchtools.sort', 'COM_RSVPPRO_EMAILINVITEES_EMAIL_NAME', 'a.`email_name`', $listDirn, $listOrder); ?>
					</th>
					<th class='left'>
						<?php echo HTMLHelper::_('searchtools.sort', 'COM_RSVPPRO_EMAILINVITEES_SENTMESSAGE', 'a.`sentmessage`', $listDirn, $listOrder); ?>
					</th>
					<th class='left'>
						<?php echo HTMLHelper::_('searchtools.sort', 'COM_RSVPPRO_EMAILINVITEES_VIEWEDEVENT', 'a.`viewedevent`', $listDirn, $listOrder); ?>
					</th>
					<th class='left'>
						<?php echo HTMLHelper::_('searchtools.sort', 'COM_RSVPPRO_EMAILINVITEES_INVITEDATE', 'a.`invitedate`', $listDirn, $listOrder); ?>
					</th>

				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="<?php echo isset($this->items[0]) ? count(get_object_vars($this->items[0])) : 10; ?>">
						<?php echo $this->pagination->getListFooter(); ?>
					</td>
				</tr>
				</tfoot>
				<tbody>
				<?php foreach ($this->items as $i => $item) :
					$ordering = ($listOrder == 'a.ordering');
					$canCreate = $user->authorise('core.create', 'com_rsvppro');
					$canEdit = $user->authorise('core.edit', 'com_rsvppro');
					$canCheckin = $user->authorise('core.manage', 'com_rsvppro');
					$canChange = $user->authorise('core.edit.state', 'com_rsvppro');
					?>
					<tr class="row<?php echo $i % 2; ?>">

						<?php if (isset($this->items[0]->ordering)) : ?>
							<td class="order nowrap center hidden-phone">
								<?php if ($canChange) :
									$disableClassName = '';
									$disabledLabel = '';

									if (!$saveOrder) :
										$disabledLabel    = Text::_('JORDERINGDISABLED');
										$disableClassName = 'inactive tip-top';
									endif; ?>
									<span class="sortable-handler hasTooltip <?php echo $disableClassName ?>"
									      title="<?php echo $disabledLabel ?>">
							<i class="icon-menu"></i>
						</span>
									<input type="text" style="display:none" name="order[]" size="5"
									       value="<?php echo $item->ordering; ?>" class="width-20 text-area-order "/>
								<?php else : ?>
									<span class="sortable-handler inactive">
							<i class="icon-menu"></i>
						</span>
								<?php endif; ?>
							</td>
						<?php endif; ?>
						<td class="hidden-phone">
							<?php echo HTMLHelper::_('grid.id', $i, $item->id); ?>
						</td>
						<?php if (isset($this->items[0]->state)): ?>

						<?php endif; ?>

						<td>

							<?php echo $item->id; ?>
						</td>
						<td>

							<?php echo $item->name . '<br /><small>' . strftime($params->get("listdateformat", "%Y-%m-%d"), $item->dtstart) . '</small>'; ?>
						</td>
						<td>

							<?php echo $item->user_id; ?>
						</td>
						<td>

							<?php echo $item->email_address; ?>
						</td>
						<td>

							<?php echo $item->email_name; ?>
						</td>
						<td>

							<?php echo Text::_('COM_RSVPPRO_EMAIL_SENTMESSAGE_' . $item->sentmessage); ?>

						</td>
						<td>

							<?php echo Text::_('COM_RSVPPRO_EMAILINVITEES_VIEWEDEVENT_' . $item->viewedevent); ?>

						</td>
						<td>

							<?php echo $item->invitedate; ?>
						</td>

					</tr>
				<?php endforeach; ?>
				<?php if(count($this->items) === 0) {?>
					<tr>
						<td class="no_rows_found" style="text-align:center;font-weight:bold;" colspan="9">
							<?php
							echo Text::_('COM_RSVPPRO_NO_DATA_FOUND_FOR_QUERY');
							?>
						</td>
					</tr>
				<?php } ?>
				</tbody>
			</table>

			<input type="hidden" name="task" value=""/>
			<input type="hidden" name="boxchecked" value="0"/>
			<input type="hidden" name="list[fullorder]" value="<?php echo $listOrder; ?> <?php echo $listDirn; ?>"/>
			<?php echo HTMLHelper::_('form.token'); ?>
    </form>
</div>
<script>
    window.toggleField = function (id, task, field) {

        var f = document.adminForm, i = 0, cbx, cb = f[id];

        if (!cb) return false;

        while (true) {
            cbx = f['cb' + i];

            if (!cbx) break;

            cbx.checked = false;
            i++;
        }

        var inputField = document.createElement('input');

        inputField.type = 'hidden';
        inputField.name = 'field';
        inputField.value = field;
        f.appendChild(inputField);

        cb.checked = true;
        f.boxchecked.value = 1;
        window.submitform(task);

        return false;
    };
</script>
