<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: view.html.php 1703 2010-02-16 12:23:46Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\File;

/**
 * HTML View class for the component
 *
 * @static
 */
class AdminInviteesViewInvitees extends RSVPAbstractView
{

	function overview($tpl = null)
	{
		$this->addTemplatePath($this->_basePath."/views/invitees/tmpl/");

		HTMLHelper::stylesheet(  'components/'.RSVP_COM_COMPONENT.'/assets/css/rsvpadmin.css' );

		$document = Factory::getDocument();
		$document->setTitle(Text::_('JEV_INVITEES'));

		// Set toolbar items for the page
		if (isset($this->repeat)){
			JToolBarHelper::title( Text::_( 'JEV_INVITEES' )." : ".$this->repeat->title(), 'jevents' );
		}
		else {
			JToolBarHelper::title( Text::_( 'JEV_INVITEES' ), 'jevents' );
		}

		JToolBarHelper::custom( 'sessions.overview', 'calendar.png', 'calendar.png', 'RSVP_SESSIONS', false );
		JToolBarHelper::custom( 'cpanel.cpanel', 'default.png', 'default.png', 'JEV_ADMIN_CPANEL', false );

		JLoader::register('JevRsvpInvitees',JPATH_ADMINISTRATOR."/components/com_rsvppro/libraries/jevrinvitees.php");

		jimport('joomla.filesystem.file');
		$this->jomsocial = false;
		if (File::exists(JPATH_SITE.'/components/com_community/community.php')){
			if (ComponentHelper::isEnabled("com_community")) {
				$this->jomsocial = true;
			}
		}

		$this->cbuilder = false;
		$this->groupjive = false;
		if (File::exists(JPATH_SITE.'/components/com_comprofiler/comprofiler.php')){
			if (ComponentHelper::isEnabled("com_comprofiler")) {
				$this->cbuilder = true;
				if (File::exists(JPATH_SITE."/components/com_comprofiler/plugin/user/plug_cbgroupjive/cbgroupjive.php")){
					$this->groupjive = true;
				}
			}
		}

        JHtmlSidebar::addEntry(
			Text::_('RSVP_SESSIONS'),
			"index.php?option=com_rsvppro&task=sessions.list",
			false
		);
		$this->jevrinvitees = new JevRsvpInvitees($this->params, $this->jomsocial, $this->cbuilder, $this->groupjive);

	}




}
