<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: view.html.php 1703 2010-02-16 12:23:46Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\Toolbar;

/**
 * HTML View class for the component
 *
 * @static
 */
class AdminSessionsViewSessions extends RSVPAbstractView
{
	function overview($tpl = null)
	{
		$params = ComponentHelper::getParams(RSVP_COM_COMPONENT);

		HTMLHelper::stylesheet(  'components/'.RSVP_COM_COMPONENT.'/assets/css/rsvpadmin.css' );

		$document = Factory::getDocument();
		$document->setTitle(Text::_('RSVP_SESSIONS'));

		// Set toolbar items for the page
		JToolBarHelper::title( Text::_( 'RSVP_SESSIONS' ), 'jevents' );

		JLoader::register('Joomla\CMS\Toolbar\Button\JeveditButton', JPATH_COMPONENT_ADMINISTRATOR . "/libraries/jevtoolbarbuttons.php");
		JLoader::register('Joomla\CMS\Toolbar\Button\JevstandardButton', JPATH_COMPONENT_ADMINISTRATOR . "/libraries/jevtoolbarbuttons.php");

		JLoader::register('Joomla\CMS\Toolbar\Button\JevconfirmButton', JPATH_COMPONENT_ADMINISTRATOR . "/libraries/jevtoolbarbuttons.php");
		JLoader::register('JToolbarButtonJevconfirm', JPATH_COMPONENT_ADMINISTRATOR . "/libraries/jevtoolbarbuttons.php");

		JLoader::register('Joomla\CMS\Toolbar\Button\JevscriptButton', JPATH_COMPONENT_ADMINISTRATOR . "/libraries/jevtoolbarbuttons.php");
		JLoader::register('Joomla\CMS\Toolbar\Button\JevrawButton', JPATH_COMPONENT_ADMINISTRATOR . "/libraries/jevtoolbarbuttons.php");

		$bar =  JToolBar::getInstance('toolbar');
		// Add a special edit button
		$bar->appendButton('Jevedit',  "new", "JTOOLBAR_NEW", 'icalevent.edit', false, false, "document.adminForm.updaterepeats.value");

		//ToolBarHelper::deleteList('RSVP_DELETE_SESSION_MESSAGE','sessions.delete',"RSVP_DELETE_SESSION");

		JToolBarHelper::spacer();
		$bar->appendButton('Jevstandard',  "home", "COM_RSVPPRO_ADMIN_CPANEL", 'cpanel.cpanel', false);

		RsvpproHelper::addSubmenu();


	}

	function editRepeatLink($row) {
		list($year,$month,$day) = JEVHelper::getYMD();
		$link =  "index.php?option=".JEV_COM_COMPONENT."&task=".$row->editTask().'&evid='. $row->id()."&year=$year&month=$month&day=$day";
		return $link;
	}

	function editLink($row) {
		$link = "index.php?option=".JEV_COM_COMPONENT."&task=icalevent.edit&evid=". $row->ev_id();
		return $link;
	}

}
