<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: edit.php 1438 2009-05-02 09:25:42Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
defined('_JEXEC') or die('Restricted Access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Form\FormHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Editor\Editor;
use Joomla\CMS\Version;

// needed until we remove bootstrap popovers
HTMLHelper::_('bootstrap.framework');
HTMLHelper::_('bootstrap.loadCss');

$app = Factory::getApplication();
$jversion = new Version;
if (!$jversion->isCompatible('4.0'))
{
	//HTMLHelper::_('formbehavior.chosen', 'select');
}
HTMLHelper::script( 'administrator/components/com_rsvppro/assets/js/rsvp.js' );
Text::script('COM_RSVPPRO_FIELD_EDIT_MISSING_REQUIRED_MESSAGE');

$conf = Factory::getConfig();
$defaulteditor = $conf->get('editor');
$ticketeditor =  Editor::getInstance($defaulteditor);
$editor =  Editor::getInstance('none');

if ($this->item->id === 0)
	exit();
?>
<div class='jevrsvppro'>
	<div id="jevents" class="edittemplate">
		<form action="index.php" method="post" name="adminForm"  id="adminForm" onsubmit="return checkRequiredMessages()">
			<div class="row-fluid">
				<input type="hidden" name="customise" value="<?php echo Factory::getApplication()->input->getInt("customise"); ?>" />
				<input type="hidden" name="cid[]" value="<?php echo (Factory::getApplication()->input->getInt("customise") && $this->item->istemplate) ? 0 : $this->item->id; ?>" />
				<input type="hidden" name="id" id="id" value="<?php echo (Factory::getApplication()->input->getInt("customise") && $this->item->istemplate) ? 0 : $this->item->id; ?>" />
				<input type="hidden" name="istemplate" id="istemplate" value="<?php echo Factory::getApplication()->input->getInt("customise") ? 0 : 1; ?>" />
				<input type="hidden" name="evid" id="evid" value="<?php echo Factory::getApplication()->input->getInt("evid"); ?>" />
				<input type="hidden" name="oldid" id="oldid" value="<?php echo $this->item->id; ?>" />
				<input type="hidden" name="created_by" id="created_by" value="<?php echo $this->item->created_by; ?>" />

				<script type="text/javascript" >
                    function submitbutton(pressbutton) {
                        if (pressbutton == 'cancel' || pressbutton == 'templates.cancel') {
                            Joomla.submitform( pressbutton , document.adminForm);
                            return;
                        }
                        var form = document.adminForm;

						<?php
						/*
if (!Factory::getApplication()->input->getInt("customise"))
{
echo $editor->save('description');
}
echo $ticketeditor->save('ticket');
						*/
						?>
                        // do field validation
                        if (form.title.value == "") {
                            alert ( "<?php echo html_entity_decode(Text::_('Missing Title')); ?>" );
                        }
                        else {
                            Joomla.submitform( pressbutton , document.adminForm);
                        }
                    }

				</script>
				<div class="gsl-form-horizontal">
					<div class="gsl-margin-small-bottom">
						<label class="gsl-form-label"><?php echo Text::_('RSVP_TEMPLATE_TITLE'); ?> </label>
						<div class="gsl-form-controls" >
							<input class="inputbox" type="text" name="title" size="50" maxlength="100" required="true" value="<?php echo htmlspecialchars($this->item->title, ENT_QUOTES, 'UTF-8'); ?>" />
						</div>
					</div>

					<?php
					// if we already have attendees then offer to lock the template
					if ($this->hasAttendeesToLock)
					{
						?>
						<div class="gsl-margin-small-bottom" >
							<label class="gsl-form-label hasjevtip" style="font-weight:bold" title="<?php echo RsvpHelper::tooltipText('RSVP_LOCK_ATTENDEE_SPECIFIC_TEMPLATES','RSVP_LOCK_ATTENDEE_SPECIFIC_TEMPLATES_DESC');?>"><?php echo Text::_('RSVP_LOCK_ATTENDEE_SPECIFIC_TEMPLATES'); ?></label>
							<div class="gsl-form-controls" >
								<label><?php echo Text::_("JEV_YES"); ?><input class="inputbox" type="radio" name="lockattendees"  value="1"  /></label>
								<label><?php echo Text::_("JEV_NO"); ?><input class="inputbox" type="radio" name="lockattendees"  value="0"   checked='checked'  /></label>
							</div>
						</div>
					<?php } ?>

					<?php
					if (!Factory::getApplication()->input->getInt("customise"))
					{
						?>
						<div class="gsl-margin-small-bottom">
							<label class="gsl-form-label"><?php echo Text::_('RSVP_TEMPLATE_DESCRIPTION'); ?></label>

							<div class="gsl-form-controls" >
								<?php
								// parameters : areaname, content, hidden field, width, height, rows, cols
								echo $editor->display('description', htmlspecialchars($this->item->description, ENT_QUOTES, 'UTF-8'), "80%", 100, '70', '10', false);
								?>
							</div>
						</div>
                    <?php } else { ?>
                        <input class="inputbox" type="hidden" name="description" size="50" maxlength="100" required="true" value="<?php echo htmlspecialchars($this->item->description, ENT_QUOTES, 'UTF-8') ?>" />
                    <?php } ?>
					<div class="gsl-margin-small-bottom">
						<label class="gsl-form-label"><?php echo Text::_('RSVP_HAS_FEES'); ?> </label>
						<div class="gsl-form-controls" >
							<div class="radio gsl-button-group">
								<label  for="withfees1"  class="gsl-button radio"><?php echo Text::_("JEV_YES"); ?><input class="inputbox gsl-hidden" type="radio" name="withfees"  id="withfees1"  value="1"  <?php echo $this->item->withfees ? "checked='checked'" : ""; ?> onclick="rsvppro.hasFees(this)" /></label>
								<label  for="withfees0"  class="gsl-button radio" ><?php echo Text::_("JEV_NO"); ?><input class="inputbox gsl-hidden" type="radio" name="withfees"  id="withfees0"  value="0"   <?php echo!$this->item->withfees ? "checked='checked'" : ""; ?> onclick="rsvppro.hasFees(this)" /></label>
							</div>
						</div>
					</div>
					<div class="gsl-margin-small-bottom">
						<label class="gsl-form-label"><?php echo Text::_('RSVP_HAS_TICKETS'); ?> </label>
						<div class="gsl-form-controls" >
							<div class="radio gsl-button-group">
								<label  for="withticket1" class="gsl-button radio"><?php echo Text::_("JEV_YES"); ?><input class="inputbox  gsl-hidden" type="radio" name="withticket"  id="withticket1"  value="1"  <?php echo $this->item->withticket ? "checked='checked'" : ""; ?> onclick="rsvppro.hasTicket(this)" /></label>
								<label  for="withticket0" class="gsl-button radio"><?php echo Text::_("JEV_NO"); ?><input class="inputbox  gsl-hidden" type="radio" name="withticket"  id="withticket0"  value="0"   <?php echo!$this->item->withticket ? "checked='checked'" : ""; ?> onclick="rsvppro.hasTicket(this)" /></label>
							</div>
						</div>
					</div>
					<?php
					if (!Factory::getApplication()->input->getInt("customise"))
					{
						?>
						<div class="gsl-margin-small-bottom">
							<label class="gsl-form-label"><?php echo Text::_('RSVP_GLOBAL_TEMPLATE'); ?> </label>
							<div class="gsl-form-controls" >
								<div class="radio gsl-button-group">
									<label  for="global1" class="gsl-button radio"><?php echo Text::_("JEV_YES"); ?><input class="inputbox  gsl-hidden" type="radio" name="global"   id="global1" value="1"  <?php echo $this->item->global ? "checked='checked'" : ""; ?> /></label>
									<label  for="global0" class="gsl-button radio"><?php echo Text::_("JEV_NO"); ?><input class="inputbox  gsl-hidden" type="radio" name="global"   id="global0" value="0"   <?php echo!$this->item->global ? "checked='checked'" : ""; ?> /></label>
								</div>
							</div>
						</div>
						<?php
					}
					?>

					<?php
					// if this is a customisation do we want to copy any field translations
					if ($this->copyTranslations){
						?>
						<div  id="jevtemplate_fields_translations">
							<h3><?php echo Text::_('RSVP_FIELD_TRANSLATIONS'); ?></h3>
							<div class="gsl-margin-small-bottom">
								<label class="gsl-form-label"><?php echo Text::_('RSVP_COPY_FIELD_TRANSLATIONS'); ?></label>
								<div class="gsl-form-controls">
									<div class="radio gsl-button-group">
										<label  for="copytranslations1" class="gsl-button radio"><?php echo Text::_("JEV_YES"); ?><input class="inputbox  gsl-hidden" type="radio" name="copytranslations"  id="copytranslations1"  value="1"  /></label>
										<label  for="copytranslations0" class="gsl-button radio"><?php echo Text::_("JEV_NO"); ?><input class="inputbox  gsl-hidden" type="radio" name="copytranslations"  id="copytranslations0"  value="0"  checked='checked' /></label>
									</div>
								</div>
							</div>
						</div>
						<?php
					}
					?>

					<fieldset class='jevconfig <?php echo $this->item->withfees ? "" : "jevconfighidden"; ?>'>
						<legend class="toggleEnlarge">
							<?php echo Text::_('RSVP_CONFIG_PAYMENTS'); ?><span class="spanclosed"> [+]</span><span class="spanopen"> [-]</span>
						</legend>
						<div class="largeDetail">
							<div class="largeDetailContent">
								<?php
								$groups = $this->params->getFieldsets();
								if (count($groups) > 0)
								{
									?>
									<ul class="gsl-tab" id="paymentTabs" gsl-tab="connect: #rsvp-payment-tabs">
										<?php
										foreach ($groups as $group => $element)
										{
											$count = $this->params->getFieldCountByFieldSet($group);
											if ($group != "xmlfile" && $group != "RSVP_ATTENDANCE_MESSAGES" && $group != "RSVP_SESSION_OPTIONS" && $count > 0)
											{
												$active = (strtolower($group) == "rsvp_currency_formatting") ? ' class="active"' : '';
												?>
												<li  <?php echo $active; ?> ><a data-toggle="tab" href="#<?php echo strtolower(str_replace(array(" ","."), "_", $group)); ?>"><?php echo Text::_($group); ?></a></li>
												<?php
											}
										}
										?>
									</ul>
									<!-- Tabs themselves //-->
									<div class=" gsl-margin-remove gsl-card-body gsl-card-default gsl-padding gsl-width-expand">
										<ul class="gsl-switcher" id="rsvp-payment-tabs">

											<?php
											// Now the tab content

											foreach ($groups as $group => $element)
											{
												$count = $this->params->getFieldCountByFieldSet($group);
												if ($group != "RSVP_ATTENDANCE_MESSAGES" && $group != "RSVP_SESSION_OPTIONS" && $count > 0)
												{

													$customfields = array();
													$this->params->render('params', $group, $customfields);
													?>
													<li >
														<?php
														foreach ($customfields as $cf)
														{
															$showonstring = $cf['showon'];
															$datashowon = "";
															if ($showonstring && version_compare(JVERSION, '3.7.0', "ge"))
															{

																HTMLHelper::_('script', 'jui/cms.js', false, true);
																$showonarray = FormHelper::parseShowOnConditions($showonstring, 'params');

																$datashowon = ' data-showon=\'' . json_encode($showonarray) . '\'';
															}

															?>
															<div class="gsl-margin-small-bottom" style="clear:left" <?php echo $datashowon;?>>
																<div class='gsl-form-label'  >
																	<?php echo  $cf["label"]; ?>
																</div>
																<div class='gsl-form-controls'>
																	<?php echo $cf["input"];?>
																</div>
															</div>
															<?php
															if ($cf["type"] == "Editor")
															{
																$editorfields[] = $cf["name"];
															}
														}
														?>
													</li>
													<?php
												}
											}
											?>
										</ul>
									</div>
									<?php
								}
								else
								{
									echo $this->params->render();
								}
								?>
							</div>
						</div>
					</fieldset>

					<fieldset class='jevticket <?php echo $this->item->withticket ? "" : "jevtickethidden"; ?>'>
						<legend class="toggleEnlarge">
							<?php echo Text::_('RSVP_TICKET'); ?><span class="spanclosed"> [+]</span><span class="spanopen"> [-]</span>
						</legend>
						<div class="largeDetail">
							<div class="largeDetailContent">
								<div class="gsl-grid">
									<div class="gsl-width-1-2">
										<?php // ?>
								<h3><?php echo Text::_('RSVP_select_existing_ticket'); ?></h3>
								<?php
										JLoader::register('JevTypeahead',JPATH_LIBRARIES."/jevents/jevtypeahead/jevtypeahead.php");
										$datapath = Route::_("index.php?option=com_rsvppro&ttoption=com_rsvppro&typeaheadtask=gwejson&file=findtemplateticket", false);
										JevTypeahead::typeahead('#sessionticket',array('remote'=>  $datapath,
										                                               'data_value'=>'title',
										                                               'data_id' => 'id',
										                                               'field_selector'=>'#existingticket',
										                                               'minLength'=>3,
										                                               'limit'=>10,
										                                               'scrollable'=>1,
										));
										$typeaheadLoad = "var sessionTicketSelected = false;
                                jQuery(document).ready(function() {
                                    jQuery('#sessionticket').on
                                            (
                                            'typeahead:change',                                        
                                            function()
                                            {  
                                                sessionTicketSelected = false;
                                            }
                                    );
                                    jQuery('#sessionticket').on
                                            (
                                            'typeahead:select',
                                            function(ev, data)
                                            {   
                                                sessionTicketSelected = true;
                                                
                                                if (data.ticket != undefined){
                                                    ticketsEditorPlugin.replace('ticket', data.ticket);                   
                                                }
                                                if (data.ticketcss != undefined){
                                                    document.getElementById('ticketcss').value = data.ticketcss;
                                                }
                                                
                                            }                                        
                                    );
                                    jQuery('#sessionticket').on
                                            (
                                            'typeahead:close',
                                            function()
                                            {  
                                            }
                                    )
                                });
                                ";
											Factory::getDocument()->addScriptDeclaration($typeaheadLoad);
										?>
								<input type="hidden" name="existingticket" id="existingticket" value="" />
								<div id="scrollable-dropdown-menu">
									<input name="ticket_notused"  id="sessionticket" class="jevtypeahead" value=""  type="text" autocomplete="off" placeholder="<?php echo Text::_("RSVP_TEMPLATE_NAME"); ?>">
								</div>
								<?php // ?>
									</div>
									<div class="gsl-width-1-2">
									</div>
								</div>
								<?php
								$trimmedTicket = trim($this->item->ticket, " \n\r\t");
								if (strpos($trimmedTicket, '{INTRO}') !== false || strpos($trimmedTicket, '{/FOOTER}') !== false)
								{
									if (strpos($trimmedTicket, '{INTRO}') > 0 || strpos($trimmedTicket, '{/FOOTER}') < strlen($trimmedTicket) - strlen('{/FOOTER}'))
									{
										Factory::getApplication()->enqueueMessage(Text::_('COM_RSVPPRO_PROBLEMS_WITH_INTRO_OR_FOOTER_IN_TICKET'), 'warning');
									}
								}
								echo $ticketeditor->display('ticket', htmlspecialchars($this->item->ticket, ENT_QUOTES, 'UTF-8'), 500, 150, '70', '10', true);
								?>
								<h4><?php echo Text::_("RSVP_SELECT_FIELD_TO_INSERT"); ?> : </h4>
								<select onchange="ticketsEditorPlugin.insert('ticket','ticketfields' )" id="ticketfields">
									<option value="Select ...:">Select ...</option>
									<option value="INTRO}Overall Ticket Intro Here{/INTRO"><?php echo Text::_("RSVP_TICKET_INTRO"); ?></option>
									<option value="FOOTER}Overall Ticket FooterHere{/FOOTER"><?php echo Text::_("RSVP_TICKET_FOOTER"); ?></option>
									<optgroup label="<?php echo Text::_("RSVP_EVENT_FIELDS", true); ?>" >
										<option value="EVENT"><?php echo Text::_("RSVP_EVENT_TITLE"); ?></option>
										<option value="DATE}%Y %m %d{/DATE"><?php echo Text::_("RSVP_EVENT_DATE"); ?></option>
										<option value="TIME}%H:%M{/TIME"><?php echo Text::_("RSVP_EVENT_TIME"); ?></option>
										<option value="LOCATION"><?php echo Text::_("RSVP_EVENT_LOCATION"); ?></option>
										<option value="CATEGORY"><?php echo Text::_("RSVP_EVENT_CATEGORY");?></option>
										<option value="LINK}{EVENT}{/LINK"><?php echo Text::_("RSVP_EVENT_LINK"); ?></option>
										<option value="RAWLINK"><?php echo Text::_("RSVP_EVENT_LINK_RAW_URL"); ?></option>
										<option value="TOTALFEES"><?php echo Text::_("RSVP_TOTALFEES"); ?></option>
										<option value="FEESPAID"><?php echo Text::_("RSVP_FEESPAID"); ?></option>
										<option value="BALANCE"><?php echo Text::_("RSVP_BALANCE"); ?></option>
										<option value="CREATOR"><?php echo Text::_("RSVP_EVENT_CREATOR"); ?></option>
										<option value="REGDATE}%Y-%m-%d{/REGDATE"><?php echo Text::_("RSVP_EVENT_REGISTRATION_DATE"); ?></option>
										<option value="REGID}Ticket Number : %s{/REGID"><?php echo Text::_("RSVP_EVENT_REGISTRATION_ID"); ?></option>
										<option value="GUESTNUM}Guest Number : %s{/GUESTNUM"><?php echo Text::_("RSVP_EVENT_GUEST_NUMBER"); ?></option>
										<option value="GUESTNAME}Guest Name : %s{/GUESTNAME"><?php echo Text::_("RSVP_EVENT_GUEST_NAME"); ?></option>
										<option value="REGEMAIL}Registrant Email : %s{/REGEMAIL"><?php echo Text::_("RSVP_EVENT_REGISTRATION_EMAIL"); ?></option>
										<!--<option value="BARCODE"><?php echo Text::_("RSVP_EVENT_BARCODE"); ?></option>/-->
										<option value="QR"><?php echo Text::_("RSVP_EVENT_QRCODE"); ?></option>
										<option value="QRRESET"><?php echo Text::_("RSVP_EVENT_QRCODE_RESETTING"); ?></option>
										<option value="CUSTOM"><?php echo Text::_("RSVP_EVENT_CUSTOMFIELD_SUMMARY"); ?></option>
										<option value="VCUSTOM"><?php echo Text::_("RSVP_EVENT_CUSTOMFIELD_VERTICAL_SUMMARY");?></option>
										<option value="REPEATSUMMARY"><?php echo Text::_("RSVP_EVENT_REPEATSUMMARY"); ?></option>
									</optgroup>
									<optgroup label="<?php echo Text::_("RSVP_TEMPLATE_FIELDS", true); ?>" class="templatefields">
									</optgroup>
								</select>
								<div>
									<h3><?php echo Text::_('RSVP_TICKET_CSS'); ?></h3>
									<div>
									<textarea name="ticketcss" id="ticketcss" class="gsl-textarea" rows="10"><?php
										echo htmlspecialchars($this->item->ticketcss, ENT_QUOTES, 'UTF-8');
										?></textarea>
									</div>
								</div>
								<table cellpadding="5" cellspacing="0" border="0" >
									<?php
									$ticketparams = $this->templateparams->get("whentickets");
									if ($ticketparams == "")
									{
										?>
										<tr>
											<td colspan='2'>
												<h3 class='error' style="max-width: 500px;"><?php echo Text::_('RSVP_TICKETS_ONLY_FOR_FULLY_PAID_NO_MODIFY_NO_CANCEL_ATTENDEES');?><h3>
											</td>
										</tr>
										<?php
										$ticketparams = array("paidnochangecancel");
									}
									?>
									<tr>
										<td align="left" colspan="2"><h4><?php echo Text::_('RSVP_WHEN_OFFER_TICKETS'); ?> </h4></td>
									</tr>
									<tr>
										<td >
											<label><?php echo Text::_("RSVP_WHEN_CAN_STILL_BE_CANCELLED"); ?></label>
										</td>
										<td>
											<input class="inputbox  gsl-checkbox" type="checkbox" name="params[whentickets][]"  value="cancancel"  <?php echo in_array("cancancel", $ticketparams) ? "checked='checked'" : ""; ?> />
										</td>
									</tr>
									<tr>
										<td >
											<label><?php echo Text::_("RSVP_WHEN_CAN_STILL_BE_CHANGED"); ?></label>
										</td>
										<td>
											<input class="inputbox  gsl-checkbox" type="checkbox" name="params[whentickets][]"  value="canchange"  <?php echo in_array("canchange", $ticketparams) ? "checked='checked'" : ""; ?> />
										</td>
									</tr>
									<tr>
										<td >
											<label><?php echo Text::_("RSVP_WITH_OUTSTANDING_BALANCE"); ?></label>
										</td>
										<td>
											<input class="inputbox  gsl-checkbox" type="checkbox" name="params[whentickets][]"  value="outstandingbalance"   <?php echo in_array("outstandingbalance", $ticketparams) ? "checked='checked'" : ""; ?> />
										</td>
									</tr>
								</table>

							</div>
						</div>
					</fieldset>

					<fieldset class="jevtemplatefields">
						<legend class="toggleEnlarge">
							<?php echo Text::_('RSVP_TEMPLATE_FIELDS'); ?><span class="spanclosed"> [+]</span><span class="spanopen"> [-]</span>
						</legend>
						<div class="largeDetail">
							<div class="largeDetailContent">
								<div class="form-horizontal gsl-grid">

									<div class="gsl-width-1-2">
										<h3><?php echo Text::_('RSVP_Add_field'); ?></h3>
										<div id="jevtemplate_fields">
											<?php
											jimport("joomla.filesystem.folder");
											$templates = Folder::files(RSVP_ADMINPATH . "/fields/", ".php");
											if (Folder::exists(JPATH_ADMINISTRATOR."/components/com_rsvppro/customfields") &&  Folder::files(RSVP_ADMINPATH . "/customfields/", ".php")){
												$templates = array_merge($templates, Folder::files(RSVP_ADMINPATH . "/customfields/", ".php"));
											}

											$options = array();
											$freeoptions = array();
											$value = false;
											foreach ($templates as $template)
											{
												$type = str_replace(".php", "", $template);
												if (strpos($type, "JevrElement") === 0 || strpos($type, "jevr") !== 0 || strpos($type, ".zip") !== false || strpos($type, ".gz") !== false){
													continue;
												}
												if (!$value)
													$value = $type;
												if (File::exists(RSVP_ADMINPATH . "/fields/" . $template)) {
													include_once(RSVP_ADMINPATH . "/fields/" . $template);
												}
												else {
													include_once(RSVP_ADMINPATH . "/customfields/" . $template);
												}
												if (method_exists("FormField" . ucfirst($type), "isEnabled"))
												{
													if (!call_user_func(array("FormField" . ucfirst($type), "isEnabled")))
													{
														continue;
													}
												}
												call_user_func(array("FormField" . ucfirst($type), "loadScript"));
												$label = Text::_('RSVP_TEMPLATE_TYPE_' . $type);
												if ($label == 'RSVP_TEMPLATE_TYPE_' . $type && method_exists("FormField" . ucfirst($type), "fieldName"))
												{
													$label = call_user_func(array("FormField" . ucfirst($type), "fieldName"));
												}
												$options[] = HTMLHelper::_('select.option', $type, $label);
												if (!method_exists("FormField" . ucfirst($type), "paidOption") || !call_user_func(array("FormField" . ucfirst($type), "paidOption")))
												{
													$freeoptions[] = HTMLHelper::_('select.option', $type, $label);
												}
											}
											RsvpHelper::getFieldScript();

											$freelist = HTMLHelper::_('select.genericlist', $freeoptions, 'templatetype', 'class="rsvptemplatetype" size="1" ', 'value', 'text', $value, "templatetype");
											$fulllist = HTMLHelper::_('select.genericlist', $options, 'templatetype', 'class="rsvptemplatetype" size="1" ', 'value', 'text', $value, "templatetype");
											echo $this->item->withfees ? $fulllist : $freelist;
											?>
											<script type="text/javascript" >
                                                var freelist = <?php echo json_encode($freelist); ?>;
                                                var fulllist = <?php echo json_encode($fulllist); ?>;
											</script>
										</div>
										<input id="newFieldButton" type="button" class="gsl-button gsl-button-primary gsl-button-small" value="<?php echo Text::_("RSVP_CREATE_FIELD"); ?>"/>
										<input id="deleteFieldButton" type="button" class="gsl-button gsl-button-danger gsl-button-small deleteFieldButton" value="<?php echo Text::_("RSVP_DELETE_FIELD"); ?>" style='display:none' />
										<input id="closeFieldButton" type="button" class="gsl-button gsl-button-secondary gsl-button-small closeFieldButton" value="<?php echo Text::_("RSVP_CLOSE_FIELD"); ?>" style='display:none'/>
									</div>
									<div class="gsl-width-1-2">
										<h3><?php echo Text::_('RSVP_select_existing_field'); ?></h3>
										<?php
										JLoader::register('JevTypeahead',JPATH_LIBRARIES."/jevents/jevtypeahead/jevtypeahead.php");
										$datapath = Route::_("index.php?option=com_rsvppro&ttoption=com_rsvppro&typeaheadtask=gwejson&file=findtemplatefield", false);
										JevTypeahead::typeahead('#sessiontemplate',array('remote'=>  $datapath,
										                                                 'data_value'=>'title',
										                                                 'data_id' => 'id',
										                                                 'field_selector'=>'#existingfield',
										                                                 'minLength'=>3,
										                                                 'limit'=>10,
										                                                 'scrollable'=>1,
										));
										$typeaheadLoad = "var sessionTemplateSelected = false;
                                jQuery(document).ready(function() {
                                    jQuery('#sessiontemplate').on
                                            (
                                            'typeahead:change',                                        
                                            function()
                                            {  
                                                sessionTemplateSelected = false;
                                            }
                                    );
                                    jQuery('#sessiontemplate').on
                                            (
                                            'typeahead:select',
                                            function(ev, data)
                                            {   
                                                sessionTemplateSelected = true;
                                                
                                                if (data.html != undefined){                                                    
                                                    var id = rsvpforms.uniqId('field');
                                                    var newDiv = jQuery(data.html.replace('field'+data.id, id));

                                                    newDiv.on('click',function(event){
                                                            if (jQuery(event.target).hasClass('sortable-handler')){
                                                                    return;
                                                            }
                                                            rsvpforms.highlightField(id);
                                                    })
                                                    // update the label preview
                                                    newDiv.find('.rsvpfl').on('change',function(){
                                                            jQuery('#pl'+id).html(this.value);
                                                    });
                                                    jQuery('#rsvpfields').append(newDiv);

                                                    // make sure this field is highlighted and others not
                                                    rsvpforms.highlightField(id);
                                                    rsvpforms.setupSortableFields();
                                                    rsvpforms.fieldsHaveReordered();

                                                    // make sure fees are shown/hidden accordingly
                                                    rsvppro.toggleFees();

                                                    if (conditionalEditorPlugin) {
                                                            rsvpforms.setupConditionalOptions();
                                                            conditionalEditorPlugin.update(id, '');
                                                    }

													try {
                                                    jQuery('select').chosen({
                                                            disable_search_threshold : 10,
                                                            allow_single_deselect : true
                                                    });
                                                    }
                                                   catch (e)
                                                   {}

                                                    setupRSVPTemplateBootstrap();
                                                     jQuery('#sessiontemplate').eq(0).val('').trigger('input');
                                                }
                                                
                                            }                                        
                                    );
                                    jQuery('#sessiontemplate').on
                                            (
                                            'typeahead:close',
                                            function()
                                            {  
                                                var title = jQuery('#sessiontemplate').val();
                                                var id = jQuery('#existingfield').val();
                                                if (title.indexOf('#')>0 || title.length==0){
                                                }
                                                else if (sessionTemplateSelected) {
                                                    jQuery('#sessiontemplate').eq(0).val(title+'#').trigger('input');
                                                }
                                            }
                                    )
                                });
                                ";
										Factory::getDocument()->addScriptDeclaration($typeaheadLoad);
										?>
										<input type="hidden" name="existingfield" id="existingfield" value="" />
										<div id="scrollable-dropdown-menu">
											<input name="template_notused"  id="sessiontemplate" class="jevtypeahead" value=""  type="text" autocomplete="off" placeholder="<?php echo Text::_("RSVP_TEMPLATE_COLON_FIELD"); ?>">
										</div>
									</div>
								</div>
								<div id="rsvpfields">
									<?php
									foreach ($this->item->fields as $field)
									{
										$fieldhtml = $field->html;
										?>
										<div class='rsvpfield' id='field<?php echo $field->field_id; ?>'>
											<span class="sortable-handler gsl-icon" gsl-icon="icon:move" style="cursor: move;float:left;"></span>
											<input id="deleteFieldButtonfield<?php echo $field->field_id; ?>" type="button" value="<?php echo Text::_("RSVP_DELETE_FIELD"); ?>" class="gsl-button gsl-button-danger gsl-button-small gsl-margin-small-bottom deleteFieldButton"/>
											<input id="closeFieldButtonfield<?php echo $field->field_id; ?>" type="button" value="<?php echo Text::_("RSVP_CLOSE_FIELD"); ?>" class="gsl-button gsl-button-secondary gsl-button-small gsl-margin-small-bottom closeFieldButton"/>
											<?php
											echo $fieldhtml;
											?>
										</div>
										<?php
									}
									?>
								</div>
							</div>
						</div>
					</fieldset>

					<fieldset class='jevmessages'>
						<legend class="toggleEnlarge">
							<?php echo Text::_('RSVP_CUSTOM_MESSAGES'); ?><span class="spanclosed"> [+]</span><span class="spanopen"> [-]</span>
						</legend>
						<div class="largeDetail">
							<div class="largeDetailContent">
								<?php
								$groups = $this->params->getFieldsets();
								foreach ($groups as $group => $element)
								{
									$count = $this->params->getFieldCountByFieldSet($group);
									if ($group == "RSVP_ATTENDANCE_MESSAGES" && $count > 0)
									{
										$customfields = array();
										$this->params->render('params', $group, $customfields);
										foreach ($customfields as $cf)
										{
											?>
											<div  class="gsl-margin-small-bottom" style="clear:left">
												<div class='gsl-form-label' <?php echo RsvpHelper::showOnRelField($cf);?> >
													<?php echo $cf["label"];?>
												</div>
												<div class='gsl-form-controls'>
													<?php echo $cf["input"];?>
												</div>
											</div>
											<?php
											if ($cf["type"] == "Editor")
											{
												$editorfields[] = $cf["name"];
											}
										}
									}
								}
								?>
							</div>
						</div>
					</fieldset>

					<?php
					// sesssion options
					ob_start();
					$groups = $this->params->getFieldsets();
					foreach ($groups as $group => $element)
					{
						$count = $this->params->getFieldCountByFieldSet($group);
						if ($group == "RSVP_SESSION_OPTIONS" && $count > 0)
						{
							unset($customfields);
							$customfields = array();
							$this->params->render('params', $group, $customfields);
							foreach ($customfields as $cf)
							{
								?>
								<div  class="gsl-margin-small-bottom" style="clear:left">
									<div class='gsl-form-label'  >
										<?php echo $cf["label"];?>
									</div>
									<div class='gsl-form-controls'>
										<?php echo $cf["input"];?>
									</div>
								</div>
								<?php
								if ($cf["type"] == "Editor")
								{
									$editorfields[] = $cf["name"];
								}
							}
						}
					}
					$sessionoptions = ob_get_clean();
					if ($sessionoptions != "")
					{
						?>
						<fieldset class='jevsessionoptions'>
							<legend class="toggleEnlarge">
								<?php echo Text::_('RSVP_SESSION_OPTIONS'); ?><span class="spanclosed"> [+]</span><span class="spanopen"> [-]</span>
							</legend>
							<div class="largeDetail">
								<div class="largeDetailContent">
									<?php echo $sessionoptions; ?>
								</div>
							</div>
						</fieldset>
						<?php
					}
					?>

				</div>
			</div>
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="task" value="defaults.edit" />
			<input type="hidden" name="act" value="" />
			<input type="hidden" name="option" value="<?php echo RSVP_COM_COMPONENT; ?>" />
			<input type="hidden" name="Itemid" value="<?php echo Factory::getApplication()->input->getInt("Itemid", 0); ?>" />
			<?php
			if (Factory::getApplication()->input->getString("tmpl") == "component")
			{
				?>
				<input type="hidden" name="tmpl" value="component" />
			<?php } ?>
		</form>
	</div>
</div>

<?php
// make sure the form isn't too big!'
$max_input_vars = intval(@ini_get("max_input_vars"));
if ($max_input_vars == 0)
{
	$max_input_vars = 999999;
}
?>
<script type="text/javascript">
    var inputvars = document.querySelectorAll('#adminForm input');
    var selectvars = document.querySelectorAll('#adminForm select');
    var textareavars = document.querySelectorAll('#adminForm textarea');
    if(inputvars.length+ selectvars.length+textareavars.length > <?php echo $max_input_vars; ?> * 0.90 ){
        alert("<?php echo Text::_("RSVP_FORM_GETTING_CLOSE_TO_MAXIMUM_SIZE_CHECK_HTACESS_SETTINGS", true) ?>\n"+(inputvars.length+ selectvars.length+textareavars.length)+"  vs " + <?php echo $max_input_vars; ?>);
    }
</script>
