var regTabs = {};
regTabs.needtoSetupAttendeeNames = false;
regTabs.uikit = false;
regTabs.bs2 = false;
regTabs.bs3 = false;
regTabs.bs4 = false;

regTabs.initialise = function (element, options) {

	this.options = options;

	this.el = jQuery("#" + element);
	this.elid = element;

	this.activeTitle = false;

	this.titles = jQuery('#' + this.elid + ' ul.nav-tabs li a');

	if (typeof UIkit !== 'undefined')
	{
		regTabs.uikit = true;
		var navTabs = document.querySelector('#' + element + ' > ul.nav-tabs');
		if (navTabs) {
			navTabs.classList.remove('nav-tabs');
			navTabs.classList.remove('nav');
			UIkit.tab(navTabs);
		}
	}

	this.titles.each(function (index, title) {

		jQuery(title).on('click', function (e) {
			if (regTabs.uikit) {
				regTabs.activate(jQuery(this));
			}
			else
			{
				e.preventDefault();
				regTabs.activate(jQuery(this));
				return false;
			}
		});
	});


	this.panelHeight = this.el.height() - (jQuery(this.titles[0]).height() + 4);
	if (this.panelHeight < 0) {
		// This causes problems in MSIE7
		//this.panelHeight = "50";
	}

	// We may need to set up the initial attendee names but could not do so until the tabs were initialised
	if (this.needtoSetupAttendeeNames) {
		this.setInitialAttendeeNames();
	}

	if (this.options.activateOnLoad != 'none')
	{
		if (this.options.activateOnLoad == 'tab0')
		{
			this.activate(this.titles[0], 0);
		}
		else
		{
			this.activate(this.options.activateOnLoad, 0);
		}
	}
};

regTabs.addTab = function (title, label, count, skipScroll) {
	//the new title
	var newTitle = jQuery('<li class="nav-item">', {
		title: title
	});
	var newTitleLink = false;
	if (regTabs.uikit) {
		label += '<button type="button" class="uk-margin-small-left uk-close" data-uk-close></button>';
		 newTitleLink = jQuery('<a href="#attendeetab' + (count-1)  + '" class="nav-link">' + label + '</a>');
	}
	else if (regTabs.bs4 ) {
		label += '<button type = "button" class = "close ml-2"	aria-label = "Close" ><span aria-hidden="true" >&times;</span></button>';
		newTitleLink = jQuery('<a href="#attendeetab' + (count-1)  + '" data-toggle="tab" class="nav-link">' + label + '</a>');
	}
	else if (regTabs.bs2 || regTabs.bs3) {
		label += '<button type = "button" class = "close"	style="margin-left:15px" aria-label = "Close" ><span aria-hidden="true" >&times;</span></button>';
		newTitleLink = jQuery('<a href="#attendeetab' + (count-1)  + '" data-toggle="tab" class="nav-link">' + label + '</a>');
	}
	newTitle.append(newTitleLink);

	jQuery('#' + this.elid + ' ul.nav-tabs, #' + this.elid + ' ul.uk-tab').append(newTitle);
	this.titles = jQuery('#' + this.elid + ' ul.nav-tabs li a,#' + this.elid + ' ul.uk-tab li a' );

	jQuery('#' + this.elid + ' ul.nav-tabs button.close, #' + this.elid + ' ul.uk-tab .uk-close').on('click', function(e)
	{
		regTabs.activate(jQuery(e.target).parents('.nav-link'));
		regTabs.removeActiveTab();

		// recalculate the fees!
		try {
			JevrFees.calculate(document.updateattendance);
		}
		catch (e)
		{

		}

		return false;
		//regTabs.removeTab(jQuery(e.target).parents('.nav-link'));
		//regTabs.activate(regTabs.titles[0], 0);
	});

	newTitleLink.on('click', function (e) {
		if (regTabs.uikit) {
			regTabs.activate(jQuery(this));
		}
		else
		{
			e.preventDefault();
			regTabs.activate(jQuery(this));
			return false;
		}
	});

	//Now for the form content!
	var elems = jQuery(".paramtmpl");
	elems.each(function (index, item) {
		item = jQuery(item);
		// do not clone elements whose parents are also to be cloned - otherwise we may get duplicate elements
		if (item.parent().hasClass("paramtmpl") || item.parent().parent().hasClass("paramtmpl")) {
			return;
		}
		var clone = item.clone();
		// radio boxes etc. have their own ids set and cloning will drop these to avoid double ids with the same values so we replace the innerHTML
		if ((!clone.attr('name') || !clone.attr('id')) && item.html() != "") {
			var html = item.html();
			// For the radio lists etc only
			html = html.replace(/\'xxxyyyzzz\'/g, (count - 1));
			html = html.replace(/xxxyyyzzz/g, (count - 1));
			html = html.replace(/paramtmpl_/g, "");
			html = html.replace(/paramtmpl/g, "");
			// fix the ID for radio fields!
			clone.html(html.replace(/_xxx/g, "_" + (count - 1)));
		}
		clone.removeClass("paramtmpl");
		clone.addClass("rsvpparam");
		clone.addClass("rsvpparam" + (count - 1));
		// replace id and names
		if (item.attr('id')) {
			var cloneid = item.attr('id').replace("xxxyyyzzz", (count - 1));
			clone.attr('id', cloneid.replace("xxx", (count - 1)));
		}
		if (item.attr('name')) {
			clone.attr('name', item.attr('name').replace("paramtmpl_", ""));
		}
		// insert the clone in the DOM
		//clone.insertAfter(item);
		item.parent().append(clone);

		// Clear up Chosen Mess
		// must search on non-clone first to get the chosen data attribute!
		var chosenElements = jQuery(item).find('*').filter(function(){return jQuery(this).data('chosen') !== undefined;});
		if (chosenElements.length){
			jQuery(clone).find('.chzn-container').remove();
			jQuery(clone).find('select').chosen('destroy');
			jQuery(clone).find('select').chosen({
				disable_search_threshold : 10,
				allow_single_deselect : true
			});
		}

		jQuery(clone).find("input[type='radio']").each(function (index, elem)
		{
			var label = document.querySelector('[for="' + elem.id + '"]');
			if (label) {
				rsvppro_toggleRadio(elem);
			}
		});


	});

	// scroll into view - see
	if (!skipScroll){
		newTitleLink[0].scrollIntoView();
	}

	// activate the new tab
	this.activate(newTitleLink);
};

regTabs.activate = function (activetab) {
	if (jQuery.type(activetab) == 'string') {
		myTab = jQuery('#' + this.elid + ' ul a[href="#' + activetab + '"]');
		activetab = myTab;
		this.activeTitle = myTab;
	}

	if (jQuery.type(activetab) == 'object') {
		try {
			if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4) {
				activetab.tab('show');
			}
		} catch (e) {

		}
		this.activeTitle = activetab;
		var activeTabId = 0;
		this.titles.each(function (index, item) {
			if (jQuery(item).parent().attr('title') == jQuery(activetab).parent().attr('title')) {
				activeTabId = parseInt(activetab.attr('href').replace("#attendeetab", ""), 10);
			}
		});
		if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4) {
			activetab.parent().addClass('active');
		} else {
			//activetab.parent().addClass('uk-active');
		}
		this.activeTab = activetab;
		var pane = jQuery("#registration-tab-pane");
		if (activeTabId == 0) {
			// first find the rows that only apply to the first attendee and display these
			var elems = pane.find(".type0param");
			elems.each(function (index, elem) {
				jQuery(elem).removeClass("type0paramHidden");
			});

			// next find the rows that apply to the second and over and display there
			elems = pane.find(".type2param");
			elems.each(function (index, elem) {
				jQuery(elem).addClass("type2paramHidden");
			});

		} else {
			// first find the rows that only apply to the first attendee and hide these
			var elems = pane.find(".type0param");
			elems.each(function (index, elem) {
				jQuery(elem).addClass("type0paramHidden");
			});

			// next find the rows that apply to the second and over and display there
			elems = pane.find(".type2param");
			elems.each(function (index, elem) {
				jQuery(elem).removeClass("type2paramHidden");
			});

		}

		// next find the rows that apply to the second and over and display there
		elems = pane.find(".type1param");
		if (pane.find(".type2param").length > 0) {
			// this doesn't work in Chrome - must be a Mootools bug!'
			//  elems.extend(pane.querySelectorAll(".type2param"));
			pane.find(".type2param").each(function (index, elem) {
				elems.push(elem);
			});
		}
		elems.each(function (index, elem) {
			var paramelements = jQuery(elem).find('.rsvpparam');
			var e = 0;
			paramelements.each(function (pindex, pelem) {
				if (jQuery(pelem).hasClass("rsvpparam" + activeTabId)) {
					jQuery(pelem).removeClass("hideparam");
				} else {
					jQuery(pelem).addClass("hideparam");
				}
				e++;
			});
		});

		if (jQuery("#killguest").length) {
			var killguest = document.getElementById("killguest");
			var killguestParent = killguest.parentNode;
			if (activeTabId > 0) {
				killguest.classList.add('show-kill-guest');
				if (regTabs.uikit) {
					killguestParent.classList.remove('uk-display-inline');
					killguestParent.classList.add('uk-button-group');
				}
			}
			else {
				killguest.classList.remove('show-kill-guest');
				if (regTabs.uikit) {
					killguestParent.classList.add('uk-display-inline');
					killguestParent.classList.remove('uk-button-group');
				}
			}
		} else if (pane.find(".nav-tabs, .uk-tab").length) {
			pane.find(".nav-tabs, .uk-tab").css('display', 'none');
		}

		// Setup labels for values
		var labels = jQuery("#registration-tab-pane .paramlist_key label");
		labels.each(function (lidx, lab) {
			var $lab = jQuery(lab);
			if ($lab.attr("for").indexOf("xmlfile_field") == 0) {
				if (typeof $lab.attr("data-id") == "undefined") {
					$lab.attr("data-id", $lab.attr("for"));
				}
				if (jQuery("#" + $lab.attr("data-id") + "_" + activeTabId).length) {
					$lab.attr("for", $lab.attr("data-id") + "_" + activeTabId);
				}
			}
		});
	}

	if (regTabs.uikit) {
		var activeNavTabsLi = document.querySelector('#' + regTabs.elid + ' > ul.uk-tab > .nav-item.uk-active');
		if (activeNavTabsLi) {
			activeNavTabsLi.classList.remove('uk-active');
			activeNavTabsLi.classList.remove('active');
			activeNavTabsLi.querySelector('a').classList.remove('active');
		}
		// regTabs.activeTitle is jquery
		regTabs.activeTitle[0].parentNode.classList.add('uk-active');
	}
	if (JevrConditionalFields) {
		JevrConditionalFields.setup(false);
	}

};

regTabs.bsStyling = function() {
	try {
		if (typeof jQuery.fn.alert.Constructor == 'function' && typeof jQuery.fn.alert.Constructor.VERSION == 'undefined')
		{
			regTabs.bs2 = true;
		}
		else {
			var version = jQuery.fn.tooltip.Constructor.VERSION;
			var parts = version.split('.');
			if (parts.length > 0 && parts[0] == 3) {
				regTabs.bs3 = true;
			} else if (parts.length > 0 && parts[0] == 4) {
				regTabs.bs4 = true;
			}
		}
	}
	catch (e) {
		//alert(jQuery.fn.alert.Constructor.VERSION);
		var bootstrap3_enabled = (typeof jQuery().emulateTransitionEnd == 'function');
		if (typeof window.jQuery == 'undefined' || typeof jQuery().emulateTransitionEnd !== 'function') {
			regTabs.bs3 = false;
		} else {
			regTabs.bs3 = true;
		}
	}

	// bs3/bs4 styling
	if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4)
	{
		var actualTabs = document.querySelectorAll("#registration-tab-pane li.nav-item:not(:first-child) a.nav-link");
		actualTabs.forEach(function(tab) {

			if (regTabs.bs4 ) {
				tab.innerHTML += '<button type = "button" class = "close ml-2"	aria-label = "Close" ><span aria-hidden="true" >&times;</span></button>';
			}
			else if (regTabs.bs2 || regTabs.bs3) {
				tab.innerHTML += '<button type = "button" class = "close"	style="margin-left:15px" aria-label = "Close" ><span aria-hidden="true" >&times;</span></button>';
			}
			jQuery(tab).find('.uk-close, .close').on('click', function (e) {
				regTabs.activate(jQuery(e.target).parents('.nav-link'));
				regTabs.removeActiveTab();
				return false;
			});

		});


		var formElements = document.querySelectorAll('#updateattendance, .paymentmethod');
		formElements.forEach(function (formElement) {
			var inputs = false;
			inputs = formElement.querySelectorAll('select:not(.uk-select)');
			inputs.forEach (function(elem){
				// only works in BS4
				elem.classList.add('mt-2');
				// BS3
				if (regTabs.bs2 || regTabs.bs3) {
					elem.style.marginTop = "0.6rem";
				}

				//elem.classList.add('uk-select');
				//elem.classList.add('uk-form-width-medium');
			});
			inputs = formElement.querySelectorAll('input[type="text"]:not(.uk-input)');
			inputs.forEach (function(elem){
				// only works in BS4
				elem.classList.add('mt-2');
				// BS3
				if (regTabs.bs2 || regTabs.bs3) {
					elem.style.marginTop = "0.6rem";
				}

				//elem.classList.add('uk-input');
				//elem.classList.add('uk-form-width-medium');
				//elem.removeAttribute('size');
			});

			inputs = formElement.querySelectorAll('input[type="radio"]:not(.uk-radio)');
			inputs.forEach (function(elem){
				var label = document.querySelector('[for="' + elem.id + '"]');
				if (label)
				{
					rsvppro_toggleRadio(elem);
				}
				else {
					//elem.classList.add('uk-radio');
				}
			});
		//	alert('check checkboxes and add config option');
			inputs = formElement.querySelectorAll('input[type="xxxcheckbox"]:not(.uk-checkbox)');
			inputs.forEach (function(elem){
				var label = document.querySelector('[for="' + elem.id + '"]');
				if (label)
				{
					rsvppro_toggleCheckboxBS(elem);
				}

				// DON'T search for nearest span otherwise checkboxes look like radio boxes - all joined up!
				var group = label.closest('.paramlist_value');
				if (group) {
					if (!regTabs.bs2) {
						group.classList.add('btn-group');
					}
					// only works in BS4
					group.classList.add('mt-2');
					// BS3
					if (regTabs.bs2 || regTabs.bs3) {
						group.style.marginTop = "0.6rem";
					}
			}

			});
			inputs = formElement.querySelectorAll('textarea:not(.uk-textarea)');
			inputs.forEach (function(elem){
				// only works in BS4
				elem.classList.add('mt-2');
				// BS3
				if (regTabs.bs2 || regTabs.bs3) {
					elem.style.marginTop = "0.6rem";
				}

				//elem.classList.add('uk-textarea');
				//elem.classList.add('uk-form-width-medium');
			});
/*
			var jevbootstrap = document.querySelectorAll('.jevbootstrap');
			jevbootstrap.forEach(function(elem) {
				elem.classList.remove('jevbootstrap');
			})
*/
			// Payment method needs to move to a template file!
			var paybalance = formElement.querySelector('.paybalance');
			if (paybalance)
			{
				paybalance.classList.remove('button2-left');
				paybalance = paybalance.querySelector('button');
				paybalance.classList.add('btn');
				paybalance.classList.add('btn-primary');
			}

		});
	}
};

regTabs.uikitStyling = function() {
	if (typeof UIkit !== 'undefined')
	{
		regTabs.uikit = true;
	}

	// uikit styling
	if (this.uikit)
	{
		var formElements = document.querySelectorAll('#updateattendance, .paymentmethod');
		formElements.forEach(function (formElement) {
			var inputs = formElement.querySelectorAll('select:not(.uk-select)');
			inputs.forEach (function(elem){
				elem.classList.add('uk-select');
				elem.classList.add('uk-form-width-medium');
			});
			inputs = formElement.querySelectorAll('input[type="text"]:not(.uk-input)');
			inputs.forEach (function(elem){
				elem.classList.add('uk-input');
				elem.classList.add('uk-form-width-medium');
				elem.removeAttribute('size');
			});
			inputs = formElement.querySelectorAll('input[type="radio"]:not(.uk-radio)');
			inputs.forEach (function(elem){
				var label = document.querySelector('[for="' + elem.id + '"]');
				if (label)
				{
					rsvppro_toggleRadio(elem);
				}
				else {
					elem.classList.add('uk-radio');
				}
			});
			// see below too - we are using uk-checkbox - we don't need both!
			inputs = formElement.querySelectorAll('input[type="xxxcheckbox"]:not(.uk-checkbox)');
			inputs.forEach (function(elem){
				var label = document.querySelector('[for="' + elem.id + '"]');
				if (label)
				{
					rsvppro_toggleCheckboxUIkit(elem);
				}
				else
				{
					elem.classList.add('uk-checkbox');
				}
			});
			// this is what you should see
			inputs = formElement.querySelectorAll('input[type="checkbox"]:not(.uk-checkbox)');
			inputs.forEach (function(elem){
				elem.classList.add('uk-checkbox');
			});

			inputs = formElement.querySelectorAll('textarea:not(.uk-textarea)');
			inputs.forEach (function(elem){
				elem.classList.add('uk-textarea');
				elem.classList.add('uk-form-width-medium');
			});

			var jevbootstrap = document.querySelectorAll('.jevbootstrap');
			jevbootstrap.forEach(function(elem) {
				elem.classList.remove('jevbootstrap');
			});

			// Payment method needs to move to a template file!
			var paybalance = formElement.querySelector('.paybalance');
			if (paybalance)
			{
				paybalance.classList.remove('button2-left');
				paybalance.classList.add('uk-display-inline-block');
				paybalance = paybalance.querySelector('button');
				paybalance.classList.add('uk-button');
				paybalance.classList.add('uk-button-primary');
			}

		});
	}
};

regTabs.removeActiveTab = function () {
	this.removeTab(this.activeTab);
};

regTabs.removeTab = function (tabToGo) {
	if (this.activeTab == tabToGo)
	{
		this.activate(jQuery(this.titles[0]));
		//this.activate(this.titles[0].href.substr(this.titles[0].href.indexOf("#")+1));
		//alert(this.titles[1].href.substr(this.titles[1].href.indexOf("#")+1));
		//this.activate(this.titles[1].href.substr(this.titles[1].href.indexOf("#")+1));
	}
	tabToGo.parent().remove();
	this.titles = jQuery('#' + this.elid + ' ul.nav-tabs li a, #' + this.elid + ' ul.uk-tab li a');

	// Now remove the form content!
	// find the relevant form entries
	var tabcounter = parseInt(tabToGo.attr('href').replace("#attendeetab",""), 10);
	var paramelements = jQuery("#registration-tab-pane .rsvpparam" +tabcounter);

	var e = 0;
	paramelements.each(function (pindex, pelem) {
		//jQuery(pelem).parent().removeChild(pelem);
		jQuery(pelem).remove();
		e++;
	});

	// update the guest count
	jQuery('#guestcount').val(this.titles.length);

	return;

	//this.activate(this.titles[0], 0);

};

regTabs.setInitialAttendeeNames = function () {
	if (!regTabs.titles){
		this.needtoSetupAttendeeNames = true;
		return;
	}
	var nameattendeenames = jQuery(".attendeename");
	var attendeecount = 1;
	nameattendeenames.each(function(atidx, attendeename){
		attendeename = jQuery(attendeename);
		var fieldid = attendeename.attr('id').replace('params', '').replace('xmlfile_', '');
		if (fieldid.indexOf("_xxx") < 0 && fieldid.indexOf("field") == 0 && fieldid.indexOf("_") > 0 && !attendeename.hasClass('disabledfirstparam')){
			fieldid = fieldid.split("_");
			if (regTabs.titles[fieldid[1]]){
				regTabs.titles[fieldid[1]] = jQuery(regTabs.titles[fieldid[1]]);
				if (attendeename.val() == ""){
					jQuery(regTabs.titles[fieldid[1]]).html(jQuery("#jevnexttabtitle").val().replace('xxx', attendeecount));
				}
				else {
					jQuery(regTabs.titles[fieldid[1]]).html(attendeename.val());
				}
				if(atidx > 0 && regTabs.uikit) {
					regTabs.titles[fieldid[1]].html(regTabs.titles[fieldid[1]].html() + '<button type="button" class="uk-margin-small-left uk-close" data-uk-close></button>');
					regTabs.titles[fieldid[1]].find('.uk-close').on('click', function(e)
					{
						regTabs.activate(jQuery(e.target).parents('.nav-link'));
						regTabs.removeActiveTab();
						return false;
						//regTabs.removeTab(jQuery(e.target).parents('.nav-link'));
						//regTabs.activate(regTabs.titles[0], 0);
					});
				}
				else if(atidx > 0)
				{
					regTabs.titles[fieldid[1]].html(regTabs.titles[fieldid[1]].html() + '<button type = "button" class = "close"	style="margin-left:15px" aria-label = "Close" ><span aria-hidden="true" >&times;</span></button>');
					regTabs.titles[fieldid[1]].find('.close').on('click', function(e)
					{
						regTabs.activate(jQuery(e.target).parents('li'));
						regTabs.removeActiveTab();
						return false;
						//regTabs.removeTab(jQuery(e.target).parents('.nav-link'));
						//regTabs.activate(regTabs.titles[0], 0);
					});
				}

			}
		}
		attendeecount++;
	});
};

function setAttendeeName(field) {
	try {
		if (regTabs.activeTitle && field.value != "") {
			var activeTabId = parseInt(regTabs.activeTitle.attr('href').replace("#attendeetab",""), 10);
			if (activeTabId > 0) {
				if (regTabs.uikit) {
					jQuery(regTabs.activeTitle).html(field.value + '<button type="button" class="uk-margin-small-left uk-close" data-uk-close></button>');
				}
				else if (regTabs.bs4 ) {
					button = '<button type = "button" class = "close ml-2"	aria-label = "Close" ><span aria-hidden="true" >&times;</span></button>';
					jQuery(regTabs.activeTitle).html(field.value + button);
				}
				else if (regTabs.bs2 || regTabs.bs3) {
					button =  '<button type = "button" class = "close"	style="margin-left:15px" aria-label = "Close" ><span aria-hidden="true" >&times;</span></button>';
					jQuery(regTabs.activeTitle).html(field.value + button);
				}
				regTabs.activeTitle.find('.uk-close, .close').on('click', function (e) {
					regTabs.activate(jQuery(e.target).parents('.nav-link'));
					regTabs.removeActiveTab();
					return false;
				});

			}
			else {
				jQuery(regTabs.activeTitle).html(field.value );
			}
		}
	}
	catch (e) {
	}
}

/*

 mootabs.prototype.removeTab =  function(title){
 if(this.activeTitle.title == title)
 {
 this.activate(this.titles[0]);
 }
 try {
 this.activeTitle.remove();
 }
 catch (e){
 this.activeTitle.dispose();
 }

 // Now remove the form content!
 // find the relevant form entries
 var pane = $("registration-tab-pane");
 var paramelements = pane.querySelectorAll('.rsvpparam'+this.activeTab);
 var e = 0;
 paramelements.each(function(pelem){
 pelem.parentNode.removeChild(pelem);
 e++;
 });

 this.activate(this.titles[0], 0);

 }

 mootabs.prototype.next = function(){
 var nextTab = this.activeTitle.getNext();
 if(!nextTab) {
 nextTab = this.titles[0];
 }
 this.activate(nextTab);
 }

 mootabs.prototype.setTitle =  function (title, label) {
 $$('#' + this.elid + ' ul li').filterByAttribute('title', '=', title)[0].innerHTML = label;
 }

 mootabs.prototype.previous =  function(){
 var previousTab = this.activeTitle.getPrevious();
 if(!previousTab) {
 previousTab = this.titles[this.titles.length - 1];
 }
 this.activate(previousTab);
 }

 });
 }



 */

/*
function doMyCheck(form, item)
{
// you can change the required message if you want
item.reqmsg = 'A problem with this input';
// it fails
return false;
}
window.addEventListener('load', function () {
jQuery(jevrsvpRequiredFields.fields).each(function (i, item) {
jQuery('.attendeename').each(function(elemidx, elem)
{
    if (elem.id == item.id) {
        item.requiredCheckScript = 'doMyCheck';
    }
});
});
});
*/


function rsvppro_toggleRadios(target)
{
	if (regTabs.uikit) {
		rsvppro_toggleRadiosUIkit(target);
	}
	if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4 ) {
		rsvppro_toggleRadiosBS(target);
	}

}
function rsvppro_toggleRadiosUIkit(target)
{
	var parentNode = target.parentNode;
	if (!parentNode.classList.contains('uk-button-group') && !parentNode.classList.contains('uk-display-inline'))
	{
		parentNode = target.parentNode.parentNode;
	}
	if (!parentNode.classList.contains('uk-button-group') && !parentNode.classList.contains('uk-display-inline'))
	{
		parentNode = target.closest('.uk-button-group');
		if (!parentNode)
		{
			parentNode = target.closest('.uk-display-inline');
			return;
		}
	}
	if (parentNode.classList.contains('uk-button-group') ||  parentNode.classList.contains('uk-display-inline'))
	{
		var inputNodes = parentNode.querySelectorAll('input');
		for (var i = 0; i < inputNodes.length; i++)
		{
			var label = parentNode.querySelector('[for="' + inputNodes[i].id + '"]');
			if (label)
			{
				var activeClass = inputNodes[i].getAttribute('data-activeclass');
				if (inputNodes[i].checked)
				{
					if (activeClass)
					{
						label.classList.add('uk-button-' + activeClass);
					}
					else if (inputNodes[i].value == 0)
					{
						label.classList.add('uk-button-danger');
					}
					else
					{
						label.classList.add('uk-button-primary');
					}
				}
				else
				{
					if (activeClass)
					{
						label.classList.remove('uk-button-' + activeClass);
					}
					label.classList.remove('uk-button-primary');
					label.classList.remove('uk-button-danger');
				}
			}
		}
	}

}

function rsvppro_toggleRadiosBS(target)
{
	parentNode = target.closest('.btn-group ');
	if (!parentNode)
	{
		return;
	}

	if (parentNode.classList.contains('btn-group'))
	{

		var inputNodes = parentNode.querySelectorAll('input');
		for (var i = 0; i < inputNodes.length; i++)
		{
			var label = parentNode.querySelector('[for="' + inputNodes[i].id + '"]');
			if (label)
			{
				var activeClass = inputNodes[i].getAttribute('data-activeclass');
				if (inputNodes[i].checked)
				{
					if (activeClass)
					{
						label.classList.add('btn-' + activeClass);
					}
					else if (inputNodes[i].value == 0)
					{
						label.classList.add('btn-danger');
					}
					else
					{
						label.classList.add('btn-primary');
					}
					// doesn't matter about not checking bs type
					label.classList.remove('btn-default');
					label.classList.remove('btn-secondary');

				}
				else
				{
					if (activeClass)
					{
						label.classList.remove('btn-' + activeClass);
					}
					label.classList.remove('btn-primary');
					label.classList.remove('btn-danger');

					if (regTabs.bs2 || regTabs.bs3) {
						label.classList.add('btn-default');
					}
					else if (regTabs.bs4)
					{
						label.classList.add('btn-secondary');
					}

				}
			}
		}
	}

}

function rsvppro_toggleRadio(target)
{
	var label = document.querySelector('.paramlist_value label[for="' + target.id + '"]');
	if (label)
	{
		if (regTabs.uikit) {
			label.classList.add('uk-button');
			label.classList.add('uk-button-default');
			target.classList.add('uk-hidden');
		}
		else if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4)
		{
			label.classList.add('btn');
			if (regTabs.bs2 || regTabs.bs3) {
				label.classList.add('btn-default');
			}
			else if (regTabs.bs4)
			{
				label.classList.add('btn-secondary');
			}
			target.classList.add('hidden');
			target.setAttribute('hidden', true);
		}

		var group = label.closest('span, .paramlist_value');
		if (regTabs.uikit) {
			group.classList.add('uk-button-group');
		}
		else if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4) {
			group.classList.add('btn-group');
			// only works in BS4
			group.classList.add('mt-2');
			if (regTabs.bs2 || regTabs.bs3) {
				group.style.marginTop = "0.6rem";
			}
		}

		target.addEventListener('click', function() {
			if (regTabs.uikit) {
				rsvppro_toggleRadiosUIkit(target);
			}
			else if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4) {
				rsvppro_toggleRadiosBS(target);
			}
		});

		var activeClass = target.getAttribute('data-activeclass');

		if (regTabs.uikit) {

			if (target.checked) {
				if (activeClass) {
					label.classList.add('uk-button-' + activeClass);
				} else if (target.value == 0) {
					label.classList.add('uk-button-danger');
				} else {
					label.classList.add('uk-button-primary');
				}
			} else {
				if (activeClass) {
					label.classList.remove('uk-button-' + activeClass);
				}
				label.classList.remove('uk-button-primary');
				label.classList.remove('uk-button-danger');
			}
		}
		else if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4) {
			if (target.checked) {
				if (activeClass) {
					label.classList.add('btn-' + activeClass);
				} else if (target.value == 0) {
					label.classList.add('btn-danger');
				} else {
					label.classList.add('btn-primary');
				}
				// doesn't matter about not checking bs type
				label.classList.remove('btn-default');
				label.classList.remove('btn-secondary');
			} else {
				if (activeClass) {
					label.classList.remove('btn-' + activeClass);
				}
				label.classList.remove('btn-primary');
				label.classList.remove('btn-danger');

				if (regTabs.bs2 || regTabs.bs3) {
					label.classList.add('btn-default');
				}
				else if (regTabs.bs4)
				{
					label.classList.add('btn-secondary');
				}

			}

		}
	}

}

function rsvppro_toggleCheckbox(target)
{
	if (regTabs.uikit) {
		rsvppro_toggleCheckboxUIkit(target);
	}
	else if (regTabs.bs2 || regTabs.bs3 || regTabs.bs4) {
		rsvppro_toggleCheckboxBS(target);
	}
}

function rsvppro_toggleCheckboxUIkit(target)
{

	var label = document.querySelector('[for="' + target.id + '"]');
	if (label)
	{
		if (!label.classList.contains('uk-button')) {
			label.classList.add('uk-button');
			label.classList.add('uk-button-default');
			target.classList.add('uk-hidden');

			target.addEventListener('click', function () {
				rsvppro_toggleCheckboxUIkit(target);
			});
		}

		var activeClass = target.getAttribute('data-activeclass');

		if (target.checked)
		{
			if (activeClass)
			{
				label.classList.add('uk-button-' + activeClass);
			}
			else if (target.value == 0)
			{
				label.classList.add('uk-button-danger');
			}
			else
			{
				label.classList.add('uk-button-primary');
			}
		}
		else
		{
			if (activeClass)
			{
				label.classList.remove('uk-button-' + activeClass);
			}
			label.classList.remove('uk-button-primary');
			label.classList.remove('uk-button-danger');
		}
	}


}

function rsvppro_toggleCheckboxBS(target)
{

	var label = document.querySelector('[for="' + target.id + '"]');
	if (label)
	{
		if (!label.classList.contains('btn')) {
			label.classList.add('btn');
			if (regTabs.bs2 || regTabs.bs3) {
				label.classList.add('btn-default');
			}
			else if (regTabs.bs4) {
				label.classList.add('btn-secondary');
			}
			target.classList.add('hidden');
			target.setAttribute('hidden', true);

			target.addEventListener('click', function () {
				rsvppro_toggleCheckboxBS(target);
			});
		}

		var activeClass = target.getAttribute('data-activeclass');

		if (target.checked)
		{
			if (activeClass)
			{
				label.classList.add('btn-' + activeClass);
			}
			else if (target.value == 0)
			{
				label.classList.add('btn-danger');
			}
			else
			{
				label.classList.add('btn-primary');
			}
			if (regTabs.bs2 || regTabs.bs3) {
				label.classList.remove('btn-default');
			}
			else if (regTabs.bs4) {
				label.classList.remove('btn-secondary');
			}
		}
		else
		{
			if (activeClass)
			{
				label.classList.remove('btn-' + activeClass);
			}
			label.classList.remove('btn-primary');
			label.classList.remove('btn-danger');

			if (regTabs.bs2 || regTabs.bs3) {
				label.classList.add('btn-default');
			}
			else if (regTabs.bs4) {
				label.classList.add('btn-secondary');
			}
		}

	}

}

document.addEventListener('DOMContentLoaded', function () {

	if (rsvpprofrontendstyling == 'U3' || rsvpprofrontendstyling == 'U4') {
		regTabs.uikitStyling();
	}
	if (!regTabs.uikit) {
		regTabs.bsStyling();
	}
});
