<?php
/**
* @copyright	Copyright (C) 2008-2021 GWE Systems Ltd. All rights reserved.
 * @license		By negoriation with author via http://www.gwesystems.com
*/
defined('JPATH_PLATFORM') or die;

use Joomla\Registry\Registry;
use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;

function ProcessJsonRequest(&$requestObject, $returnData){

	if (!isset($requestObject->typeahead)){
		return array();
	}

	$user = Factory::getUser();
	if ($user->id==0){
		PlgSystemGwejson::throwerror("There was an error");
	}
        
        $lang = Factory::getLanguage();
	$lang->load("com_rsvppro", JPATH_ADMINISTRATOR);
        $lang->load("com_rsvppro", JPATH_SITE);
	$lang->load("com_jevents", JPATH_ADMINISTRATOR);
        $lang->load("com_jevents", JPATH_SITE);

	$returnData->titles	= array();
	$returnData->exactmatch=false;

	ini_set("display_errors",0);

        include_once(JPATH_SITE."/components/com_rsvppro/models/jevtemplates.php");
        $model = BaseDatabaseModel::getInstance("JevtemplatesModelJevtemplates");
        $colonPos = strpos($requestObject->typeahead, "#");
        if ($colonPos>0 && strlen($requestObject->typeahead)>=$colonPos+1){
            list($template, $field) = explode("#", $requestObject->typeahead,2);
        }
        else {
            $template = $requestObject->typeahead;
            $field = false;
        }
       
        $model->typeahead = $template;
        $items =  $model->getItems();

        if ($colonPos>0 && isset($items[0])){
            $templateid = $items[0]->id;
            /*
            include_once(JPATH_SITE."/components/com_rsvppro/models/jevfields.php");
            $model = BaseDatabaseModel::getInstance("JevfieldsModelJevfields");
            $model->setState("template", $templateid);
            $items =  $model->getItems();
             */

            $items = array();
            include_once(JPATH_ADMINISTRATOR."/components/com_rsvppro/models/template.php");
            include_once(JPATH_ADMINISTRATOR."/components/com_rsvppro/tables/template.php");
            $datamodel = BaseDatabaseModel::getInstance("RsvpprotemplatesModelTemplate");
            $datamodel->setId($templateid);
            
            // model function needs to think we are editing the template
            Factory::getApplication()->input->set("option","com_rsvppro");
            Factory::getApplication()->input->set('task', 'templates.edit');
            
            $templateItem = $datamodel->getData();
            // Get field data from the model                   
            $params	= $datamodel->getParams($templateItem);
            $templateparams = $templateItem->params;
            if (is_string($templateparams) && strlen(trim($templateparams))>2){
                    $templateparams = new Registry($templateparams);
            }
            else if (is_string($templateparams) && trim($templateparams)==""){
                    $templateparams = ComponentHelper::getParams(RSVP_COM_COMPONENT);
            }
                        
            foreach ($templateItem->fields as $field)
            {
                    $fieldhtml = $field->html;
                    ob_start();
                    ?>
                    <div class='rsvpfield' id='field<?php echo $field->field_id; ?>'>
	                    <span class="sortable-handler gsl-icon" gsl-icon="icon:move" style="cursor: move;float:left;"></span>
                            <input id="deleteFieldButtonfield<?php echo $field->field_id; ?>" type="button" value="<?php echo Text::_("RSVP_DELETE_FIELD"); ?>" class="gsl-button gsl-button-danger gsl-button-small gsl-margin-small-bottom deleteFieldButton"/>
                            <input id="closeFieldButtonfield<?php echo $field->field_id; ?>" type="button" value="<?php echo Text::_("RSVP_CLOSE_FIELD"); ?>" class="gsl-button gsl-button-secondary gsl-button-small gsl-margin-small-bottom  closeFieldButton"/>
                            <?php
                            echo $fieldhtml;
                            ?>
                    </div>
                    <?php
                    $field->html = ob_get_clean();
                    $field->title = $template. "#".$field->name;
                    $field->id = $field->field_id;
                    $items[] = $field;
            }            
        }

	return $items;

}

