<?php

/*
 *  @author    Geraint Edwards - JEvents.net
 *  @copyright Copyright (C) 2016 - 2021 GWE Systems Ltd
 *  @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
 *  @link https://www.jevents.net
 */

defined('JPATH_PLATFORM') or die;

use Joomla\CMS\MVC\Model\ListModel;
use Joomla\CMS\Factory;
jimport('joomla.application.component.modellist');
/**
 * Frontend model for Session Templates
 *
 * @author carcam
 */
class JevtemplatesModelJevtemplates extends ListModel
{
	public $typeahead="";

	public function __construct($config = array())
	{
		parent::__construct($config);
	}

	protected function getListQuery()
	{
		// Create a new query object.
		$user = Factory::getUser();
		$db    = $this->getDbo();
		$query = $db->getQuery(true);
		$typeahead = $this->typeahead;

		$select = array();
		$where = array();

		$select[] = 'tmp.id';
		$select[] = 'tmp.title';

		$query->select($select);
		$query->from('`#__jev_rsvp_templates` AS tmp');

		$where[] = '(tmp.global = 1 OR tmp.created_by = '.$user->id .')';

		if($typeahead)
		{
			$where[] = 'tmp.title LIKE "%'.$typeahead.'%"';
		}

		if($where)
		{
			$query->where($where, "AND");
		}


		// Add the list ordering clause.
		$orderCol  = $this->state->get('list.ordering', 'tmp.title');
		$orderDirn = $this->state->get('list.direction', 'ASC');
		if ($orderCol && $orderDirn)
		{
			$query->order($db->escape($orderCol . ' ' . $orderDirn));
		}

		$query->setLimit(100);

		return $query;
	}
}
