<?php

defined('JPATH_BASE') or die;

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Factory;
if (!class_exists('VmConfig'))
	require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/config.php');
if (!class_exists('ShopFunctions'))
	require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/shopfunctions.php');
if (!class_exists('TableCategories'))
	require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/tables/categories.php');

jimport('joomla.form.formfield');

/**
 * Reverse field mapping from Virtuemart to Joomla custom fields or profile
 *
 *
 */
class FormFieldJevrfieldmapping extends FormField
{

	protected $type = 'jevrfieldmapping';

	function getInput()
	{

		$html = "";

		Factory::getLanguage()->load('com_virtuemart', JPATH_ADMINISTRATOR);
		Factory::getLanguage()->load('com_virtuemart_shoppers', JPATH_SITE);
		Factory::getLanguage()->load('com_virtuemart', JPATH_SITE);
		Factory::getLanguage()->load('com_virtuemart_shoppers', JPATH_SITE . "/components/com_virtuemart");
		Factory::getLanguage()->load('com_virtuemart', JPATH_SITE . "/components/com_virtuemart");
		$vmUserFieldsModel = VmModel::getModel('Userfields');
		// All fields
		$vmfields = $vmUserFieldsModel->getUserFields('');
		$html .= '<select class="inputbox"   name="' . $this->name . '[vm]" >';
		$html .= '<option value="">' . Text::_('RSVP_SELECT_VM_PROFILE_FIELD') . '</option>';

		foreach ($vmfields as $vmfield)
		{
			if ($vmfield->virtuemart_userfield_id > 0)
			{
				$selected = "";
				if (is_array($this->value) && isset($this->value["vm"]) && $this->value["vm"]==$vmfield->virtuemart_userfield_id)
				{
					$selected= " selected='selected' ";
				}
				
				$html .= '<option value="' . $vmfield->virtuemart_userfield_id . '" '.$selected.'>' . Text::_($vmfield->title) . '</option>';
			}
		}
		$html .= "</select>";

		$html .= "&nbsp;<strong>" . Text::_("RSVP_MAPS_TO") . "</strong>&nbsp;";
		
		JLoader::register('FieldsHelper', JPATH_ADMINISTRATOR . '/components/com_fields/helpers/fields.php');
		$userCustomFields = FieldsHelper::getFields("com_users.user");
		$html .= '<select class="inputbox"   name="' . $this->name . '[cf]" >';
		$html .= '<option value="">' . Text::_('RSVP_SELECT_USER_CUSTOM_FIELD') . '</option>';
		if (count($userCustomFields))
		{
			foreach ($userCustomFields as $userCustomField)
			{
				$selected = "";
				if (is_array($this->value) && isset($this->value["cf"]) && $this->value["cf"]==$userCustomField->id)
				{
					$selected= " selected='selected' ";
				}
				$html .= '<option value="' . $userCustomField->id . '" '.$selected.'>' . $userCustomField->title . '</option>';
			}
		}
		$html .= "</select>";

		$html .= "&nbsp;<strong>" . Text::_("RSVP_OR") . "</strong>&nbsp;";
		
		$html .= '<select class="inputbox"   name="' . $this->name . '[up]" >';
		$html .= '<option value="">' . Text::_('RSVP_SELECT_USER_PROFILE_FIELD') . '</option>';

		$plugin = PluginHelper::getPlugin('user', 'profile3');
		if (!$plugin)
		{
			$plugin = PluginHelper::getPlugin('user', 'profile2');
		}
		if (!$plugin)
		{
			$plugin = PluginHelper::getPlugin('user', 'profile');
		}
			
		if (isset($plugin->params) && $plugin->params)
		{
			$params = new Registry($plugin->params);
			$lang = Factory::getLanguage();
			$lang->load("plg_user_profile", JPATH_ADMINISTRATOR);
			Form::addFormPath(JPATH_SITE . '/plugins/user/profile/profiles');

			$form = Form::getInstance("profileform", "profile");
			$fieldsets = $form->getFieldsets();

			foreach ($fieldsets as $key => $fieldset)
			{
				$fieldsetFields = $form->getFieldset($key);
				foreach ($fieldsetFields as $fsfield)
				{
					$label = $fsfield->getLabel();
					$name = $fsfield->fieldname;
					$selected = "";
					if (is_array($this->value) && isset($this->value["up"]) && $this->value["up"]==$fsfield->fieldname)
					{
						$selected= " selected='selected' ";
					}
					
					$html .= '<option value="' . $fsfield->fieldname . '" '.$selected.' >' . $label . '</option>';
				}
			}
		}
		$html .= "</select>";
		
		return $html;

		//$categorylist = ShopFunctions::categoryListTree($this->value);
		VmConfig::loadConfig();
		$vendorId = VmConfig::isSuperVendor();
		if ($this->value == "")
		{
			$this->value = array();
		}
		$categorylist = ShopFunctions::categoryListTreeLoop($this->value, 0, 0, array(), 0, $vendorId, VmConfig::$vmlang);
		$class = '';
		$html = '<select class="inputbox"   name="' . $this->name . '" ' . $multiple . ' ' . $size . '>';
		$html .= '<option value="0">' . Text::_('COM_VIRTUEMART_CATEGORY_FORM_TOP_LEVEL') . '</option>';
		$html .= $categorylist;
		$html .= "</select>";
		return $html;
	}

}

class_alias("FormFieldJevrfieldmapping", "JFormFieldJevrfieldmapping");