<?php


defined('JPATH_BASE') or die;

use Joomla\CMS\Language\Text;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Factory;

if (!class_exists('VmConfig'))
    require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/config.php');
if (!class_exists('ShopFunctions'))
    require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/shopfunctions.php');
if (!class_exists('vObject'))
    require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/vobject.php');
if (!class_exists('VmTable'))
    require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/vmtable.php');
if (!class_exists('TableCategories'))
    require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/tables/categories.php');

jimport('joomla.form.formfield');

/**
 * Supports a modal product picker.
 *
 *
 */
class FormFieldJevVmcats extends FormField
{ 
	protected $type = 'jevvmcats';

	/**
	 * Method to get the field input markup.
	 *
         * @author      Valerie Cartan Isaksen
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
  
     function getInput() {
        $multiple= ($this->element['multiple'] ? 'multiple="multiple"' : "");
        $size= ($this->element['size'] ? 'size="'.$this->element['size'].'"' : "");
	
        Factory::getLanguage()->load('com_virtuemart', JPATH_ADMINISTRATOR);
        //$categorylist = ShopFunctions::categoryListTree($this->value);
	VmConfig::loadConfig();
	$vendorId = VmConfig::isSuperVendor();
	if ($this->value==""){
		$this->value = array();
	}
	$categorylist = ShopFunctions::categoryListTreeLoop($this->value, 0, 0, array(), 0, $vendorId, VmConfig::$vmlang);
        $class = '';
        $html = '<select class="inputbox"   name="' . $this->name . '" '.$multiple.' '.$size.'>';
        $html .= '<option value="0">' . Text::_('COM_VIRTUEMART_CATEGORY_FORM_TOP_LEVEL') . '</option>';
        $html .= $categorylist;
        $html .="</select>";
        return $html;
        

    }



}
class_alias("FormFieldJevVmcats", "JFormFieldJevVmcats");