<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Date\Date;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

jimport( 'joomla.plugin.plugin' );

class plgRsvpproManual2 extends CMSPlugin
{

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	public function generatePaymentPage(&$html, $attendee, $rsvpdata, $event, &$transaction){

		$plugin = PluginHelper::getPlugin("rsvppro","manual2");
		$params = new Registry($plugin->params);
		$comparams  = ComponentHelper::getParams("com_rsvppro");

		$currency = RsvpHelper::getTemplateSpecificParameter($rsvpdata,  "Currency","GBP");
		$amount = RsvpHelper::ceil_dec(Factory::getApplication()->input->getFloat("amount",0), 2, ".");
		//$amount = ceil(Factory::getApplication()->input->getFloat("amount",0)*100)/100;

		if (isset($rsvpdata->template) &&  is_numeric($rsvpdata->template)){
			$db = Factory::getDBO();
			$db->setQuery("Select params from #__jev_rsvp_templates where id=".intval($rsvpdata->template));
			$templateParams = $db->loadObject();
			if ($templateParams){
				$templateParams =  json_decode($templateParams->params);
                                $templateParams = RsvpHelper::translateTemplateParams($rsvpdata->template, $templateParams);
			}
			else {
				$templateParams = $params;
			}
		}
		else {
			$templateParams = $params;
		}

		$html =   isset($templateParams->templatebody2)? $templateParams->templatebody2: $params->get("templatebody2","Total Fees = {TOTALFEES}<br/>Fees Already Paid= {FEESPAID}<br/>Outstanding Balance = {BALANCE}<br/><br/>Please send your payment to ...");
		if (isset($attendee->outstandingBalances)){
			$html = str_replace("{TOTALFEES}",$this->phpMoneyFormat($attendee->outstandingBalances['totalfee'], $templateParams), $html);
			$html = str_replace("{FEESPAID}",$this->phpMoneyFormat($attendee->outstandingBalances['feepaid'], $templateParams), $html);
			$html = str_replace("{BALANCE}",$this->phpMoneyFormat($attendee->outstandingBalances['feebalance'], $templateParams), $html);
                        $html = str_replace("{RAWBALANCE}",$attendee->outstandingBalances['feebalance'], $html);
			$html = str_replace("{DEPOSIT}",$this->phpMoneyFormat($attendee->outstandingBalances['deposit'], $templateParams), $html);
		}
		$html = str_replace("{TRANSACTIONID}",$transaction->get("transaction_id"), $html);

		$user = JEVHelper::getUser($attendee->user_id);
		if ($user->id == 0 && RsvpHelper::getTemplateSpecificParameter($rsvpdata,  "attendemails", 0))
		{
			$name = $attendee->email_address;
			$username = $attendee->email_address;
		}
		else
		{
			$name = $user->name;
			$username = $user->username;
		}

		$userdet = JEVHelper::getUser($event->created_by());
		if (RsvpHelper::getTemplateSpecificParameter($rsvpdata,  'contact_display_name', 0) == 1)
		{
			$contactlink = $userdet->name;
		}
		else
		{
			$contactlink = $userdet->username;
		}
		$html = str_replace("{CREATOR_EMAIL}", $userdet->email, $html);
		$html = str_replace("{CREATOR}", $contactlink, $html);

		$comparams = ComponentHelper::getParams("com_rsvppro");
		include_once(JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/attendeehelper.php");
		$this->helper = new RsvpAttendeeHelper($comparams);

		$html = $this->helper->parseMessage($html, $rsvpdata, $event, $name, $username, $attendee, false, false, $transaction);

		$currency = isset($templateParams->Currency)? $templateParams->Currency:$currency;

		// setup transaction data
		$transaction->amount = $amount;
		$transaction->currency = $currency;
		$transaction->attendee_id = $attendee->id;
		$transaction->gateway = "manual2";

		$transaction->params = new stdClass();
		$transaction->params = json_encode($transaction->params);

		$transaction->store();

		$this->notifyManualPayment($transaction, $attendee, $rsvpdata);

	}

	public static function NotifyPayment($templateParams) {
		return $templateParams->get("notifymanpay2", 1);
	}

	public static function PaymentMessageType() {
		return "manpay2";
	}

	public function editTransaction ($attendee, $rsvpdata, $event, &$transaction){

		$plugin = PluginHelper::getPlugin("rsvppro","manual2");
		$params = new Registry($plugin->params);
		$comparams  = ComponentHelper::getParams("com_rsvppro");

		$lang = Factory::getLanguage();
		$lang->load("plg_rsvppro_manual2", JPATH_ADMINISTRATOR);

		$db = Factory::getDBO();

		if (isset($rsvpdata->template) &&  is_numeric($rsvpdata->template)){
			$template = $rsvpdata->template;
			$db->setQuery("Select params from #__jev_rsvp_templates where id=".intval($rsvpdata->template));
			$templateParams = $db->loadObject();
			if ($templateParams){
				$templateParams =  json_decode($templateParams->params);
			}
			else {
				$templateParams = $params;
			}
		}
		else {
			$template = false;
			$templateParams = $params;
		}
		$html ="<h2>".($transaction->transaction_id ? Text::_("RSVP_FORM_TRANSACTION_EDIT") :  Text::_("RSVP_FORM_TRANSACTION_ADD"))."</h2>";

		$html .=   isset($templateParams->templatebody2)? $templateParams->templatebody2: $params->get("templatebody2","Total Fees = {TOTALFEES}<br/>Fees Already Paid= {FEESPAID}<br/>Outstanding Balance = {BALANCE}<br/><br/>Please send your payment to ...");
		if (isset($attendee->outstandingBalances)){
			$html = str_replace("{TOTALFEES}",$this->phpMoneyFormat($attendee->outstandingBalances['totalfee'], $template), $html);
			$html = str_replace("{FEESPAID}",$this->phpMoneyFormat($attendee->outstandingBalances['feepaid'], $template), $html);
			$html = str_replace("{BALANCE}",$this->phpMoneyFormat($attendee->outstandingBalances['feebalance'], $template), $html);
                        $html = str_replace("{RAWBALANCE}",$attendee->outstandingBalances['feebalance'], $html);

			$transaction->amount = $transaction->amount ==0?$attendee->outstandingBalances['feebalance']:$transaction->amount ;
		}

		$userdet = JEVHelper::getUser($event->created_by());
		if (RsvpHelper::getTemplateSpecificParameter($rsvpdata,  'contact_display_name', 0) == 1)
		{
			$contactlink = $userdet->name;
		}
		else
		{
			$contactlink = $userdet->username;
		}
		$html = str_replace("{CREATOR_EMAIL}", $userdet->email, $html);
		$html = str_replace("{CREATOR}", $contactlink, $html);

		// setup transaction data
		$transaction->currency = isset($templateParams->Currency) ? $templateParams->Currency : $params->get("Currency");
		$transaction->attendee_id = $attendee->id;
		$transaction->gateway = "manual2";

		$transaction->params = new stdClass();
		$transaction->params = json_encode($transaction->params);

		HTMLHelper::stylesheet(  'components/com_rsvppro/assets/css/rsvpattend.css' );
		HTMLHelper::script( 'components/com_rsvppro/assets/js/tabs.js' );
		jimport('joomla.utilities.date');
		// Must use strtotime format for force Date to not just parse the date itself!!!
		if (is_null($transaction->transaction_date) || $transaction->transaction_date=="0000-00-00 00:00:00" || $transaction->transaction_date=="1970-01-01 01:00:00"){
			jimport("joomla.utilities.date");
			if (class_exists("JevDate")) {
				$tempdate = new JevDate("+0days");
				$transaction->transaction_date=$tempdate->toMySQL();
			}
			else {
				$tempdate = new Date("+0days");
				$transaction->transaction_date=$tempdate->toSql();
			}
		}
		ob_start();
?>
<script  type="text/javascript">
<!--
	function submitbutton(pressbutton) {
		var form = document.adminForm;
		submitform( pressbutton );
	}
// -->
</script>

<form action="index.php" name="adminForm" method="post" id="adminForm">
			<input type="hidden" name="transaction_id" value="<?php echo $transaction->transaction_id; ?>" />
			<input type="hidden" name="attendee_id" value="<?php echo $attendee->id; ?>" />
			<input type="hidden" name="cid[]" value="<?php echo $attendee->id; ?>" />
			<input type="hidden" name="paymentstate" value="1" />
	<table cellpadding="4" cellspacing="1" border="0" class="adminform">
		<tr>
			<td><?php echo  Text::_("RSVP_TRANSACTION_DATE");?> </td>
			<td>
				<input type="text" name="transaction_date" size="40" value="<?php echo $transaction->transaction_date; ?>" />
			</td>
		</tr>
		<tr>
			<td><?php echo  Text::_("RSVP_TRANSACTION_GATEWAY");?> </td>
			<td>
				<?php echo  Text::_("ENGINE_MANUAL2");?>
				<input type="hidden" name="gateway" value="manual2" />
			</td>
		</tr>
		<tr>
			<td><?php echo  Text::_("RSVP_TRANSACTION_CURRENCY");?> </td>
			<td>
				<?php echo $transaction->currency;?>
				<input type="hidden" name="currency" value="<?php echo $transaction->currency;?>" />
			</td>
		</tr>
		<tr>
			<td><?php echo  Text::_("RSVP_TRANSACTION_AMOUNT");?> </td>
			<td>
				<input type="text" name="amount" size="40" value="<?php echo $transaction->amount; ?>" />
			</td>
		</tr>
		<tr>
			<td valign="top"><?php echo  Text::_("RSVP_TRANSACTION_NOTES");?> </td>
			<td>
				<textarea rows="5" cols="50" name="notes"><?php echo $transaction->notes; ?></textarea>
			</td>
		</tr>
	</table>

	<input type="hidden" name="option" value="com_rsvppro" />
	<input type="hidden" name="task" value="attendees.edittransaction" />
	<?php echo HTMLHelper::_( 'form.token' ); ?>
</form>
<?php
		$html .= ob_get_clean();
		return $html;
	}

	static public function transactionDetailLink($transaction){

		$plugin = PluginHelper::getPlugin("rsvppro","manual2");
		$params = new Registry($plugin->params);

		return  'Manual Payment' ;
	}

	public function activeGatewayClass(&$activeGatewayClass, $action="notify"){
		$gateway = Factory::getApplication()->input->getString("gateway");

		if ($gateway == "manual2" || strpos($gateway,"manua2l_")===0){
			$activeGatewayClass = __CLASS__;
		}
	}

	public function activeGateways(&$activeGatewayClasses){
			$activeGatewayClasses[] = __CLASS__;
	}

	function phpMoneyFormat($amount, $template) {
		if (isset($template->Currency)){
			$digits 	= $template->CurrencyDigits;
			$symbol 	= $template->CurrencySymbol;
			$onLeft 	= (strcmp($template->CurrencyPlacement,'left') == 0);
			$separator 	= $template->CurrencySeparator;
			$decimal	= $template->CurrencyDecimal;
		}
		else {
			$eSessParams = ComponentHelper::getParams('com_rsvppro');

			$digits 	= $eSessParams->get("CurrencyDigits");
			$symbol 	= $eSessParams->get("CurrencySymbol");
			$onLeft 	= (strcmp($eSessParams->get("CurrencyPlacement"),'left') == 0);
			$separator 	= $eSessParams->get("CurrencySeparator");
			$decimal	= $eSessParams->get("CurrencyDecimal");
		}
		$formattedText  = '';

		// negative amount
		if ( $amount < 0 ) $formattedText .= '-';

		// currency symbol on the left
		if ( $onLeft )     $formattedText .= $symbol;

		// format with correct number of digits and separator
		if ( $digits > 0 ) {
			$amount = RsvpHelper::ceil_dec(abs($amount), $digits, ".");
			$formattedText .= number_format( abs($amount), $digits, $decimal, $separator );
		} else {
			$formattedText = abs( $amount );
		}

		// currency symbols on the right
		if ( !$onLeft )    $formattedText .= $symbol;


		return $formattedText;
	}

	private function notifyManualPayment($transaction, $attendee, $rsvpdata){

		// immediate notification
		if (RsvpHelper::getTemplateSpecificParameter($rsvpdata,  "notifymanpay2", 1)==2  && $transaction->gateway == "manual2")
		{

			$comparams = ComponentHelper::getParams("com_rsvppro");
			include_once(JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/attendeehelper.php");
			$this->helper = new RsvpAttendeeHelper($comparams);

			$rpid = $attendee->rp_id;

			$this->dataModel = new JEventsDataModel();
			$this->queryModel = new JEventsDBModel($this->dataModel);

			// Find the first repeat
			$vevent = $this->dataModel->queryModel->getEventById($rsvpdata->ev_id, false, "icaldb");
			if ($rpid == 0)
			{
				$repeat = $vevent->getFirstRepeat();
			}
			else
			{
				list($year, $month, $day) = JEVHelper::getYMD();
				$repeatdata = $this->dataModel->getEventData(intval($rpid), "icaldb", $year, $month, $day);
				if ($repeatdata && isset($repeatdata["row"]))
					$repeat = $repeatdata["row"];
			}

			$user = JEVHelper::getUser($attendee->user_id);
			if ($user->id == 0 && RsvpHelper::getTemplateSpecificParameter($rsvpdata,  "attendemails", 0))
			{
				$name = $attendee->email_address;
				$username = $attendee->email_address;
			}
			else
			{
				$name = $user->name;
				$username = $user->username;
			}

			$class = "plgRsvppro" . ucfirst($transaction->gateway);
			$pluginpath = version_compare(JVERSION, "1.6.0", 'ge')?JPATH_SITE."/plugins/rsvppro/$transaction->gateway/" : JPATH_SITE."/plugins/rsvppro/";
			JLoader::register($class, $pluginpath . $transaction->gateway . ".php");

			$this->helper->notifyUser($rsvpdata, $repeat, $user, $name, $username, $attendee, 'manpay2', false, $transaction);
		}
	}


}
