<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');
jimport('joomla.log.log');

// Load Omnipay autoloader
require JPATH_SITE . '/libraries/jev_omnipay/vendor/autoload.php';

// Use Omnipay
use Joomla\Utilities\ArrayHelper;
use Joomla\Registry\Registry;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Log\Log;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Factory;
use Omnipay\Omnipay;

class plgRsvpproPaypalExpress extends CMSPlugin
{

	public function __construct(& $subject, $config)
	{

		// Enable Logging
		Log::addLogger(
			array(
				'text_file' => 'com_rsvppro.paypal_express.ipn.log.php'
			),
			Log::ALL,
			'com_rsvppro.ppe_ipn'
		);

		parent::__construct($subject, $config);

	}

	public function generatePaymentPage(&$html, $attendee, $rsvpdata, $event, &$transaction)
	{

		$plugin = PluginHelper::getPlugin("rsvppro", "paypalexpress");
		$params = new Registry($plugin->params);

		$jinput = Factory::getApplication()->input;

		$invoice = $jinput->getString("invoiceid", '') . '_' . $transaction->transaction_id;

		// Amount, format number to 2 for PayPal to be happy.
		$amount     = number_format(RsvpHelper::ceil_dec($jinput->getFloat("amount", 0), 2, "."), 2);

		$detaillink = Route::_(Uri::root() . $event->viewDetailLink($event->yup(), $event->mup(), $event->dup(), false), false);

		$currency = $params->get("Currency","GBP");

		if (isset($rsvpdata->template) && is_numeric($rsvpdata->template)){
			$db = Factory::getDBO();
			$db->setQuery("Select params from #__jev_rsvp_templates where id=".intval($rsvpdata->template));
			$templateParams = $db->loadObject();
			if ($templateParams){
				$templateParams =  json_decode($templateParams->params);
				$templateParams = RsvpHelper::translateTemplateParams($rsvpdata->template, $templateParams);
			}
			else {
				$templateParams = $params;
			}
		}
		else {
			$templateParams = $params;
		}

		$currency = isset($templateParams->Currency)? $templateParams->Currency:$currency;

		$code     = '';

		if (isset($rsvpdata->template) && is_numeric($rsvpdata->template))
		{
			$db = Factory::getDbo();
			$db->setQuery("Select params from #__jev_rsvp_templates where id=" . intval($rsvpdata->template));
			$templateParams = $db->loadObject();
			if ($templateParams)
			{
				$templateParams = json_decode($templateParams->params);
				$templateParams = RsvpHelper::translateTemplateParams($rsvpdata->template, $templateParams);

				// Clear if using Global Params
				if ((int) $templateParams->ppeuseglobalsettings === 1)
				{
					$templateParams = $params;
				}
			}
			else
			{
				$templateParams = $params;
			}

		}
		else
		{
			$templateParams = $params;
		}

		$comparams = ComponentHelper::getParams("com_rsvppro");
		$user      = JEVHelper::getUser($attendee->user_id);
		if ((int) $user->id === 0 && RsvpHelper::getTemplateSpecificParameter($rsvpdata,  "attendemails", 0))
		{
			$name     = $attendee->email_address;
			$username = $attendee->email_address;
		}
		else
		{
			$name     = $user->name;
			$username = $user->username;
		}

		// Load the attendee helper
		include_once(JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/attendeehelper.php");

		$this->helper = new RsvpAttendeeHelper($comparams);

		$html = $this->helper->parseMessage($html, $rsvpdata, $event, $name, $username, $attendee, false, false, $transaction);

		$currency   = isset($templateParams->Currency) ? $templateParams->Currency : $currency;
		$start_date = JEventsHTML::getDateFormat($event->yup(), $event->mup(), $event->dup(), 0);

		$noshipping = isset($templateParams->request_shipping) ? $templateParams->request_shipping : $params->get("request_shipping", 1);

		$mode_val = isset($templateParams->PayPalMode) ? (int) $templateParams->PayPalMode : (int) $templateParams->get('PayPalMode');
		$mode = $mode_val === 0 ? true : false;

		// PayPal Express Params
		$ppe                    = new stdClass();
		$DefaultPayPalAccount   = isset($templateParams->ppe_DefaultPayPalAccount) ? $templateParams->ppe_DefaultPayPalAccount : $params->get('ppe_DefaultPayPalAccount');
		$ppe->apiusername       = isset($templateParams->ppe_apiusername) ? $templateParams->ppe_apiusername : $params->get('ppe_apiusername');
		$ppe->apipassword       = isset($templateParams->ppe_apipassword) ? $templateParams->ppe_apipassword : $params->get('ppe_apipassword');
		$ppe->apisignature      = isset($templateParams->ppe_apisignature) ? $templateParams->ppe_apisignature : $params->get('ppe_apisignature');
		$ppe->landingpage       = isset($templateParams->ppe_landingpage) ? $templateParams->ppe_landingpage : $params->get('ppe_landingpage', 'Login');
		$ppe->brandName         = isset($templateParams->ppe_brandName) ? $templateParams->ppe_brandName : $params->get('ppe_brandName');
		$ppe->landingpage       = isset($templateParams->ppe_landingpage) ? $templateParams->ppe_landingpage : $params->get('ppe_landingpage');
		$ppe->logoImageUrl      = isset($templateParams->ppe_logoImageUrl) ? $templateParams->ppe_logoImageUrl : $params->get('ppe_logoImageUrl');
		$ppe->headerImageUrl    = isset($templateParams->ppe_headerImageUrl) ? $templateParams->ppe_headerImageUrl : $params->get('ppe_headerImageUrl');
		$ppe->borderColor       = isset($templateParams->ppe_borderColor) ? $templateParams->ppe_borderColor : $params->get('ppe_borderColor');
		$ppe->noshipping        = $noshipping;
		$ppe->invoice           = $invoice;
		$ppe->mode              = $mode;
		$ppe->amount            = $amount;
		$ppe->currency          = $currency;
		$ppe->detaillink        = $detaillink;

		// setup transaction data
		$transaction->amount      = $amount;
		$transaction->currency    = $currency;
		$transaction->attendee_id = $attendee->id;
		$transaction->gateway     = 'paypalexpress';
		$transaction->params        = new stdClass();
		$transaction->params->payee = $DefaultPayPalAccount;
		$transaction->params->username = $ppe->apiusername;
		$transaction->params->password = $ppe->apipassword;
		$transaction->params->signature = $ppe->apisignature;
		$transaction->params->mode   = $mode;
		$transaction->params        = json_encode($transaction->params);

		// Save the transaction data
		$transaction->store();

		$ppe->rsvp_trans_id = $transaction->transaction_id;

		$data             = new stdClass;
		$data->start_date = $start_date;
		$data->amount     = $amount;
		$data->currency   = $currency;
		$data->invoice    = $invoice;
		$data->title      = $event->title;
		$data->detaillink = $detaillink;
		$data->code       = $code;

		static::PayPalRedirect($ppe, $data);

	}

	public static function PayPalRedirect($ppe, $data)
	{
		// OmniPay PayPal Express
		$gateway = Omnipay::create('PayPal_Express');
		$gateway->setUsername($ppe->apiusername);
		$gateway->setPassword($ppe->apipassword);
		$gateway->setSignature($ppe->apisignature);
		$gateway->setTestMode($ppe->mode);
		$gateway->setLandingPage($ppe->landingpage);
		$gateway->setBrandName($ppe->brandName);
		$gateway->setHeaderImageUrl($ppe->headerImageUrl);
		$gateway->setLogoImageUrl($ppe->logoImageUrl);
		$gateway->setBorderColor(str_replace('#', '', $ppe->borderColor));

		$session = Session::getInstance('none', array());
		$session->set('rsvppro_checkout', json_encode($ppe));

		// Send the purchase
		$response = $gateway->purchase(
			[
				'amount'    => $data->amount,
				'currency'  => $data->currency,
				'invoice'   => $data->invoice,
				'item_name' => htmlspecialchars($data->title . " - " . $data->start_date),
				'cancelUrl' => $data->detaillink . $data->code,
				'notifyUrl' => JURI::root() . "index.php?option=com_rsvppro&task=accounts.notify&gateway=paypalexpress&ipn=1&invoice=" . $ppe->invoice,
				'returnUrl' => JURI::root() . "index.php?option=com_rsvppro&task=accounts.notify&gateway=paypalexpress"
			]
		)->send();

		// NOTE: we are using purchase and NOT completePurchase, so this sends the client off site and we call completePurchase later.

        if ($response->isRedirect()) {
            $response->redirect();
        } else {
            $responseData   = $response->getData();

            if(is_array($responseData) && isset($responseData['L_ERRORCODE0']) && $responseData['L_ERRORCODE0'] === '10002' ) {
                echo JText::_('RSVP_PAYPAL_EXPRESS_INVALID_CREDENTIAL');
            } else {
                echo $response->getMessage();
            }
        }
	}

	static public function  notifyRsvpGateway(&$args)
	{

		$app     = Factory::getApplication();
		$session = Session::getInstance('none', array());
		$jinput  = $app->input;

		$params = ComponentHelper::getParams(RSVP_COM_COMPONENT);

		// Check if we are an IPN response:
		if ($jinput->getInt('ipn', 0) === 1)
		{
			$plugin = PluginHelper::getPlugin("rsvppro","paypalexpress");
			// Test needed for J4/J3.9 compatibility
			$dispatcher = method_exists(Factory::getApplication(),"getDispatcher") ? Factory::getApplication()->getDispatcher() : JEventDispatcher::getInstance();
			$paypalPlugin = new plgRsvpproPaypalExpress($dispatcher,  (array)($plugin));

			$paypalPlugin->PayPal_IPNResponse();

			return; // Get out of here we have finished with the IPN Response
		}

		// Get PayPal Credentials from current users session
		$ppe = json_decode($session->get('rsvppro_checkout'));

		$gateway = Omnipay::create('PayPal_Express');
		$gateway->setUsername($ppe->apiusername);
		$gateway->setPassword($ppe->apipassword);
		$gateway->setSignature($ppe->apisignature);
		$gateway->setTestMode($ppe->mode);

		// We run this to complete the purchase and validate it was successful
		$response = $gateway->completePurchase(array(
			'amount'   => $ppe->amount,
			'currency' => $ppe->currency,
			'token'    => $jinput->getString('token', ''),
			'PayerID'  => $jinput->getString('PayerID', ''),
			'notifyUrl' => JURI::root() . 'index.php?option=com_rsvppro&task=accounts.notify&gateway=paypalexpress&ipn=1&invoice=' . $ppe->invoice
		))->send();


		$transaction = new rsvpTransaction();
		$transaction->load($ppe->rsvp_trans_id);

		// Send confirmation email setting, set false unless payment is successful.
		$send_cm = false;


		if ($response->isPending())
		{
			// pending sale flow
			$transaction->logdata = 'Transaction is Pending, please check your PayPal Account: ' . $response->getMessage(); // Any message the gateway his given us.
		}
		else if ($response->isSuccessful())
		{
			// normal successful flow
			$transaction->logdata      = 'Payment was Successful: ' . $response->getMessage();
			$transaction->paymentstate = 1;

			$send_cm = true;

		}
		else if ($response->isRedirect())
		{
			// redirect back to PayPal since there was a payment error, i.e. funding source
			$app->redirect($response->getRedirectUrl());

			return;
		}
		else
		{
			// normal failure flow
			$transaction->logdata = 'There was an error, PayPal responded with: ' . $response->getMessage(); // Any message the gateway his given us.

		}

		$transaction->gw_transid = $response->getTransactionReference(); // Transaction Reference, for refunds etc.

		// Store updated transaction
		$transaction->store();

		// Send Payment Confirmation
		if ($send_cm)
		{
			// fetch the session and the attendee
			$db  = Factory::getDbo();
			$sql = "SELECT * FROM #__jev_attendees WHERE id=" . $transaction->attendee_id;
			$db->setQuery($sql);
			$attendee = $db->loadObject();

			$sql = "SELECT * FROM #__jev_attendance WHERE id=" . $attendee->at_id;
			$db->setQuery($sql);
			$rsvpdata = $db->loadObject();

			plgRsvpproPaypalExpress::notifyPaypalPayment($transaction, $attendee, $rsvpdata);
		}
		// Session cleanup
		$session->clear('rsvppro_checkout');

		$app->redirect($ppe->detaillink);

	}


	protected function PayPal_Message($text, $email)
	{
		$this->FixEmail($email);
		if ($email == '')
		{
			return;
		}
		$mail = Factory::getMailer();

		try {
		return $mail->sendMail($email, 'paypal log', $email, 'PayPal EXPRESS Message', $text, 0);
		}
		catch (Exception $e)
		{
			return false;
		}

	}

	protected function PayPal_Error($text, $email)
	{
		$this->FixEmail($email);
		if ($email == '')
		{
			return;
		}
		$mail = Factory::getMailer();

		try {
		return $mail->sendMail($email, 'paypal log', $email, 'PayPal EXPRESS Error', $text, 0);
		}
		catch (Exception $e)
		{
			return false;
		}

	}

	protected function FixEmail(& $email)
	{
		if ($email == '')
		{
			// get Jevents params and send messages to admin if necessary
			$params   = ComponentHelper::getParams("com_jevents");
			$jevadmin = $params->get("jevadmin", -1);
			if ($jevadmin == -1)
			{
				return;
			}
			$jevadmin = JEVHelper::getUser($jevadmin);
			$email    = $jevadmin->email;
		}

	}

	private function notifyPaypalPayment($transaction, $attendee, $rsvpdata, $aftertransation = false)
	{
		// immediate notification
		if (((!$aftertransation && RsvpHelper::getTemplateSpecificParameter($rsvpdata,  "notifypplpay", 1) == 2) || ($aftertransation && RsvpHelper::getTemplateSpecificParameter($rsvpdata,  "notifypplpay", 1) == 1)) && $transaction->gateway == "paypalexpress")
		{

			$comparams = ComponentHelper::getParams("com_rsvppro");
			include_once(JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/attendeehelper.php");
			$this->helper = new RsvpAttendeeHelper($comparams);

			$rpid = $attendee->rp_id;

			$this->dataModel  = new JEventsDataModel();
			$this->queryModel = new JEventsDBModel($this->dataModel);

			// Find the first repeat
			$vevent = $this->dataModel->queryModel->getEventById($rsvpdata->ev_id, false, "icaldb", false);
			if ($rpid == 0)
			{
				$repeat = $vevent->getFirstRepeat();
			}
			else
			{
				list($year, $month, $day) = JEVHelper::getYMD();
				$repeatdata = $this->dataModel->getEventData(intval($rpid), "icaldb", $year, $month, $day);
				if ($repeatdata && isset($repeatdata["row"]))
					$repeat = $repeatdata["row"];
			}

			$user = JEVHelper::getUser($attendee->user_id);
			if ($user->id == 0 && RsvpHelper::getTemplateSpecificParameter($rsvpdata,  "attendemails", 0))
			{
				$name     = $attendee->email_address;
				$username = $attendee->email_address;
			}
			else
			{
				$name     = $user->name;
				$username = $user->username;
			}

			$class      = "plgRsvppro" . ucfirst($transaction->gateway);
			$pluginpath = version_compare(JVERSION, "1.6.0", 'ge') ? JPATH_SITE . "/plugins/rsvppro/$transaction->gateway/" : JPATH_SITE . "/plugins/rsvppro/";
			JLoader::register($class, $pluginpath . $transaction->gateway . ".php");

			$this->helper->notifyUser($rsvpdata, $repeat, $user, $name, $username, $attendee, 'pplpay', false, $transaction);
		}
	}

	public function phpMoneyFormat($amount, $template)
	{
		if (isset($template->Currency))
		{
			$digits    = $template->CurrencyDigits;
			$symbol    = $template->CurrencySymbol;
			$onLeft    = (strcmp($template->CurrencyPlacement, 'left') == 0);
			$separator = $template->CurrencySeparator;
			$decimal   = $template->CurrencyDecimal;
		}
		else
		{
			$eSessParams = ComponentHelper::getParams('com_rsvppro');

			$digits    = $eSessParams->get("CurrencyDigits");
			$symbol    = $eSessParams->get("CurrencySymbol");
			$onLeft    = (strcmp($eSessParams->get("CurrencyPlacement"), 'left') == 0);
			$separator = $eSessParams->get("CurrencySeparator");
			$decimal   = $eSessParams->get("CurrencyDecimal");
		}
		$formattedText = '';

		// negative amount
		if ($amount < 0) $formattedText .= '-';

		// currency symbol on the left
		if ($onLeft) $formattedText .= $symbol;

		// format with correct number of digits and separator
		if ($digits > 0)
		{
			$amount        = RsvpHelper::ceil_dec(abs($amount), $digits, ".");
			$formattedText .= number_format(abs($amount), $digits, $decimal, $separator);
		}
		else
		{
			$formattedText = abs($amount);
		}

		// currency symbols on the right
		if (!$onLeft) $formattedText .= $symbol;


		return $formattedText;
	}
	protected /**
	 *  PayPal_Response
	 *  Verifies IPN transaction with PayPal server
	 */
	function PayPal_IPNResponse()
	{

		$jinput = Factory::getApplication()->input;
		// Security check on source IP address
		//	$this->securityCheck();

		$params = ComponentHelper::getParams(RSVP_COM_COMPONENT);

		// get receiver email for log messages
		$receiver_email = $jinput->getString('receiver_email', '');

		// Say we got an IPN Response
		Log::add(
			'Received IPN Response', Log::INFO, 'com_rsvppro.ppe_ipn'
		);

		// Lets store the response first.
		Log::add(
			'$_REQUEST: ' . print_r($_REQUEST, true), Log::INFO, 'com_rsvppro.ppe_ipn'
		);

		// get the invoice ID - will be needed for to get the transaction and rsvpdata

		$invoice = $jinput->getString('invoice', '0_0');

		Log::add(
			'Invoice: ' . $invoice, Log::INFO, 'com_rsvppro.ppe_ipn'
		);

		$parts = explode('_', $invoice);

		if (count($parts) !== 2){
			$logText = "Bad invoice id!\n";
			$logText .= '$_REQUEST: ' . print_r( $_REQUEST, true ) . "\n";
			Log::add(
				$logText, Log::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error( $logText  , $receiver_email);
			return;
		}
		$parts = ArrayHelper::toInteger($parts);
		list($attendee_id,$transaction_id) = $parts;

		// Load the transaction instance
		$transaction = new rsvpTransaction();
		if ( !$transaction->load( $transaction_id ) )
		{
			$logText = "Error loading rsvpTransaction instance $transaction_id\n";
			$logText .= $transaction->getError();
			$logText .= '$_REQUEST: ' . print_r( $_REQUEST, true ) . "\n";
			Log::add(
				$logText, Log::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error( $logText  ,$receiver_email );
			return;
		}
		$transactionData = json_decode($transaction->params);

		// fetch the session and the attendee
		$db  = Factory::getDbo();
		$sql = "SELECT * FROM #__jev_attendees WHERE id=" . $attendee_id;
		$db->setQuery($sql);
		$attendee = $db->loadObject();
		if (!$attendee)
		{
			$logText = "Error loading attendee instance $attendee_id\n";
			$logText .= $db->getErrorMessage();
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::ERROR, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		$sql = "SELECT * FROM #__jev_attendance WHERE id=" . $attendee->at_id;
		$db->setQuery($sql);
		$rsvpdata = $db->loadObject();

		if (!$rsvpdata)
		{
			$logText = "Error loading rsvpdata instance $attendee->at_id\n";
			$logText .= $db->getErrorMessage();
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::ERROR, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		if (isset($rsvpdata->template) && is_numeric($rsvpdata->template))
		{
			$db = Factory::getDBO();
			$db->setQuery("Select params from #__jev_rsvp_templates where id=" . intval($rsvpdata->template));
			$templateParams = $db->loadObject();
			if ($templateParams)
			{
				$templateParams = json_decode($templateParams->params);
			}
			else
			{
				$templateParams = $params;
			}
		}
		else
		{
			$templateParams = $params;
		}

		// read the post from PayPal system and add 'cmd'
		$req = 'cmd=_notify-validate';

		foreach ($_POST as $key => $value)
		{
			if (get_magic_quotes_gpc())
			{
				// Fix issue with magic quotes
				$value = stripslashes($value);
			}

			$value = urlencode($value);
			$req   .= "&$key=$value";
		}

		$mode_val = (int) isset($templateParams->PayPalMode) ? $templateParams->PayPalMode : $params->get("PayPalMode", 0);
		if ($mode_val === 1)
		{
			$mode = 'www.paypal.com';
		}
		else
		{
			$mode = 'www.sandbox.paypal.com';
		}
		$currency = isset($templateParams->Currency) ? $templateParams->Currency : $this->params->get("Currency", "GBP");
		$payee    = isset($templateParams->ppe_DefaultPayPalAccount) ? $templateParams->ppe_DefaultPayPalAccount : $this->params->get("ppe_DefaultPayPalAccount");;
		// Always Secure Now!
		$secure = 1;

		// post back to PayPal system to validate
		$header    = '';
		$logText   = "Authenticating with PayPal....\n";
		$useragent = "JEvents.net";
		if ($secure)
		{
			$header .= "POST /cgi-bin/webscr HTTP/1.1\r\n";
			$header .= "Host: " . $mode . ":443\r\n";
			$header .= "Connection: close\r\n";
			$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
			if ($useragent)
			{
				$header .= "User-Agent: " . $useragent . "\r\n";
			}
			$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
			stream_context_set_default(array(
				'ssl' => array(
					'peer_name'         => 'generic-server',
					'verify_peer'       => false,
					'verify_peer_name'  => false,
					'allow_self_signed' => true
				)));
			$fp = fsockopen('ssl://' . $mode, 443, $errno, $errstr, 30);
		}
		else
		{
			$header .= "POST /cgi-bin/webscr HTTP/1.1\r\n";
			$header .= "Host: " . $mode . "\r\n";
			$header .= "Connection: close\r\n";
			$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
			if ($useragent)
			{
				$header .= "User-Agent: " . $useragent . "\r\n";
			}
			$header .= "Content-Length: " . strlen($req) . "\r\n";
			stream_context_set_default(array(
				'ssl' => array(
					'peer_name'         => 'generic-server',
					'verify_peer'       => false,
					'verify_peer_name'  => false,
					'allow_self_signed' => true
				)));
			$fp = fsockopen($mode, 80, $errno, $errstr, 30);
		}
		if (!$fp)
		{
			// HTTP ERROR
			$logText .= "Failed to establish post-back connection: $errstr ($errno)!";
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::ERROR, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, '');

			return;
		}


		// send the POST data back to PayPal, and wait for a response
		fputs($fp, $header . $req);

		$understoodResponse     = false;
		$paypalPostBackResponse = '';
		while (!feof($fp))
		{
			$res                    = fgets($fp, 1024);
			$paypalPostBackResponse .= $res;
			if (strcmp(trim($res), 'VERIFIED') == 0) $understoodResponse = true;
		}

		if (!$understoodResponse)
		{
			$logText = "Invalid PayPal Response!\n";
			$logText .= $paypalPostBackResponse . "\n";
			$logText .= "header = $header\n";
			$logText .= "req = $req\n";
			$logText .= '$_POST: ' . print_r($_POST, true) . "\n";
			//$logText .= '$_REQUEST: ' . print_r( $_REQUEST, true ) . "\n";
			// Now sent later
			//$this->PayPal_Log( $logText );
			//$this->PayPal_Error( $logText  , '');

			// Try Curl as a fallback
			try
			{
				if ($secure)
				{
					$paypal_url = "https://$mode/cgi-bin/webscr";
				}
				else
				{
					$paypal_url = "http://$mode/cgi-bin/webscr";
				}
				$logText .= "Trying Curl as fallback to fputs at $paypal_url \n";

				$ch = curl_init($paypal_url);
				if ($ch == false)
				{
					$logText .= "Invalid PayPal Response from Curl!\n";
					$logText .= date('[Y-m-d H:i e] ') . "Can't connect to PayPal to validate IPN message: " . curl_error($ch);
					Log::add(
						$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
					);
					$this->PayPal_Error($logText, '');
					curl_close($ch);

					return;
				}

				curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
				curl_setopt($ch, CURLOPT_USERAGENT, "Jevents.net");
				curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
				curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
				// Set TCP timeout to 30 seconds
				curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
				curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));


				$res = curl_exec($ch);
				if (curl_errno($ch) != 0)
				{
					$logText = "Invalid PayPal Response from Curl!\n";
					$logText .= date('[Y-m-d H:i e] ') . "Can't connect to PayPal to validate IPN message: " . curl_error($ch);
					curl_close($ch);

					return;
				}
				curl_close($ch);
				if (strpos($res, 'VERIFIED') !== false)
				{
					$understoodResponse = true;
					$logText            = "IPN Response - " . gmstrftime("%b %d %Y %H:%M:%S", time()) . "\n";
				}
				if (!$understoodResponse)
				{
					$logText .= "Bad Response from Curl !\n";
					$logText .= "res = " . $res;
					Log::add(
						$logText, Jlog::ERROR, 'com_rsvppro.ppe_ipn'
					);
					$this->PayPal_Error($logText, '');

					return;
				}

			}
			catch (Exception $ex)
			{
				$logText = "Caught Error from Curl";
				Log::add(
					$logText, Jlog::ERROR, 'com_rsvppro.ppe_ipn'
				);
				$this->PayPal_Error($logText, '');
				return;
			}
		}

		// So far so good.  Now, we need to check the specifics of what went on.
		// To do that, safely extract some information for POST to use in the queries.
		$txn_id         = strval($jinput->get('txn_id', ''));
		$receiver_email = strval($jinput->getString('receiver_email', ''));
		$currency       = strval($jinput->get('mc_currency', ''));
		$amount         = floatval($jinput->get('mc_gross', 0));
		$status         = strval($jinput->get('payment_status', ''));

		// check the payment_status is Completed
		if (strcmp($status, 'Completed') != 0 && strcmp($status, 'Refunded') != 0)
		{
			$logText = "Incomplete payment transaction!\n";
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		$refunded = false;
		// if a refund the set the transasction id back to zero
		if (strcmp($status, 'Refunded') == 0)
		{

			// see https://cms.paypal.com/us/cgi-bin/?&cmd=_render-content&content_ID=developer/e_howto_api_nvp_r_RefundTransaction for more ideas
			$logText = "Payment refunded!\n";
			Log::add(
				$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
			);
			// must ensure the registration is set to cancelled state too!
			$refunded = true;
		}

		// Check #1 - Ensure the payment was received by the proper PayPal account
		$business_email = $jinput->getString('business', $receiver_email);
		if ($business_email !== $transactionData->payee)
		{
			$logText = "Receiver Email Error!\n";
			$logText .= "Receiver Email: $receiver_email Payee from transaction Email: " . $transactionData->payee . "\n";
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		// Check #2 - Ensure amount is correct
		if ($amount != $transaction->amount && strcmp($status, 'Refunded') != 0)
		{
			$logText = "Amount Error!\n";
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		// Check #3 - Ensure currency is correct
		if (strcmp($currency, $transaction->currency) != 0)
		{
			$logText = "Currency Error!\n";
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		if (!$transaction->bind($_POST))
		{
			$logText = "Error binding rsvpTransaction instance\n";
			$logText .= $transaction->getError();
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		$transaction->logdata                           = array();
		$transaction->logdata["request"]                = Factory::getApplication()->input->get;
		$transaction->logdata["paypalPostBackResponse"] = $paypalPostBackResponse;
		$transaction->logdata                           = json_encode($transaction->logdata);

		if ($refunded)
		{
			$transaction->paymentstate = -1;
		}
		else
		{
			$transaction->paymentstate = 1;
		}

		if (!$transaction->check())
		{
			$logText = "Error checking rsvpTransaction instance\n";
			$logText .= $transaction->getError();
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		if (!$transaction->store())
		{
			$logText = "Error saving rsvpTransaction instance\n";
			$logText .= $transaction->getError();
			$logText .= '$_REQUEST: ' . print_r($_REQUEST, true) . "\n";
			Log::add(
				$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
			);
			$this->PayPal_Error($logText, $receiver_email);

			return;
		}

		if ($refunded)
		{
			return;
		}
		$this->notifyPaypalPayment($transaction, $attendee, $rsvpdata, true);

		/*
		if ($refunded){
			// load the registration
			$registration = new comAERegistration( $db );
			$registration->load( $transaction->registration_id );

			$registration->updateStatus();
		}
		*/

		$logText = "Success\n";
		// for debugging only
		//$logText .= '$_REQUEST: ' . print_r( $_REQUEST, true ) . "\n";
		Log::add(
			$logText, Jlog::INFO, 'com_rsvppro.ppe_ipn'
		);

		$this->PayPal_Message($logText, $receiver_email);
	}

	public static function NotifyPayment($templateParams)
	{
		return $templateParams->get("notifypplpay", 1);
	}

	public static function PaymentMessageType()
	{
		return "pplpay";
	}

	static public function transactionDetailLink($transaction)
	{

		$plugin = PluginHelper::getPlugin("rsvppro", "paypalexpress");
		$params = new Registry($plugin->params);

		$transactionLogdata = json_decode($transaction->logdata);

		$mode_val = (int) $params->get('PayPalMode');

		if ($mode_val === 0) {
			$host = 'https://www.sandbox.paypal.com';
		} else {
			$host ='https://www.paypal.com';
		}

		return '<a href="https://' . $host . '/vst/id=' . $transactionLogdata->request->txn_id . '" target="_blank">' . $transactionLogdata->request->txn_id . '</a>';
	}

	public function activeGatewayClass(&$activeGatewayClass, $action = "notify")
	{
		$gateway = Factory::getApplication()->input->getString("gateway");

		if ($gateway == "paypalexpress" || $gateway == "1" || strpos($gateway, "paypalexpress_") === 0)
		{
			$activeGatewayClass = __CLASS__;
		}
	}

	public function activeGateways(&$activeGatewayClasses)
	{
		$activeGatewayClasses[] = __CLASS__;
	}

}
