<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2015-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;

/*
 * function gwejson_skiptoken()

{
	// This file checks the token
	return false;

}
*/

function ProcessJsonRequest(&$requestObject, $returnData)
{
	$params = ComponentHelper::getParams("com_rsvppro");

	$lang 		= Factory::getLanguage();
	$lang->load("plg_jevents_jevrsvppro", JPATH_ADMINISTRATOR);
	$lang->load("com_rsvppro", JPATH_ADMINISTRATOR);

	if ($params->get("recaptchaprivate",false)){
		if (isset($requestObject->gresponseField)  && trim($requestObject->gresponseField)!=="") {
			require_once('autoload.php');
			$recaptcha = new \ReCaptcha\ReCaptcha($params->get("recaptchaprivate",false));
			$resp = $recaptcha->verify( $requestObject->gresponseField,Factory::getApplication()->input->getString("REMOTE_ADDR","","server"));
			//$resp = $recaptcha->verify($requestObject->gresponseField,$_SERVER['REMOTE_ADDR']);//"127.0.0.1");// "84.82.83.241");//$_SERVER['REMOTE_ADDR']);

			//$resp = $recaptcha->verify($gRecaptchaResponse, $remoteIp);
			if ($resp->isSuccess()) {
				// verified!
			} else {
				if ($recaptcha::VERSION == "php_1.1.2")
				{
					$curl = new \ReCaptcha\RequestMethod\CurlPost();
				}
				else
				{
					$curl = new \ReCaptcha\RequestMethod\Curl();
				}
				$recaptcha = new \ReCaptcha\ReCaptcha($params->get("recaptchaprivate",false), $curl );

				$resp = $recaptcha->verify( $requestObject->gresponseField,Factory::getApplication()->input->getString("REMOTE_ADDR","","server"));
				if ($resp->isSuccess()) {
					// verified!
				} else {
					$errors = $resp->getErrorCodes();
					PlgSystemGwejson::throwerror ( Text::_("JEV_RECAPTCHA_ERROR",true));
				}
			}
		}
		else if (isset($requestObject->responseField) && trim($requestObject->responseField)!==""){
			require_once('recaptcha.php');
			$response = recaptcha_check_answer($params->get("recaptchaprivate",false),Factory::getApplication()->input->getString("REMOTE_ADDR","","server"), $requestObject->challengeField,$requestObject->responseField);
			if (!$response->is_valid){
				PlgSystemGwejson::throwerror ( Text::_("JEV_RECAPTCHA_ERROR",true));
			}
		}
		else {
			 PlgSystemGwejson::throwerror ( Text::_("JEV_RECAPTCHA_ERROR",true));
			//PlgSystemGwejson::throwerror ( "There was an error - no valid argument");
		}

		$mainframe= Factory::getApplication('site');
		$mainframe->setUserState("jevrecaptcha","ok");

		// we can't call the recaptcha twice so this is to pass on confirmation that the answer was correct
		if (isset($requestObject->gresponseField)  && trim($requestObject->gresponseField)!=="") {
			$returnData->secretcaptcha = md5($requestObject->gresponseField .  $params->get("recaptchaprivate",false) );
		}
		else {
			$returnData->secretcaptcha = md5($requestObject->responseField .  $params->get("recaptchaprivate",false) );
		}
		$returnData->success = 1;
	}

	return $returnData;
}
