<?php
defined('JPATH_BASE') or die('Direct Access to this location is not allowed.');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

HTMLHelper::stylesheet('components/com_rsvppro/assets/css/rsvpattend.css');
HTMLHelper::script('components/com_rsvppro/assets/js/tabs.js');
$script = "var urlroot = '" . JURI::root() . "';\n";
$script .= "var jsontoken = '" . Session::getFormToken() . "';\n";

$document = Factory::getDocument();
$document->addScriptDeclaration($script);

$html = "";
$user = Factory::getUser();

PluginHelper::importPlugin("rsvppro");
$results = Factory::getApplication()->triggerEvent('onGetAttendanceForm', array(& $html, $this));

foreach ($results as $result)
{
	// one of the plugins has blocked the remidner so output the HTML and return
	if (!$result)
	{
		echo $html;

		return;
	}
}


$Itemid = Factory::getApplication()->input->getInt("Itemid");
//list($year,$month,$day) = JEVHelper::getYMD();
//$link = $this->row->viewDetailLink($year,$month,$day,false, $Itemid);

$rp_id  = intval($this->row->rp_id());
$atd_id = intval($this->rsvpdata->id);
$link   = "index.php?option=com_rsvppro&task=attendees.record&at_id=$atd_id&rp_id=$rp_id&Itemid=$Itemid";
if (Factory::getApplication()->input->getCmd("tmpl", "") == "component")
{
	$link .= "&tmpl=component";
}

// Do we need the email address security code?
if ($this->emailaddress != "")
{
	$code = base64_encode($this->emailaddress . ":" . md5($this->params->get("emailkey", "email key") . $this->emailaddress));
	$link = $link . "&em=" . $code;
}
$link       = Route::_($link, false);
$this->link = $link;

$db = Factory::getDBO();

// Until we incorporate registration deadline we stop registrations from the time the event starts
jimport('joomla.utilities.date');

if (!isset($this->templateInfo))
{
	$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);
	if (is_int($xmlfile) && $xmlfile > 0)
	{
		$db = Factory::getDbo();
		$db->setQuery("Select * from #__jev_rsvp_templates where id=" . intval($xmlfile));
		$this->templateInfo = $db->loadObject();
		if ($this->templateInfo)
		{
			$this->templateParams = $this->templateInfo->params;
			$this->templateParams = json_decode($this->templateParams);
		}
		else
		{
			$this->templateParams = false;
		}
	}
	else
	{
		$this->templateParams = false;
	}
}

// Must use strtotime format for force JevDate to not just parse the date itself!!!
$jnow = new JevDate("+1 second");
$now  = $jnow->toUnix();

// ALWAYS close this div before a return;
$html .= '<!-- attendee attendance form -->';
$html .= '<div id="templateid' . (isset($this->templateInfo) ? $this->templateInfo->id : 0) . '" >';

// Tell the user they are attending only if cancellation is not allowed and they are attending
if (!$this->rsvpdata->allowchanges && $this->attending && $this->attendee->attendstate == 1)
{
	$html .= $this->loadTemplate("youareattending");
}
else if (isset($this->attendee->attendstate) && $this->attendee->attendstate == 0)
{
	$html .= $this->loadTemplate("youarenotattending");
}
else if (isset($this->attendee->attendstate) && $this->attendee->attendstate == 2)
{
	$html .= $this->loadTemplate("youmaybeattending");
}
else if (isset($this->attendee->attendstate) && $this->attendee->attendstate == 3)
{
	$html .= $this->loadTemplate("awaitingconfirmation");
}
else if (isset($this->attendee->attendstate) && $this->attendee->attendstate == 4)
{
	$html .= $this->loadTemplate("awaitingpayment");
}
else if (($this->rsvpdata->allowcancellation || $this->rsvpdata->allowchanges) && $this->attending && ($this->attendee->attendstate == 1 || $this->attendee->attendstate == 4))
{
	if ($this->templateParams)
	{
		if (isset($this->templateParams->whentickets) && count($this->templateParams->whentickets) > 0 && ($this->rsvpdata->allowcancellation || $this->rsvpdata->allowchanges))
		{
			$html .= $this->loadTemplate("ticket");
		}
	}
}

// if we need the payment form or repayment form then display these instead.
if (Factory::getApplication()->input->getInt("paymentform", 0) == 1 || Factory::getApplication()->input->getInt("repaymentform", 0) == 1)
{
	if (isset($this->attendeeParams->outstandingBalances["feebalance"]) && floatval($this->attendeeParams->outstandingBalances["feebalance"]) != 0)
	{
		echo $html . $this->loadTemplate("emptyattendanceform") . "</div>";

		return;
	}
}

// We see if registrations are open
if ($now > $this->rsvpdata->adjustedregclose)
{
	echo $html . $this->loadTemplate("registrationsclosed") . $this->loadTemplate("emptyattendanceform") . "</div>";

	// We have  special case where cancellations are allowed AFTER the registration close date e.g. for event creators etc.
	if (!($this->attending && $this->attendee->attendstate == 1 && $this->canCancel))
	{
		return;
	}
}
else if ($now < $this->rsvpdata->adjustedregopen)
{
	echo $html . $this->loadTemplate("registrationsnotopen") . $this->loadTemplate("emptyattendanceform") . "</div>";

	return;
}

// if there is an intro to the form display it here:
$html .= $this->loadTemplate("intro");

// if tracking capacity find how many spaces are used up/left
if ($this->rsvpdata->withCapacity )
{
	if ($this->rsvpdata->capacity > 0)
	{
		if ($this->rsvpdata->attendeeCount >= $this->rsvpdata->capacity)
		{
			// I need the attendance form if I'm administering and attending the event otherwise I can't cancel attendees!
			if ($user->id == $this->row->created_by() || JEVHelper::isAdminUser($user) || $this->attending || JEVHelper::canDeleteEvent($this->row, $user))
			{
				$html .= $this->loadTemplate("eventfull");
			}
			else
			{
				$html .= $this->loadTemplate("eventfull");
				if ($this->rsvpdata->attendeeCount < $this->rsvpdata->capacity + $this->rsvpdata->waitingcapacity)
				{
					$html .= $this->loadTemplate("waitinglist");
				}
				else
				{
					if ($this->jomsocial && $html != "")
					{
						$html = '<div class="cModule jevattendform">' . $html . "</div>";
					}
					echo $html . $this->loadTemplate("emptyattendanceform") . "</div>";

					return;
				}
			}
		}
		else if ($this->params->get('show_atd_count_detail', 1))
		{
			$html .= $this->loadTemplate("capacityremaing");
		}
	}
	else
	{
		$html .= ($this->params->get('show_atd_count_detail', 1)) ? $this->loadTemplate("numberattending") : '';
	}
}

if ($this->rsvpdata->capacity && isset($this->attendee->atdcount) && $this->attendee->attendstate == 4 && ($this->rsvpdata->attendeeCount + $this->attendee->atdcount > $this->rsvpdata->capacity))
{
	// if counting unpaid capacity then we have already counted this attendee so doouble count it
	if (isset($this->templateParams->unpaidcapacity) && $this->templateParams->unpaidcapacity == 1)
	{
		if ($this->rsvpdata->attendeeCount > $this->rsvpdata->capacity)
		{
			Factory::getApplication()->enqueueMessage(Text::_("JEV_EVENT_FILLED_BEFORE_PAYMENT"), "notice");
			$html .= "</div>";

			return;
		}
	}
	else
	{
		Factory::getApplication()->enqueueMessage(Text::_("JEV_EVENT_FILLED_BEFORE_PAYMENT"), "notice");
		$html .= "</div>";

		return;
	}
}

if ($this->rsvpdata->allrepeats)
{
	$html .= $this->loadTemplate("attendanceform_single");
}
// or just this repeat
else if ($this->row->hasrepetition())
{
	$html .= $this->loadTemplate("attendanceform_repeating");
}

if ($this->jomsocial && $html != "")
{
	$intro = "";
	if ($this->rsvpdata->attendintro == "")
	{
		$intro = '<h3><span>' . Text::_('JEV_ATTEND_THIS_EVENT') . '</span></h3>';
	}
	$html = '<div class="cModule jevattendform">' . $intro . $html . "</div>";
}

echo $html;
?>
</div>
