<?php

defined('JPATH_BASE') or die('Direct Access to this location is not allowed.');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

HTMLHelper::stylesheet(  'components/com_rsvppro/assets/css/rsvpattend.css' );

$html = '<!-- attendee cancelform -->';
$user = Factory::getUser();

$Itemid = Factory::getApplication()->input->getInt("Itemid");
list($year, $month, $day) = JEVHelper::getYMD();
//$link = $this->row->viewDetailLink($year,$month,$day,false, $Itemid);
$rp_id = intval($this->row->rp_id());
$atd_id = intval($this->rsvpdata->id);
$link = "index.php?option=com_rsvppro&task=attendees.record&at_id=$atd_id&rp_id=$rp_id&Itemid=$Itemid";
if (Factory::getApplication()->input->getCmd("tmpl","")=="component"){
	$link .= "&tmpl=component";
}

// Do we need the email address security code?
if ($this->emailaddress != "")
{
	$code = base64_encode($this->emailaddress . ":" . md5($this->params->get("emailkey", "email key") . $this->emailaddress));
	$link = $link . "&em=" . $code;
}
$link = Route::_($link);

$db = Factory::getDBO();

// Until we incorporate registration deadline we stop registrations from the time the event starts
jimport('joomla.utilities.date');

// Must use strtotime format for force JevDate to not just parse the date itself!!!
$jnow = new JevDate("+1 second");
$now = $jnow->toUnix();

$feesAndBalances = isset($this->attendee->outstandingBalances) ? $this->attendee->outstandingBalances : false;

if (!isset($this->templateInfo )) {
	$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);
	if (is_int($xmlfile) &&  $xmlfile>0){
		$db = Factory::getDbo();
		$db->setQuery("Select * from #__jev_rsvp_templates where id=" . intval($xmlfile));
		$this->templateInfo = $db->loadObject();
		if ($this->templateInfo){
			$this->templateParams = $this->templateInfo->params;
			$this->templateParams = json_decode($this->templateParams);
		}
		else {
			$this->templateParams= false;
		}		
	}	
	else {
		$this->templateParams= false;
	}
}

// Always close this div efore a return!
$html .= '<div id="templateid'.(isset($this->templateInfo )?$this->templateInfo->id : 0).'">';

// Tell the user they are attending only if cancellation is not allows and they are attending
if (!$this->rsvpdata->allowcancellation && $this->attending && $this->attendee->attendstate == 1)
{
	$html .= $this->loadTemplate("youareattending");
	if ($feesAndBalances && isset($feesAndBalances["feebalance"]) && $feesAndBalances["feebalance"]>0)
	{
		$html .= $this->loadTemplate("awaitingpayment");
	}
}
else if (isset($this->attendee->attendstate) && $this->attendee->attendstate == 2)
{
	$html .= $this->loadTemplate("youmaybeattending");
}
else if (isset($this->attendee->attendstate) && $this->attendee->attendstate == 3)
{
	$html .= $this->loadTemplate("awaitingconfirmation");
	if ($feesAndBalances && isset($feesAndBalances["feebalance"]) && $feesAndBalances["feebalance"]>0)
	{
		$html .= $this->loadTemplate("awaitingpayment");
	}
}
else if (isset($this->attendee->attendstate) && $this->attendee->attendstate == 4)
{
	$html .= $this->loadTemplate("awaitingpayment");
}
else if (($this->rsvpdata->allowcancellation || $this->rsvpdata->allowchanges ) && $this->attending && ($this->attendee->attendstate == 1 || $this->attendee->attendstate == 4))
{
	if ($this->templateParams)
	{
		if (isset($this->templateParams->whentickets) && count($this->templateParams->whentickets) > 0)
		{
			$html .= $this->loadTemplate("ticket");
		}
	}
}

// We see if registrations are open and if we can cancel
if ($now > $this->rsvpdata->adjustedcancelclose)
{
	echo $html . $this->loadTemplate("registrationsclosed") . $this->loadTemplate("emptyattendanceform")."</div>";
	return;
}
else if ($now < $this->rsvpdata->adjustedregopen)
{
	echo $html . $this->loadTemplate("registrationsnotopen") . $this->loadTemplate("emptyattendanceform")."</div>";
	return;
}

// if there is an intro to the form display it here:
if ($this->rsvpdata->attendintro != "")
{
	$html .= $this->loadTemplate("intro");
}

// if tracking capacity find how many spaces are used up/left
if ($this->params->get("capacity",0) )
{
	$sql = "SELECT atdcount FROM #__jev_attendeecount as a WHERE a.at_id=" . $this->rsvpdata->id;
	if (!$this->rsvpdata->allrepeats)
	{
		$sql .= " and a.rp_id=" . $this->row->rp_id();
	}
	$db->setQuery($sql);
	$attendeeCount = intval( $db->loadResult());

	$unpaidWaitingList = "";
	if ($this->templateParams)
	{
		if (isset($this->templateParams->waitingnopay) && $this->templateParams->waitingnopay){
			$unpaidWaitingList = "  OR atdees.attendstate=4";
		}
	}
	
	$query = "SELECT sum(atdees.atdcount) as waitingcount "
		. "\n FROM #__jev_attendees AS atdees "
		. "WHERE atdees.at_id = " . intval($this->rsvpdata->id) ." AND atdees.waiting=1 AND atdees.confirmed=1 AND (atdees.attendstate=1 $unpaidWaitingList)"	;
	if (!$this->rsvpdata->allrepeats){
		$query .= " and atdees.rp_id=".$this->row->rp_id();
	}
	
	$db->setQuery( $query );
	$waitingCount = intval($db->loadResult());
	
	$this->rsvpdata->attendeeCount = $attendeeCount;
	$this->rsvpdata->waitingCount = $waitingCount;
	$this->rsvpdata->attendeeCountExWaiting = $attendeeCount - $waitingCount;
	$this->rsvpdata->attendeeCount = $attendeeCount;
	$this->waitingCount = $waitingCount;
	$this->rsvpdata->attendeeCountExWaiting =  $attendeeCount - $waitingCount;

	if ($this->rsvpdata->capacity > 0) {
		if ($attendeeCount >= $this->rsvpdata->capacity)
		{
			// I need the attendance form if I'm administering and attending the event otherwise I can't cancel attendees!
			if ($user->id == $this->row->created_by() || JEVHelper::isAdminUser($user) || $this->attending || JEVHelper::canDeleteEvent($this->row, $user))
			{
				$html .= $this->loadTemplate("eventfull");
			}
			else
			{
				$html .= $this->loadTemplate("eventfull");
				if ($attendeeCount < $this->rsvpdata->capacity + $this->rsvpdata->waitingcapacity)
				{
					$html .= $this->loadTemplate("waitinglist");
				}
				else
				{
					if ($this->jomsocial && $html != "")
					{
						$html = '<div class="cModule jevattendform">' . $html . "</div>";
					}
					echo $html . $this->loadTemplate("emptyattendanceform")."</div>";
					return;
				}
			}
		} else if($this->params->get('show_atd_count_detail', 1)) {
			$html .=  $this->loadTemplate("capacityremaing");
		}
	}
	else {
			$html .=  ($this->params->get('show_atd_count_detail', 1)) ? $this->loadTemplate("numberattending") : '';
	}
}
else {
	$this->rsvpdata->attendeeCount = 0;
	$this->rsvpdata->attendeeCount = 0;
}

if ($this->rsvpdata->capacity && isset($this->attendee->atdcount) && $this->attendee->attendstate == 4 && ($attendeeCount + $this->attendee->atdcount>$this->rsvpdata->capacity))
{
	// if counting unpaid capacity then we have already counted this attendee so doouble count it
	if (isset($this->templateParams->unpaidcapacity) && $this->templateParams->unpaidcapacity == 1){
		if ($attendeeCount>$this->rsvpdata->capacity){
			Factory::getApplication()->enqueueMessage(Text::_("JEV_EVENT_FILLED_BEFORE_PAYMENT"), "notice");
                        echo $html."</div>";
			return;
		}
	}
	else {
		Factory::getApplication()->enqueueMessage(Text::_("JEV_EVENT_FILLED_BEFORE_PAYMENT"), "notice");
                echo $html."</div>";
		return;
	}
}

if ($this->rsvpdata->allrepeats)
{
	$html .='<form action="' . $link . '"  method="post"  name="updateattendance" id="updateattendance"  enctype="multipart/form-data" >';
	$html .=  HTMLHelper::_('form.token');
	// if not logged in and allowing email based attendence then put in the input box
	$html .= '<table width="100%" class="paramlist admintable" cellspacing="1">';
	$html .= $this->loadTemplate("byemail");
	$html .= '</table>';


	// New parameterised fields
	$hasparams = false;
	if ($this->rsvpdata->template != "")
	{
		$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);
		if (is_int($xmlfile) || file_exists($xmlfile))
		{

			if (isset($this->attendee) && isset($this->attendee->params))
			{
				$params = new JevRsvpParameter($this->attendee->params, $xmlfile, $this->rsvpdata, $this->row);
				$feesAndBalances = $params->outstandingBalance($this->attendee);
			}
			else
			{
				$params = new JevRsvpParameter("", $xmlfile, $this->rsvpdata, $this->row);
			}

			$paramsarray = $params->renderToBasicArray('xmlfile', $this->attendee);
			if (count($paramsarray) > 0)
			{
				$html .= '<div id="registration-tab-pane" class="tab-page">';
				$html .= '<div class="tab-content">';

				// we have guests
				if ($this->attendee->guestcount > 0)
				{
					$html .= '<table class="attendeesummary" style="border:none;">';
					$html .= '<tr>';
					$html .= '<th />';
					$html .= '<th>' . Text::_('JEV_PRIMARY_ATTENDEE') . '</th>';
					for ($guest = 1; $guest < $this->attendee->guestcount; $guest++)
					{
						$html .= '<th>' . Text::sprintf("JEV_ATTENDEE_NUMBER", $guest + 1) . '</th>';
					}
					$html .= '</tr>';
					foreach ($paramsarray as $param)
					{
						if ($param['formonly'] || !$param['showindetail'] || !$param["accessible"])
						{
							continue;
						}
						if ($param['peruser'] == 2 && $this->attendee->guestcount <= 1)
							continue;

						// if group conditional then skip altogether
						if ($param['peruser'] == 0 && isset($param['conditionalfield']) && $param['conditionalfield'] != "")
						{
							if (isset($paramsarray[$param['conditionalfield']]) && $paramsarray[$param['conditionalfield']]['rawvalue'] != $param['conditionalfieldvalue'])
							{
								continue;
							}
						}
						// if not group conditional but no matches then skip too
						if ($param['peruser'] > 0 && isset($param['conditionalfield']) && $param['conditionalfield'] != "")
						{
							if (isset($paramsarray[$param['conditionalfield']]))
							{
								if (is_array($paramsarray[$param['conditionalfield']]['rawvalue']))
								{
									$showany = false;
									foreach ($paramsarray[$param['conditionalfield']]['rawvalue'] as $rawvalue)
									{
										if ($rawvalue == $param['conditionalfieldvalue'])
										{
											$showany = true;
										}
									}
									if (!$showany)
									{
										continue;
									}
								}
								else if ($paramsarray[$param['conditionalfield']]['rawvalue'] != $param['conditionalfieldvalue'])
								{
									continue;
								}
							}
						}

                                                $class= isset($param['classname']) ? "class='".$param['classname']."'" : "";
                                                $html .= "<tr $class> ";
						$html .='<td class="rsvpoptionlabel">' . Text::_($param['label']) . ' : </td>';
						if (!isset($param['peruser']) || $param['peruser'] <= 0)
						{
							$val = $param['value'];
							if (is_array($val))
							{
								$val = implode(",", $val);
							}
							$val = stripslashes($val);
							$html .='<td class="rsvpgroupoptionvalue" colspan="' . $this->attendee->guestcount . '">' . $val . '</td>';
						}
						else
						{
							// fix non-array values
							// TODO find why this is happening on pistol site
							if (!is_array($param['value']) && $this->attendee->guestcount==1){
								$param['value'] = array($param['value']);
							}

							if (is_array($param['value']) && count($param['value']) == $this->attendee->guestcount)
							{
								for ($guest = 0; $guest < $this->attendee->guestcount; $guest++)
								{
									if ($param['peruser'] == 2 && $guest == 0)
									{
										$html .='<td class="rsvpnaoption"></td>';
									}
									else
									{
										$val = $param['value'][$guest];
										if (is_array($val))
										{
											$val = implode(",", $val);
										}
										$val = stripslashes($val);

										// should we skip this output because its a conditional field
										if (isset($param['conditionalfield']) && $param['conditionalfield'] != "" && isset($paramsarray[$param['conditionalfield']]))
										{
											if (is_array($paramsarray[$param['conditionalfield']]['rawvalue']))
											{
												if (isset($paramsarray[$param['conditionalfield']]['rawvalue'][$guest]) && $paramsarray[$param['conditionalfield']]['rawvalue'][$guest] != $param['conditionalfieldvalue'])
												{
													$val = "";
												}
											}
											else if ($paramsarray[$param['conditionalfield']]['rawvalue'] != $param['conditionalfieldvalue'])
											{
												$val = "";
											}
										}

										$html .='<td class="rsvpuseroptionvalue">' . $val . '</td>';
									}
								}
							}
							else
							{
								// WE HAVE A PROBLEM
								$html .='<td class="rsvpproblemvalue" colspan="' . $this->attendee->guestcount . '">' . Text::_('JEV_PROBLEM_CONTACT_ORGANISER') . '</td>';
							}
						}
						$html .= "</tr>";
					}

					$html .= '</table>';
				}
				// its just the one!
				else
				{
					foreach ($paramsarray as $param)
					{
						if ($param['formonly'])
						{
							continue;
						}
						// if group conditional then skip altogether
						if ($param['peruser'] == 0 && isset($param['conditionalfield']) && $param['conditionalfield'] != "")
						{
							if (isset($paramsarray[$param['conditionalfield']]) && $paramsarray[$param['conditionalfield']]['rawvalue'] != $param['conditionalfieldvalue'])
							{
								continue;
							}
						}

						$html .='<span class="rsvpoptionlabel">' . stripslashes(RsvpHelper::translate($param['label'])) . ' : </span>';
						if (is_array($param['value']))
						{
							$values = $param['value'];
							$html .='<span class="rsvpoptionvalue">' . stripslashes(implode(",", $values)) . '</span>';
						}
						else
						{
							$html .='<span class="rsvpoptionvalue">' . stripslashes($param['value']) . '</span>';
						}
						$html .= "<br/>";
					}
				}
				$html .= '</div>';
				$html .= '</div>';
			}
		}
	}

    $attendstate = $this->params->get("defaultattendstate", -1);

	if ($hasparams)
	{
		$this->attendstate = $attendstate;
		$cancelbutton = $this->loadTemplate("attendanceform_cancelbutton");
		if ($cancelbutton == "")
		{
			return "";
		}
		else
		{
			$html .= $cancelbutton;
		}
		$html .='<input type="hidden" name="Itemid"  value="' .  Factory::getApplication()->input->getInt("Itemid" ,1) . '" />';
		$html .='</form>';
	}
	else
	{
		if (isset($this->attendee->attendstate))
			$attendstate = $this->attendee->attendstate;
		$initialstate = $this->rsvpdata->initialstate ? 1 : 3;

		// if subject to payment then must be a yes!
		if ($attendstate == 4)
		{
			$attendstate = 1;
		}

		$this->attendstate = $attendstate;
		$cancelbutton = $this->loadTemplate("attendanceform_cancelbutton");
		if ($cancelbutton == "")
		{
			return "";
		}
		else
		{
			$html .= $cancelbutton;
		}
		$html .='<input type="hidden" name="Itemid"  value="' .  Factory::getApplication()->input->getInt("Itemid" ,1) . '" />';
		$html .='</form>';
	}
}
// or just this repeat
else if ($this->row->hasrepetition())
{
	$html.='<form action="' . $link . '"  method="post"  name="updateattendance" id="updateattendance"  enctype="multipart/form-data" >';
$html .=  HTMLHelper::_('form.token');
	// if not logged in and allowing email based attendence then put in the input box
	$html .= $this->loadTemplate("byemail");

	// New parameterised fields
	$hasparams = false;
	if ($this->rsvpdata->template != "")
	{
		$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);
		if (is_int($xmlfile) || file_exists($xmlfile))
		{
			if (isset($this->attendee) && isset($this->attendee->params))
			{
				$params = new JevRsvpParameter($this->attendee->params, $xmlfile, $this->rsvpdata, $this->row);
			}
			else
			{
				$params = new JevRsvpParameter("", $xmlfile, $this->rsvpdata, $this->row);
			}

			$paramsarray = $params->renderToBasicArray('xmlfile', $this->attendee);
			if (count($paramsarray) > 0)
			{
				$html .= '<div id="registration-tab-pane" class="tab-page">';
				$html .= '<div class="tab-content">';

				// we have guests
				if ($this->attendee->guestcount > 0)
				{
					$html .= '<table class="attendeesummary" style="border:none;">';
					$html .= '<tr>';
					$html .= '<th />';
					$html .= '<th>' . Text::_('JEV_PRIMARY_ATTENDEE') . '</th>';
					for ($guest = 1; $guest < $this->attendee->guestcount; $guest++)
					{
						$html .= '<th>' . Text::sprintf("JEV_ATTENDEE_NUMBER", $guest + 1) . '</th>';
					}
					$html .= '</tr>';
					foreach ($paramsarray as $param)
					{
						if ($param['formonly'] || !$param['showindetail'] || !$param["accessible"])
						{
							continue;
						}
						if ($param['peruser'] == 2 && $this->attendee->guestcount <= 1)
							continue;

						// if group conditional then skip altogether
						if ($param['peruser'] == 0 && isset($param['conditionalfield']) && $param['conditionalfield'] != "")
						{
							if (isset($paramsarray[$param['conditionalfield']]) && $paramsarray[$param['conditionalfield']]['rawvalue'] != $param['conditionalfieldvalue'])
							{
								continue;
							}
						}
						// if not group conditional but no matches then skip too
						if ($param['peruser'] > 0 && isset($param['conditionalfield']) && $param['conditionalfield'] != "")
						{
							if (isset($paramsarray[$param['conditionalfield']]))
							{
								if (is_array($paramsarray[$param['conditionalfield']]['rawvalue']))
								{
									$showany = false;
									foreach ($paramsarray[$param['conditionalfield']]['rawvalue'] as $rawvalue)
									{
										if ($rawvalue == $param['conditionalfieldvalue'])
										{
											$showany = true;
										}
									}
									if (!$showany)
									{
										continue;
									}
								}
								else if ($paramsarray[$param['conditionalfield']]['rawvalue'] != $param['conditionalfieldvalue'])
								{
									continue;
								}
							}
						}

                                                $class= isset($param['classname']) ? "class='".$param['classname']."'" : "";
                                                $html .= "<tr $class> ";
						$html .='<td class="rsvpoptionlabel">' . RsvpHelper::translate($param['label']) . ' : </td>';
						if (!isset($param['peruser']) || $param['peruser'] <= 0)
						{
							$val = is_array($param['value']) ? implode (", ",$param['value']):$param['value'];
							$html .='<td class="rsvpgroupoptionvalue" colspan="' . $this->attendee->guestcount . '">' . $val . '</td>';
						}
						else
						{
							// fix non-array values
							// TODO find why this is happening on pistol site
							if (!is_array($param['value']) && $this->attendee->guestcount==1){
								$param['value'] = array($param['value']);
							}
							if (is_array($param['value']) && count($param['value']) == $this->attendee->guestcount)
							{
								for ($guest = 0; $guest < $this->attendee->guestcount; $guest++)
								{
									if ($param['peruser'] == 2 && $guest == 0)
									{
										$html .='<td class="rsvpnaoption"></td>';
									}
									else
									{
										$val = $param['value'][$guest];
										if (is_array($val))
										{
											$val = implode(",", $val);
										}
										$val = stripslashes($val);

										// should we skip this output because its a conditional field
										if (isset($param['conditionalfield']) && $param['conditionalfield'] != "" && isset($paramsarray[$param['conditionalfield']]))
										{
											if (is_array($paramsarray[$param['conditionalfield']]['rawvalue']))
											{
												if (isset($paramsarray[$param['conditionalfield']]['rawvalue'][$guest]) && $paramsarray[$param['conditionalfield']]['rawvalue'][$guest] != $param['conditionalfieldvalue'])
												{
													$val = "";
												}
											}
											else if ($paramsarray[$param['conditionalfield']]['rawvalue'] != $param['conditionalfieldvalue'])
											{
												$val = "";
											}
										}

										$html .='<td class="rsvpuseroptionvalue">' . $val . '</td>';
									}
								}
							}
							else
							{
								// WE HAVE A PROBLEM
								$html .='<td class="rsvpproblemvalue" colspan="' . $this->attendee->guestcount . '">' . Text::_('JEV_PROBLEM_CONTACT_ORGANISER') . '</td>';
							}
						}
						$html .= "</tr>";
					}

					$html .= '</table>';
				}
				// its just the one!
				else
				{
					foreach ($paramsarray as $param)
					{
						if ($param['formonly'])
						{
							continue;
						}
						
						// if group conditional then skip altogether
						if ($param['peruser'] == 0 && isset($param['conditionalfield']) && $param['conditionalfield'] != "")
						{
							if (isset($paramsarray[$param['conditionalfield']]) && $paramsarray[$param['conditionalfield']]['rawvalue'] != $param['conditionalfieldvalue'])
							{
								continue;
							}
						}

						
						$html .='<span class="rsvpoptionlabel">' . RsvpHelper::translate($param['label']) . ' : </span>';
						if (is_array($param['value']))
						{
							$values = $param['value'];
							$html .='<span class="rsvpoptionvalue">' . implode(",", $values) . '</span>';
						}
						else
						{
							$html .='<span class="rsvpoptionvalue">' . $param['value'] . '</span>';
						}
						$html .= "<br/>";
					}
				}
				$html .= '</div>';
				$html .= '</div>';
			}
		}
	}

    $attendstate = $this->params->get("defaultattendstate", -1);

    if ($hasparams)
	{
		$this->attendstate = $attendstate;
		$cancelbutton = $this->loadTemplate("attendanceform_cancelbutton");
		if ($cancelbutton == "")
		{
			return "";
		}
		else
		{
			$html .= $cancelbutton;
		}
		$html .='<input type="hidden" name="Itemid"  value="' .  Factory::getApplication()->input->getInt("Itemid" ,1) . '" />';
		$html .='</form>';
	}
	else
	{
		if (isset($this->attendee->attendstate))
			$attendstate = $this->attendee->attendstate;
		$initialstate = $this->rsvpdata->initialstate ? 1 : 3;

		// if subject to payment then must be a yes!
		if ($attendstate == 4)
		{
			$attendstate = 1;
		}
		
		$this->attendstate = $attendstate;
		$cancelbutton = $this->loadTemplate("attendanceform_cancelbutton");
		if ($cancelbutton == "")
		{
			return "";
		}
		else
		{
			$html .= $cancelbutton;
		}
		$html .='<input type="hidden" name="Itemid"  value="' .  Factory::getApplication()->input->getInt("Itemid" ,1) . '" />';
		$html .='</form>';
	}
}

if ($this->jomsocial && $html != "")
{
	$html = '<div class="cModule jevattendform"><h3><span>' . Text::_('JEV_ATTEND_THIS_EVENT') . '</span></h3>' . $html . "</div>";
}

echo $html."</div>";
